#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 476
#define LARGE_STATE_COUNT 179
#define SYMBOL_COUNT 98
#define ALIAS_COUNT 0
#define TOKEN_COUNT 50
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 14
#define MAX_ALIAS_SEQUENCE_LENGTH 7

enum {
  sym_symbol = 1,
  sym_line_comment = 2,
  anon_sym_LPAREN = 3,
  anon_sym_RPAREN = 4,
  anon_sym_LBRACK = 5,
  anon_sym_RBRACK = 6,
  anon_sym_AT_LPAREN = 7,
  anon_sym_AT_LBRACK = 8,
  anon_sym_LBRACE = 9,
  anon_sym_RBRACE = 10,
  anon_sym_AT_LBRACE = 11,
  anon_sym_def = 12,
  anon_sym_var = 13,
  anon_sym_quote = 14,
  anon_sym_splice = 15,
  anon_sym_quasiquote = 16,
  anon_sym_unquote = 17,
  anon_sym_break = 18,
  anon_sym_set = 19,
  anon_sym_if = 20,
  anon_sym_do = 21,
  anon_sym_while = 22,
  anon_sym_fn = 23,
  anon_sym_SQUOTE = 24,
  anon_sym_SEMI = 25,
  anon_sym_TILDE = 26,
  anon_sym_COMMA = 27,
  anon_sym_PIPE = 28,
  anon_sym_defn = 29,
  anon_sym_defn_DASH = 30,
  anon_sym_varfn = 31,
  anon_sym_varfn_DASH = 32,
  anon_sym_defmacro = 33,
  anon_sym_defmacro_DASH = 34,
  sym_str_literal = 35,
  sym_buffer_literal = 36,
  aux_sym_number_literal_token1 = 37,
  aux_sym_number_literal_token2 = 38,
  aux_sym_number_literal_token3 = 39,
  anon_sym_true = 40,
  anon_sym_false = 41,
  sym_nil_literal = 42,
  aux_sym_escape_sequence_token1 = 43,
  aux_sym_escape_sequence_token2 = 44,
  aux_sym_escape_sequence_token3 = 45,
  aux_sym_escape_sequence_token4 = 46,
  sym_keyword = 47,
  sym__long_str = 48,
  sym__long_buffer = 49,
  sym_source_file = 50,
  sym__expr = 51,
  sym_tuple = 52,
  sym_sqr_tuple = 53,
  sym_array = 54,
  sym_sqr_array = 55,
  sym_struct = 56,
  sym_table = 57,
  sym__struct_tables_commom = 58,
  sym__special_forms = 59,
  sym_def = 60,
  sym_var = 61,
  sym_quote = 62,
  sym_splice = 63,
  sym_quasiquote = 64,
  sym_unquote = 65,
  sym_break = 66,
  sym_set = 67,
  sym_if = 68,
  sym_do = 69,
  sym_while = 70,
  sym_fn = 71,
  sym__parameters = 72,
  sym_parameters = 73,
  sym_tuple_parameters = 74,
  sym__shorthand = 75,
  sym_short_quote = 76,
  sym_short_splice = 77,
  sym_short_quasiquote = 78,
  sym_short_unquote = 79,
  sym_short_fn = 80,
  sym__specials = 81,
  sym_extra_defs = 82,
  sym__literals = 83,
  sym_long_str_literal = 84,
  sym_long_buffer_literal = 85,
  sym_number_literal = 86,
  sym_bool_literal = 87,
  sym_metadata = 88,
  sym__name = 89,
  sym_body = 90,
  sym__identifier = 91,
  aux_sym_source_file_repeat1 = 92,
  aux_sym_tuple_repeat1 = 93,
  aux_sym_struct_repeat1 = 94,
  aux_sym_def_repeat1 = 95,
  aux_sym_while_repeat1 = 96,
  aux_sym_parameters_repeat1 = 97,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_symbol] = "symbol",
  [sym_line_comment] = "line_comment",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_AT_LPAREN] = "@(",
  [anon_sym_AT_LBRACK] = "@[",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_AT_LBRACE] = "@{",
  [anon_sym_def] = "def",
  [anon_sym_var] = "var",
  [anon_sym_quote] = "quote",
  [anon_sym_splice] = "splice",
  [anon_sym_quasiquote] = "quasiquote",
  [anon_sym_unquote] = "unquote",
  [anon_sym_break] = "break",
  [anon_sym_set] = "set",
  [anon_sym_if] = "if",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_fn] = "fn",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_SEMI] = ";",
  [anon_sym_TILDE] = "~",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_defn] = "defn",
  [anon_sym_defn_DASH] = "defn-",
  [anon_sym_varfn] = "varfn",
  [anon_sym_varfn_DASH] = "varfn-",
  [anon_sym_defmacro] = "defmacro",
  [anon_sym_defmacro_DASH] = "defmacro-",
  [sym_str_literal] = "str_literal",
  [sym_buffer_literal] = "buffer_literal",
  [aux_sym_number_literal_token1] = "number_literal_token1",
  [aux_sym_number_literal_token2] = "number_literal_token2",
  [aux_sym_number_literal_token3] = "number_literal_token3",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_nil_literal] = "nil_literal",
  [aux_sym_escape_sequence_token1] = "escape_sequence_token1",
  [aux_sym_escape_sequence_token2] = "escape_sequence_token2",
  [aux_sym_escape_sequence_token3] = "escape_sequence_token3",
  [aux_sym_escape_sequence_token4] = "escape_sequence_token4",
  [sym_keyword] = "keyword",
  [sym__long_str] = "_long_str",
  [sym__long_buffer] = "_long_buffer",
  [sym_source_file] = "source_file",
  [sym__expr] = "_expr",
  [sym_tuple] = "tuple",
  [sym_sqr_tuple] = "sqr_tuple",
  [sym_array] = "array",
  [sym_sqr_array] = "sqr_array",
  [sym_struct] = "struct",
  [sym_table] = "table",
  [sym__struct_tables_commom] = "_struct_tables_commom",
  [sym__special_forms] = "_special_forms",
  [sym_def] = "def",
  [sym_var] = "var",
  [sym_quote] = "quote",
  [sym_splice] = "splice",
  [sym_quasiquote] = "quasiquote",
  [sym_unquote] = "unquote",
  [sym_break] = "break",
  [sym_set] = "set",
  [sym_if] = "if",
  [sym_do] = "do",
  [sym_while] = "while",
  [sym_fn] = "fn",
  [sym__parameters] = "_parameters",
  [sym_parameters] = "parameters",
  [sym_tuple_parameters] = "tuple_parameters",
  [sym__shorthand] = "_shorthand",
  [sym_short_quote] = "short_quote",
  [sym_short_splice] = "short_splice",
  [sym_short_quasiquote] = "short_quasiquote",
  [sym_short_unquote] = "short_unquote",
  [sym_short_fn] = "short_fn",
  [sym__specials] = "_specials",
  [sym_extra_defs] = "extra_defs",
  [sym__literals] = "_literals",
  [sym_long_str_literal] = "long_str_literal",
  [sym_long_buffer_literal] = "long_buffer_literal",
  [sym_number_literal] = "number_literal",
  [sym_bool_literal] = "bool_literal",
  [sym_metadata] = "metadata",
  [sym__name] = "_name",
  [sym_body] = "body",
  [sym__identifier] = "_identifier",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym_struct_repeat1] = "struct_repeat1",
  [aux_sym_def_repeat1] = "def_repeat1",
  [aux_sym_while_repeat1] = "while_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_symbol] = sym_symbol,
  [sym_line_comment] = sym_line_comment,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_AT_LPAREN] = anon_sym_AT_LPAREN,
  [anon_sym_AT_LBRACK] = anon_sym_AT_LBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_AT_LBRACE] = anon_sym_AT_LBRACE,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_quote] = anon_sym_quote,
  [anon_sym_splice] = anon_sym_splice,
  [anon_sym_quasiquote] = anon_sym_quasiquote,
  [anon_sym_unquote] = anon_sym_unquote,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_defn] = anon_sym_defn,
  [anon_sym_defn_DASH] = anon_sym_defn_DASH,
  [anon_sym_varfn] = anon_sym_varfn,
  [anon_sym_varfn_DASH] = anon_sym_varfn_DASH,
  [anon_sym_defmacro] = anon_sym_defmacro,
  [anon_sym_defmacro_DASH] = anon_sym_defmacro_DASH,
  [sym_str_literal] = sym_str_literal,
  [sym_buffer_literal] = sym_buffer_literal,
  [aux_sym_number_literal_token1] = aux_sym_number_literal_token1,
  [aux_sym_number_literal_token2] = aux_sym_number_literal_token2,
  [aux_sym_number_literal_token3] = aux_sym_number_literal_token3,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_nil_literal] = sym_nil_literal,
  [aux_sym_escape_sequence_token1] = aux_sym_escape_sequence_token1,
  [aux_sym_escape_sequence_token2] = aux_sym_escape_sequence_token2,
  [aux_sym_escape_sequence_token3] = aux_sym_escape_sequence_token3,
  [aux_sym_escape_sequence_token4] = aux_sym_escape_sequence_token4,
  [sym_keyword] = sym_keyword,
  [sym__long_str] = sym__long_str,
  [sym__long_buffer] = sym__long_buffer,
  [sym_source_file] = sym_source_file,
  [sym__expr] = sym__expr,
  [sym_tuple] = sym_tuple,
  [sym_sqr_tuple] = sym_sqr_tuple,
  [sym_array] = sym_array,
  [sym_sqr_array] = sym_sqr_array,
  [sym_struct] = sym_struct,
  [sym_table] = sym_table,
  [sym__struct_tables_commom] = sym__struct_tables_commom,
  [sym__special_forms] = sym__special_forms,
  [sym_def] = sym_def,
  [sym_var] = sym_var,
  [sym_quote] = sym_quote,
  [sym_splice] = sym_splice,
  [sym_quasiquote] = sym_quasiquote,
  [sym_unquote] = sym_unquote,
  [sym_break] = sym_break,
  [sym_set] = sym_set,
  [sym_if] = sym_if,
  [sym_do] = sym_do,
  [sym_while] = sym_while,
  [sym_fn] = sym_fn,
  [sym__parameters] = sym__parameters,
  [sym_parameters] = sym_parameters,
  [sym_tuple_parameters] = sym_tuple_parameters,
  [sym__shorthand] = sym__shorthand,
  [sym_short_quote] = sym_short_quote,
  [sym_short_splice] = sym_short_splice,
  [sym_short_quasiquote] = sym_short_quasiquote,
  [sym_short_unquote] = sym_short_unquote,
  [sym_short_fn] = sym_short_fn,
  [sym__specials] = sym__specials,
  [sym_extra_defs] = sym_extra_defs,
  [sym__literals] = sym__literals,
  [sym_long_str_literal] = sym_long_str_literal,
  [sym_long_buffer_literal] = sym_long_buffer_literal,
  [sym_number_literal] = sym_number_literal,
  [sym_bool_literal] = sym_bool_literal,
  [sym_metadata] = sym_metadata,
  [sym__name] = sym__name,
  [sym_body] = sym_body,
  [sym__identifier] = sym__identifier,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_tuple_repeat1] = aux_sym_tuple_repeat1,
  [aux_sym_struct_repeat1] = aux_sym_struct_repeat1,
  [aux_sym_def_repeat1] = aux_sym_def_repeat1,
  [aux_sym_while_repeat1] = aux_sym_while_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_splice] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_quasiquote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unquote] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defn_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varfn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_varfn_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmacro] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defmacro_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_str_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_buffer_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_number_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_number_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_nil_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_escape_sequence_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_escape_sequence_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_escape_sequence_token3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_escape_sequence_token4] = {
    .visible = false,
    .named = false,
  },
  [sym_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym__long_str] = {
    .visible = false,
    .named = true,
  },
  [sym__long_buffer] = {
    .visible = false,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__expr] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_sqr_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_sqr_array] = {
    .visible = true,
    .named = true,
  },
  [sym_struct] = {
    .visible = true,
    .named = true,
  },
  [sym_table] = {
    .visible = true,
    .named = true,
  },
  [sym__struct_tables_commom] = {
    .visible = false,
    .named = true,
  },
  [sym__special_forms] = {
    .visible = false,
    .named = true,
  },
  [sym_def] = {
    .visible = true,
    .named = true,
  },
  [sym_var] = {
    .visible = true,
    .named = true,
  },
  [sym_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [sym_unquote] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_fn] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__shorthand] = {
    .visible = false,
    .named = true,
  },
  [sym_short_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_splice] = {
    .visible = true,
    .named = true,
  },
  [sym_short_quasiquote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_unquote] = {
    .visible = true,
    .named = true,
  },
  [sym_short_fn] = {
    .visible = true,
    .named = true,
  },
  [sym__specials] = {
    .visible = false,
    .named = true,
  },
  [sym_extra_defs] = {
    .visible = true,
    .named = true,
  },
  [sym__literals] = {
    .visible = false,
    .named = true,
  },
  [sym_long_str_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_long_buffer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_number_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_bool_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_metadata] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym_body] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_def_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_body = 1,
  field_condition = 2,
  field_else = 3,
  field_form = 4,
  field_item = 5,
  field_key = 6,
  field_l_value = 7,
  field_metadata = 8,
  field_name = 9,
  field_parameter = 10,
  field_parameters = 11,
  field_r_value = 12,
  field_then = 13,
  field_value = 14,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_body] = "body",
  [field_condition] = "condition",
  [field_else] = "else",
  [field_form] = "form",
  [field_item] = "item",
  [field_key] = "key",
  [field_l_value] = "l_value",
  [field_metadata] = "metadata",
  [field_name] = "name",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_r_value] = "r_value",
  [field_then] = "then",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[32] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 1},
  [4] = {.index = 4, .length = 1},
  [5] = {.index = 5, .length = 1},
  [6] = {.index = 6, .length = 1},
  [7] = {.index = 7, .length = 2},
  [8] = {.index = 9, .length = 2},
  [9] = {.index = 11, .length = 2},
  [10] = {.index = 13, .length = 4},
  [11] = {.index = 17, .length = 1},
  [12] = {.index = 18, .length = 1},
  [13] = {.index = 19, .length = 1},
  [14] = {.index = 20, .length = 2},
  [15] = {.index = 22, .length = 1},
  [16] = {.index = 23, .length = 1},
  [17] = {.index = 24, .length = 1},
  [18] = {.index = 25, .length = 2},
  [19] = {.index = 27, .length = 2},
  [20] = {.index = 29, .length = 2},
  [21] = {.index = 31, .length = 2},
  [22] = {.index = 33, .length = 2},
  [23] = {.index = 35, .length = 1},
  [24] = {.index = 36, .length = 2},
  [25] = {.index = 38, .length = 2},
  [26] = {.index = 40, .length = 2},
  [27] = {.index = 42, .length = 3},
  [28] = {.index = 45, .length = 3},
  [29] = {.index = 48, .length = 3},
  [30] = {.index = 51, .length = 3},
  [31] = {.index = 54, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_item, 0},
  [1] =
    {field_key, 0, .inherited = true},
    {field_value, 0, .inherited = true},
  [3] =
    {field_body, 1},
  [4] =
    {field_form, 0},
  [5] =
    {field_form, 0, .inherited = true},
  [6] =
    {field_item, 1, .inherited = true},
  [7] =
    {field_item, 0, .inherited = true},
    {field_item, 1, .inherited = true},
  [9] =
    {field_key, 0},
    {field_value, 1},
  [11] =
    {field_key, 1, .inherited = true},
    {field_value, 1, .inherited = true},
  [13] =
    {field_key, 0, .inherited = true},
    {field_key, 1, .inherited = true},
    {field_value, 0, .inherited = true},
    {field_value, 1, .inherited = true},
  [17] =
    {field_metadata, 0},
  [18] =
    {field_l_value, 2},
  [19] =
    {field_body, 2},
  [20] =
    {field_form, 0, .inherited = true},
    {field_form, 1, .inherited = true},
  [22] =
    {field_condition, 2},
  [23] =
    {field_parameter, 0},
  [24] =
    {field_parameters, 2},
  [25] =
    {field_name, 2},
    {field_value, 3},
  [27] =
    {field_metadata, 0, .inherited = true},
    {field_metadata, 1, .inherited = true},
  [29] =
    {field_l_value, 2},
    {field_r_value, 3},
  [31] =
    {field_condition, 2},
    {field_then, 3},
  [33] =
    {field_condition, 2},
    {field_form, 3, .inherited = true},
  [35] =
    {field_parameter, 1, .inherited = true},
  [36] =
    {field_parameter, 0, .inherited = true},
    {field_parameter, 1, .inherited = true},
  [38] =
    {field_body, 3},
    {field_parameters, 2},
  [40] =
    {field_name, 2},
    {field_parameters, 3},
  [42] =
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_value, 4},
  [45] =
    {field_condition, 2},
    {field_else, 4},
    {field_then, 3},
  [48] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [51] =
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
  [54] =
    {field_body, 5},
    {field_metadata, 3, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
};

static TSSymbol ts_alias_sequences[32][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(21);
      if (lookahead == '"') ADVANCE(2);
      if (lookahead == '#') ADVANCE(22);
      if (lookahead == '\'') ADVANCE(33);
      if (lookahead == '(') ADVANCE(24);
      if (lookahead == ')') ADVANCE(25);
      if (lookahead == ',') ADVANCE(36);
      if (lookahead == '.') ADVANCE(68);
      if (lookahead == '0') ADVANCE(40);
      if (lookahead == ':') ADVANCE(57);
      if (lookahead == ';') ADVANCE(34);
      if (lookahead == '@') ADVANCE(58);
      if (lookahead == '[') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == ']') ADVANCE(27);
      if (lookahead == '{') ADVANCE(30);
      if (lookahead == '|') ADVANCE(37);
      if (lookahead == '}') ADVANCE(31);
      if (lookahead == '~') ADVANCE(35);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(41);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(78);
      END_STATE();
    case 1:
      if (lookahead == '"') ADVANCE(2);
      if (lookahead == '#') ADVANCE(22);
      if (lookahead == '\'') ADVANCE(33);
      if (lookahead == '(') ADVANCE(24);
      if (lookahead == ',') ADVANCE(36);
      if (lookahead == ':') ADVANCE(57);
      if (lookahead == ';') ADVANCE(34);
      if (lookahead == '[') ADVANCE(26);
      if (lookahead == '~') ADVANCE(35);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead)) ADVANCE(78);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(38);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead != 0) ADVANCE(2);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(39);
      if (lookahead == '\\') ADVANCE(5);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 4:
      if (lookahead == 'u') ADVANCE(6);
      if (lookahead == 'x') ADVANCE(17);
      if (lookahead != 0) ADVANCE(2);
      END_STATE();
    case 5:
      if (lookahead == 'u') ADVANCE(7);
      if (lookahead == 'x') ADVANCE(18);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 6:
      if (lookahead == '{') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(12);
      END_STATE();
    case 7:
      if (lookahead == '{') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(19);
      END_STATE();
    case 8:
      if (lookahead == '}') ADVANCE(2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(8);
      END_STATE();
    case 9:
      if (lookahead == '}') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 10:
      if (lookahead == '}') ADVANCE(3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 11:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(2);
      END_STATE();
    case 12:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(17);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(9);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(3);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(8);
      END_STATE();
    case 16:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(10);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(11);
      END_STATE();
    case 18:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(14);
      END_STATE();
    case 19:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(18);
      END_STATE();
    case 20:
      if (eof) ADVANCE(21);
      if (lookahead == '"') ADVANCE(2);
      if (lookahead == '#') ADVANCE(22);
      if (lookahead == '\'') ADVANCE(33);
      if (lookahead == '(') ADVANCE(24);
      if (lookahead == ')') ADVANCE(25);
      if (lookahead == ',') ADVANCE(36);
      if (lookahead == '.') ADVANCE(68);
      if (lookahead == '0') ADVANCE(40);
      if (lookahead == ':') ADVANCE(57);
      if (lookahead == ';') ADVANCE(34);
      if (lookahead == '@') ADVANCE(58);
      if (lookahead == '[') ADVANCE(26);
      if (lookahead == ']') ADVANCE(27);
      if (lookahead == '{') ADVANCE(30);
      if (lookahead == '|') ADVANCE(37);
      if (lookahead == '}') ADVANCE(31);
      if (lookahead == '~') ADVANCE(35);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(59);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(20)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(41);
      if (lookahead != 0 &&
          lookahead != '`') ADVANCE(78);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('\'' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(23);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(22);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(23);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_AT_LPAREN);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_AT_LBRACK);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_AT_LBRACE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_str_literal);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_buffer_literal);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(44);
      if (lookahead == '_') ADVANCE(43);
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == 'x') ADVANCE(61);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(42);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(44);
      if (lookahead == '_') ADVANCE(43);
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(42);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(44);
      if (lookahead == 'r') ADVANCE(60);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(43);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '.') ADVANCE(44);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(43);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (lookahead == '&' ||
          lookahead == 'E' ||
          lookahead == 'e') ADVANCE(64);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(44);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(aux_sym_number_literal_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '&') ADVANCE(66);
      if (lookahead == '.') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (lookahead == '&') ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(aux_sym_number_literal_token2);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (lookahead == '&') ADVANCE(65);
      if (lookahead == '.') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(49);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          (lookahead < '`' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (lookahead == '&') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(50);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          (lookahead < '`' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(aux_sym_number_literal_token3);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(51);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          (lookahead < '`' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token1);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token1);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token2);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token3);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(aux_sym_escape_sequence_token4);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(sym_keyword);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(57);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '"') ADVANCE(3);
      if (lookahead == '(') ADVANCE(28);
      if (lookahead == '[') ADVANCE(29);
      if (lookahead == '{') ADVANCE(32);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(68);
      if (lookahead == '0') ADVANCE(40);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(41);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(76);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(49);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          (lookahead < '`' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '.') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == 'u') ADVANCE(63);
      if (lookahead == 'x') ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '"' ||
          ('\'' <= lookahead && lookahead <= ')') ||
          lookahead == ',' ||
          lookahead == ';' ||
          lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '`' ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(52);
      if (lookahead != 0) ADVANCE(53);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '{') ADVANCE(13);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(74);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(51);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          (lookahead < '`' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(70);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(44);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(69);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(50);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          (lookahead < '`' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_symbol);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(51);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          (lookahead < '`' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_symbol);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          (lookahead < '\'' || ')' < lookahead) &&
          lookahead != ',' &&
          lookahead != ';' &&
          lookahead != '[' &&
          lookahead != ']' &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(78);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'b') ADVANCE(1);
      if (lookahead == 'd') ADVANCE(2);
      if (lookahead == 'f') ADVANCE(3);
      if (lookahead == 'i') ADVANCE(4);
      if (lookahead == 'n') ADVANCE(5);
      if (lookahead == 'q') ADVANCE(6);
      if (lookahead == 's') ADVANCE(7);
      if (lookahead == 't') ADVANCE(8);
      if (lookahead == 'u') ADVANCE(9);
      if (lookahead == 'v') ADVANCE(10);
      if (lookahead == 'w') ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'r') ADVANCE(12);
      END_STATE();
    case 2:
      if (lookahead == 'e') ADVANCE(13);
      if (lookahead == 'o') ADVANCE(14);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(15);
      if (lookahead == 'n') ADVANCE(16);
      END_STATE();
    case 4:
      if (lookahead == 'f') ADVANCE(17);
      END_STATE();
    case 5:
      if (lookahead == 'i') ADVANCE(18);
      END_STATE();
    case 6:
      if (lookahead == 'u') ADVANCE(19);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(20);
      if (lookahead == 'p') ADVANCE(21);
      END_STATE();
    case 8:
      if (lookahead == 'r') ADVANCE(22);
      END_STATE();
    case 9:
      if (lookahead == 'n') ADVANCE(23);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(24);
      END_STATE();
    case 11:
      if (lookahead == 'h') ADVANCE(25);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(26);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(27);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 15:
      if (lookahead == 'l') ADVANCE(28);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 18:
      if (lookahead == 'l') ADVANCE(29);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      END_STATE();
    case 20:
      if (lookahead == 't') ADVANCE(32);
      END_STATE();
    case 21:
      if (lookahead == 'l') ADVANCE(33);
      END_STATE();
    case 22:
      if (lookahead == 'u') ADVANCE(34);
      END_STATE();
    case 23:
      if (lookahead == 'q') ADVANCE(35);
      END_STATE();
    case 24:
      if (lookahead == 'r') ADVANCE(36);
      END_STATE();
    case 25:
      if (lookahead == 'i') ADVANCE(37);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(38);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'm') ADVANCE(39);
      if (lookahead == 'n') ADVANCE(40);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(41);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(sym_nil_literal);
      END_STATE();
    case 30:
      if (lookahead == 's') ADVANCE(42);
      END_STATE();
    case 31:
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 33:
      if (lookahead == 'i') ADVANCE(44);
      END_STATE();
    case 34:
      if (lookahead == 'e') ADVANCE(45);
      END_STATE();
    case 35:
      if (lookahead == 'u') ADVANCE(46);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_var);
      if (lookahead == 'f') ADVANCE(47);
      END_STATE();
    case 37:
      if (lookahead == 'l') ADVANCE(48);
      END_STATE();
    case 38:
      if (lookahead == 'k') ADVANCE(49);
      END_STATE();
    case 39:
      if (lookahead == 'a') ADVANCE(50);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_defn);
      if (lookahead == '-') ADVANCE(51);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(52);
      END_STATE();
    case 42:
      if (lookahead == 'i') ADVANCE(53);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(54);
      END_STATE();
    case 44:
      if (lookahead == 'c') ADVANCE(55);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 46:
      if (lookahead == 'o') ADVANCE(56);
      END_STATE();
    case 47:
      if (lookahead == 'n') ADVANCE(57);
      END_STATE();
    case 48:
      if (lookahead == 'e') ADVANCE(58);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 50:
      if (lookahead == 'c') ADVANCE(59);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_defn_DASH);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 53:
      if (lookahead == 'q') ADVANCE(60);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_quote);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 56:
      if (lookahead == 't') ADVANCE(62);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_varfn);
      if (lookahead == '-') ADVANCE(63);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 59:
      if (lookahead == 'r') ADVANCE(64);
      END_STATE();
    case 60:
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_splice);
      END_STATE();
    case 62:
      if (lookahead == 'e') ADVANCE(66);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_varfn_DASH);
      END_STATE();
    case 64:
      if (lookahead == 'o') ADVANCE(67);
      END_STATE();
    case 65:
      if (lookahead == 'o') ADVANCE(68);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_unquote);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_defmacro);
      if (lookahead == '-') ADVANCE(69);
      END_STATE();
    case 68:
      if (lookahead == 't') ADVANCE(70);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_defmacro_DASH);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_quasiquote);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 20, .external_lex_state = 1},
  [2] = {.lex_state = 20, .external_lex_state = 1},
  [3] = {.lex_state = 20, .external_lex_state = 1},
  [4] = {.lex_state = 20, .external_lex_state = 1},
  [5] = {.lex_state = 20, .external_lex_state = 1},
  [6] = {.lex_state = 20, .external_lex_state = 1},
  [7] = {.lex_state = 20, .external_lex_state = 1},
  [8] = {.lex_state = 20, .external_lex_state = 1},
  [9] = {.lex_state = 20, .external_lex_state = 1},
  [10] = {.lex_state = 20, .external_lex_state = 1},
  [11] = {.lex_state = 20, .external_lex_state = 1},
  [12] = {.lex_state = 20, .external_lex_state = 1},
  [13] = {.lex_state = 20, .external_lex_state = 1},
  [14] = {.lex_state = 20, .external_lex_state = 1},
  [15] = {.lex_state = 20, .external_lex_state = 1},
  [16] = {.lex_state = 20, .external_lex_state = 1},
  [17] = {.lex_state = 20, .external_lex_state = 1},
  [18] = {.lex_state = 20, .external_lex_state = 1},
  [19] = {.lex_state = 20, .external_lex_state = 1},
  [20] = {.lex_state = 20, .external_lex_state = 1},
  [21] = {.lex_state = 20, .external_lex_state = 1},
  [22] = {.lex_state = 20, .external_lex_state = 1},
  [23] = {.lex_state = 20, .external_lex_state = 1},
  [24] = {.lex_state = 20, .external_lex_state = 1},
  [25] = {.lex_state = 20, .external_lex_state = 1},
  [26] = {.lex_state = 20, .external_lex_state = 1},
  [27] = {.lex_state = 20, .external_lex_state = 1},
  [28] = {.lex_state = 20, .external_lex_state = 1},
  [29] = {.lex_state = 20, .external_lex_state = 1},
  [30] = {.lex_state = 20, .external_lex_state = 1},
  [31] = {.lex_state = 20, .external_lex_state = 1},
  [32] = {.lex_state = 20, .external_lex_state = 1},
  [33] = {.lex_state = 20, .external_lex_state = 1},
  [34] = {.lex_state = 20, .external_lex_state = 1},
  [35] = {.lex_state = 20, .external_lex_state = 1},
  [36] = {.lex_state = 20, .external_lex_state = 1},
  [37] = {.lex_state = 20, .external_lex_state = 1},
  [38] = {.lex_state = 20, .external_lex_state = 1},
  [39] = {.lex_state = 20, .external_lex_state = 1},
  [40] = {.lex_state = 20, .external_lex_state = 1},
  [41] = {.lex_state = 20, .external_lex_state = 1},
  [42] = {.lex_state = 20, .external_lex_state = 1},
  [43] = {.lex_state = 20, .external_lex_state = 1},
  [44] = {.lex_state = 20, .external_lex_state = 1},
  [45] = {.lex_state = 20, .external_lex_state = 1},
  [46] = {.lex_state = 20, .external_lex_state = 1},
  [47] = {.lex_state = 20, .external_lex_state = 1},
  [48] = {.lex_state = 20, .external_lex_state = 1},
  [49] = {.lex_state = 20, .external_lex_state = 1},
  [50] = {.lex_state = 20, .external_lex_state = 1},
  [51] = {.lex_state = 20, .external_lex_state = 1},
  [52] = {.lex_state = 20, .external_lex_state = 1},
  [53] = {.lex_state = 20, .external_lex_state = 1},
  [54] = {.lex_state = 20, .external_lex_state = 1},
  [55] = {.lex_state = 20, .external_lex_state = 1},
  [56] = {.lex_state = 20, .external_lex_state = 1},
  [57] = {.lex_state = 20, .external_lex_state = 1},
  [58] = {.lex_state = 20, .external_lex_state = 1},
  [59] = {.lex_state = 20, .external_lex_state = 1},
  [60] = {.lex_state = 20, .external_lex_state = 1},
  [61] = {.lex_state = 20, .external_lex_state = 1},
  [62] = {.lex_state = 20, .external_lex_state = 1},
  [63] = {.lex_state = 20, .external_lex_state = 1},
  [64] = {.lex_state = 20, .external_lex_state = 1},
  [65] = {.lex_state = 20, .external_lex_state = 1},
  [66] = {.lex_state = 20, .external_lex_state = 1},
  [67] = {.lex_state = 20, .external_lex_state = 1},
  [68] = {.lex_state = 20, .external_lex_state = 1},
  [69] = {.lex_state = 20, .external_lex_state = 1},
  [70] = {.lex_state = 20, .external_lex_state = 1},
  [71] = {.lex_state = 20, .external_lex_state = 1},
  [72] = {.lex_state = 20, .external_lex_state = 1},
  [73] = {.lex_state = 20, .external_lex_state = 1},
  [74] = {.lex_state = 20, .external_lex_state = 1},
  [75] = {.lex_state = 20, .external_lex_state = 1},
  [76] = {.lex_state = 20, .external_lex_state = 1},
  [77] = {.lex_state = 20, .external_lex_state = 1},
  [78] = {.lex_state = 20, .external_lex_state = 1},
  [79] = {.lex_state = 20, .external_lex_state = 1},
  [80] = {.lex_state = 20, .external_lex_state = 1},
  [81] = {.lex_state = 20, .external_lex_state = 1},
  [82] = {.lex_state = 20, .external_lex_state = 1},
  [83] = {.lex_state = 20, .external_lex_state = 1},
  [84] = {.lex_state = 20, .external_lex_state = 1},
  [85] = {.lex_state = 20, .external_lex_state = 1},
  [86] = {.lex_state = 20, .external_lex_state = 1},
  [87] = {.lex_state = 20, .external_lex_state = 1},
  [88] = {.lex_state = 20, .external_lex_state = 1},
  [89] = {.lex_state = 20, .external_lex_state = 1},
  [90] = {.lex_state = 20, .external_lex_state = 1},
  [91] = {.lex_state = 20, .external_lex_state = 1},
  [92] = {.lex_state = 20, .external_lex_state = 1},
  [93] = {.lex_state = 20, .external_lex_state = 1},
  [94] = {.lex_state = 20, .external_lex_state = 1},
  [95] = {.lex_state = 20, .external_lex_state = 1},
  [96] = {.lex_state = 20, .external_lex_state = 1},
  [97] = {.lex_state = 20, .external_lex_state = 1},
  [98] = {.lex_state = 20, .external_lex_state = 1},
  [99] = {.lex_state = 20, .external_lex_state = 1},
  [100] = {.lex_state = 20, .external_lex_state = 1},
  [101] = {.lex_state = 20, .external_lex_state = 1},
  [102] = {.lex_state = 20, .external_lex_state = 1},
  [103] = {.lex_state = 20, .external_lex_state = 1},
  [104] = {.lex_state = 20, .external_lex_state = 1},
  [105] = {.lex_state = 20, .external_lex_state = 1},
  [106] = {.lex_state = 20, .external_lex_state = 1},
  [107] = {.lex_state = 20, .external_lex_state = 1},
  [108] = {.lex_state = 20, .external_lex_state = 1},
  [109] = {.lex_state = 20, .external_lex_state = 1},
  [110] = {.lex_state = 20, .external_lex_state = 1},
  [111] = {.lex_state = 20, .external_lex_state = 1},
  [112] = {.lex_state = 20, .external_lex_state = 1},
  [113] = {.lex_state = 20, .external_lex_state = 1},
  [114] = {.lex_state = 20, .external_lex_state = 1},
  [115] = {.lex_state = 20, .external_lex_state = 1},
  [116] = {.lex_state = 20, .external_lex_state = 1},
  [117] = {.lex_state = 20, .external_lex_state = 1},
  [118] = {.lex_state = 20, .external_lex_state = 1},
  [119] = {.lex_state = 20, .external_lex_state = 1},
  [120] = {.lex_state = 20, .external_lex_state = 1},
  [121] = {.lex_state = 20, .external_lex_state = 1},
  [122] = {.lex_state = 20, .external_lex_state = 1},
  [123] = {.lex_state = 20, .external_lex_state = 1},
  [124] = {.lex_state = 20, .external_lex_state = 1},
  [125] = {.lex_state = 20, .external_lex_state = 1},
  [126] = {.lex_state = 20, .external_lex_state = 1},
  [127] = {.lex_state = 20, .external_lex_state = 1},
  [128] = {.lex_state = 20, .external_lex_state = 1},
  [129] = {.lex_state = 20, .external_lex_state = 1},
  [130] = {.lex_state = 20, .external_lex_state = 1},
  [131] = {.lex_state = 20, .external_lex_state = 1},
  [132] = {.lex_state = 20, .external_lex_state = 1},
  [133] = {.lex_state = 20, .external_lex_state = 1},
  [134] = {.lex_state = 20, .external_lex_state = 1},
  [135] = {.lex_state = 20, .external_lex_state = 1},
  [136] = {.lex_state = 20, .external_lex_state = 1},
  [137] = {.lex_state = 20, .external_lex_state = 1},
  [138] = {.lex_state = 20, .external_lex_state = 1},
  [139] = {.lex_state = 20, .external_lex_state = 1},
  [140] = {.lex_state = 20, .external_lex_state = 1},
  [141] = {.lex_state = 20, .external_lex_state = 1},
  [142] = {.lex_state = 20, .external_lex_state = 1},
  [143] = {.lex_state = 20, .external_lex_state = 1},
  [144] = {.lex_state = 20, .external_lex_state = 1},
  [145] = {.lex_state = 20, .external_lex_state = 1},
  [146] = {.lex_state = 20, .external_lex_state = 1},
  [147] = {.lex_state = 20, .external_lex_state = 1},
  [148] = {.lex_state = 20, .external_lex_state = 1},
  [149] = {.lex_state = 20, .external_lex_state = 1},
  [150] = {.lex_state = 20, .external_lex_state = 1},
  [151] = {.lex_state = 20, .external_lex_state = 1},
  [152] = {.lex_state = 20, .external_lex_state = 1},
  [153] = {.lex_state = 20, .external_lex_state = 1},
  [154] = {.lex_state = 20, .external_lex_state = 1},
  [155] = {.lex_state = 20, .external_lex_state = 1},
  [156] = {.lex_state = 20, .external_lex_state = 1},
  [157] = {.lex_state = 20, .external_lex_state = 1},
  [158] = {.lex_state = 20, .external_lex_state = 1},
  [159] = {.lex_state = 20, .external_lex_state = 1},
  [160] = {.lex_state = 20, .external_lex_state = 1},
  [161] = {.lex_state = 20, .external_lex_state = 1},
  [162] = {.lex_state = 20, .external_lex_state = 1},
  [163] = {.lex_state = 20, .external_lex_state = 1},
  [164] = {.lex_state = 20, .external_lex_state = 1},
  [165] = {.lex_state = 20, .external_lex_state = 1},
  [166] = {.lex_state = 20, .external_lex_state = 1},
  [167] = {.lex_state = 20, .external_lex_state = 1},
  [168] = {.lex_state = 20, .external_lex_state = 1},
  [169] = {.lex_state = 20, .external_lex_state = 1},
  [170] = {.lex_state = 20, .external_lex_state = 1},
  [171] = {.lex_state = 20, .external_lex_state = 1},
  [172] = {.lex_state = 20, .external_lex_state = 1},
  [173] = {.lex_state = 20, .external_lex_state = 1},
  [174] = {.lex_state = 20, .external_lex_state = 1},
  [175] = {.lex_state = 20, .external_lex_state = 1},
  [176] = {.lex_state = 20, .external_lex_state = 1},
  [177] = {.lex_state = 20, .external_lex_state = 1},
  [178] = {.lex_state = 20, .external_lex_state = 1},
  [179] = {.lex_state = 20, .external_lex_state = 1},
  [180] = {.lex_state = 20, .external_lex_state = 1},
  [181] = {.lex_state = 20, .external_lex_state = 1},
  [182] = {.lex_state = 20, .external_lex_state = 1},
  [183] = {.lex_state = 20, .external_lex_state = 1},
  [184] = {.lex_state = 20, .external_lex_state = 1},
  [185] = {.lex_state = 20, .external_lex_state = 1},
  [186] = {.lex_state = 20, .external_lex_state = 1},
  [187] = {.lex_state = 20, .external_lex_state = 1},
  [188] = {.lex_state = 20, .external_lex_state = 1},
  [189] = {.lex_state = 20, .external_lex_state = 1},
  [190] = {.lex_state = 20, .external_lex_state = 1},
  [191] = {.lex_state = 20, .external_lex_state = 1},
  [192] = {.lex_state = 20, .external_lex_state = 1},
  [193] = {.lex_state = 20, .external_lex_state = 1},
  [194] = {.lex_state = 20, .external_lex_state = 1},
  [195] = {.lex_state = 20, .external_lex_state = 1},
  [196] = {.lex_state = 20, .external_lex_state = 1},
  [197] = {.lex_state = 20, .external_lex_state = 1},
  [198] = {.lex_state = 20, .external_lex_state = 1},
  [199] = {.lex_state = 20, .external_lex_state = 1},
  [200] = {.lex_state = 20, .external_lex_state = 1},
  [201] = {.lex_state = 20, .external_lex_state = 1},
  [202] = {.lex_state = 20, .external_lex_state = 1},
  [203] = {.lex_state = 20, .external_lex_state = 1},
  [204] = {.lex_state = 20, .external_lex_state = 1},
  [205] = {.lex_state = 20, .external_lex_state = 1},
  [206] = {.lex_state = 20, .external_lex_state = 1},
  [207] = {.lex_state = 20, .external_lex_state = 1},
  [208] = {.lex_state = 20, .external_lex_state = 1},
  [209] = {.lex_state = 20, .external_lex_state = 1},
  [210] = {.lex_state = 20, .external_lex_state = 1},
  [211] = {.lex_state = 20, .external_lex_state = 1},
  [212] = {.lex_state = 20, .external_lex_state = 1},
  [213] = {.lex_state = 20, .external_lex_state = 1},
  [214] = {.lex_state = 20, .external_lex_state = 1},
  [215] = {.lex_state = 20, .external_lex_state = 1},
  [216] = {.lex_state = 20, .external_lex_state = 1},
  [217] = {.lex_state = 20, .external_lex_state = 1},
  [218] = {.lex_state = 20, .external_lex_state = 1},
  [219] = {.lex_state = 20, .external_lex_state = 1},
  [220] = {.lex_state = 20, .external_lex_state = 1},
  [221] = {.lex_state = 20, .external_lex_state = 1},
  [222] = {.lex_state = 20, .external_lex_state = 1},
  [223] = {.lex_state = 20, .external_lex_state = 1},
  [224] = {.lex_state = 20, .external_lex_state = 1},
  [225] = {.lex_state = 20, .external_lex_state = 1},
  [226] = {.lex_state = 20, .external_lex_state = 1},
  [227] = {.lex_state = 1, .external_lex_state = 2},
  [228] = {.lex_state = 1, .external_lex_state = 2},
  [229] = {.lex_state = 1, .external_lex_state = 2},
  [230] = {.lex_state = 1, .external_lex_state = 2},
  [231] = {.lex_state = 20, .external_lex_state = 1},
  [232] = {.lex_state = 1, .external_lex_state = 2},
  [233] = {.lex_state = 1, .external_lex_state = 2},
  [234] = {.lex_state = 1, .external_lex_state = 2},
  [235] = {.lex_state = 1, .external_lex_state = 2},
  [236] = {.lex_state = 20, .external_lex_state = 1},
  [237] = {.lex_state = 20, .external_lex_state = 1},
  [238] = {.lex_state = 20, .external_lex_state = 1},
  [239] = {.lex_state = 20, .external_lex_state = 1},
  [240] = {.lex_state = 20, .external_lex_state = 1},
  [241] = {.lex_state = 20, .external_lex_state = 1},
  [242] = {.lex_state = 20, .external_lex_state = 1},
  [243] = {.lex_state = 20, .external_lex_state = 1},
  [244] = {.lex_state = 20, .external_lex_state = 1},
  [245] = {.lex_state = 20, .external_lex_state = 1},
  [246] = {.lex_state = 20, .external_lex_state = 1},
  [247] = {.lex_state = 20, .external_lex_state = 1},
  [248] = {.lex_state = 20, .external_lex_state = 1},
  [249] = {.lex_state = 20, .external_lex_state = 1},
  [250] = {.lex_state = 20, .external_lex_state = 1},
  [251] = {.lex_state = 20, .external_lex_state = 1},
  [252] = {.lex_state = 20, .external_lex_state = 1},
  [253] = {.lex_state = 20, .external_lex_state = 1},
  [254] = {.lex_state = 20, .external_lex_state = 1},
  [255] = {.lex_state = 20, .external_lex_state = 1},
  [256] = {.lex_state = 20, .external_lex_state = 1},
  [257] = {.lex_state = 20, .external_lex_state = 1},
  [258] = {.lex_state = 20, .external_lex_state = 1},
  [259] = {.lex_state = 20, .external_lex_state = 1},
  [260] = {.lex_state = 20, .external_lex_state = 1},
  [261] = {.lex_state = 20, .external_lex_state = 1},
  [262] = {.lex_state = 20, .external_lex_state = 1},
  [263] = {.lex_state = 20, .external_lex_state = 1},
  [264] = {.lex_state = 20, .external_lex_state = 1},
  [265] = {.lex_state = 20, .external_lex_state = 1},
  [266] = {.lex_state = 20, .external_lex_state = 1},
  [267] = {.lex_state = 20, .external_lex_state = 1},
  [268] = {.lex_state = 20, .external_lex_state = 1},
  [269] = {.lex_state = 20, .external_lex_state = 1},
  [270] = {.lex_state = 20, .external_lex_state = 1},
  [271] = {.lex_state = 20, .external_lex_state = 1},
  [272] = {.lex_state = 20, .external_lex_state = 1},
  [273] = {.lex_state = 20, .external_lex_state = 1},
  [274] = {.lex_state = 20, .external_lex_state = 1},
  [275] = {.lex_state = 20, .external_lex_state = 1},
  [276] = {.lex_state = 20, .external_lex_state = 1},
  [277] = {.lex_state = 20, .external_lex_state = 1},
  [278] = {.lex_state = 20, .external_lex_state = 1},
  [279] = {.lex_state = 20, .external_lex_state = 1},
  [280] = {.lex_state = 20, .external_lex_state = 1},
  [281] = {.lex_state = 20, .external_lex_state = 1},
  [282] = {.lex_state = 20, .external_lex_state = 1},
  [283] = {.lex_state = 20, .external_lex_state = 1},
  [284] = {.lex_state = 20, .external_lex_state = 1},
  [285] = {.lex_state = 20, .external_lex_state = 1},
  [286] = {.lex_state = 20, .external_lex_state = 1},
  [287] = {.lex_state = 20, .external_lex_state = 1},
  [288] = {.lex_state = 20, .external_lex_state = 1},
  [289] = {.lex_state = 20, .external_lex_state = 1},
  [290] = {.lex_state = 20, .external_lex_state = 1},
  [291] = {.lex_state = 20, .external_lex_state = 1},
  [292] = {.lex_state = 20, .external_lex_state = 1},
  [293] = {.lex_state = 20, .external_lex_state = 1},
  [294] = {.lex_state = 20, .external_lex_state = 1},
  [295] = {.lex_state = 20, .external_lex_state = 1},
  [296] = {.lex_state = 20, .external_lex_state = 1},
  [297] = {.lex_state = 20, .external_lex_state = 1},
  [298] = {.lex_state = 20, .external_lex_state = 1},
  [299] = {.lex_state = 20, .external_lex_state = 1},
  [300] = {.lex_state = 1, .external_lex_state = 2},
  [301] = {.lex_state = 1},
  [302] = {.lex_state = 1},
  [303] = {.lex_state = 1},
  [304] = {.lex_state = 1},
  [305] = {.lex_state = 1},
  [306] = {.lex_state = 1},
  [307] = {.lex_state = 1},
  [308] = {.lex_state = 1},
  [309] = {.lex_state = 1},
  [310] = {.lex_state = 1},
  [311] = {.lex_state = 1},
  [312] = {.lex_state = 1},
  [313] = {.lex_state = 1, .external_lex_state = 2},
  [314] = {.lex_state = 1, .external_lex_state = 2},
  [315] = {.lex_state = 1, .external_lex_state = 2},
  [316] = {.lex_state = 1, .external_lex_state = 2},
  [317] = {.lex_state = 1, .external_lex_state = 2},
  [318] = {.lex_state = 1, .external_lex_state = 2},
  [319] = {.lex_state = 1, .external_lex_state = 2},
  [320] = {.lex_state = 1, .external_lex_state = 2},
  [321] = {.lex_state = 1, .external_lex_state = 2},
  [322] = {.lex_state = 1, .external_lex_state = 2},
  [323] = {.lex_state = 1, .external_lex_state = 2},
  [324] = {.lex_state = 1, .external_lex_state = 2},
  [325] = {.lex_state = 1, .external_lex_state = 2},
  [326] = {.lex_state = 1, .external_lex_state = 2},
  [327] = {.lex_state = 1, .external_lex_state = 2},
  [328] = {.lex_state = 1, .external_lex_state = 2},
  [329] = {.lex_state = 1, .external_lex_state = 2},
  [330] = {.lex_state = 1, .external_lex_state = 2},
  [331] = {.lex_state = 1, .external_lex_state = 2},
  [332] = {.lex_state = 1, .external_lex_state = 2},
  [333] = {.lex_state = 1, .external_lex_state = 2},
  [334] = {.lex_state = 1, .external_lex_state = 2},
  [335] = {.lex_state = 1, .external_lex_state = 2},
  [336] = {.lex_state = 1, .external_lex_state = 2},
  [337] = {.lex_state = 1, .external_lex_state = 2},
  [338] = {.lex_state = 1, .external_lex_state = 2},
  [339] = {.lex_state = 1, .external_lex_state = 2},
  [340] = {.lex_state = 1, .external_lex_state = 2},
  [341] = {.lex_state = 1, .external_lex_state = 2},
  [342] = {.lex_state = 1, .external_lex_state = 2},
  [343] = {.lex_state = 1, .external_lex_state = 2},
  [344] = {.lex_state = 1, .external_lex_state = 2},
  [345] = {.lex_state = 1, .external_lex_state = 2},
  [346] = {.lex_state = 1, .external_lex_state = 2},
  [347] = {.lex_state = 1, .external_lex_state = 2},
  [348] = {.lex_state = 1, .external_lex_state = 2},
  [349] = {.lex_state = 1, .external_lex_state = 2},
  [350] = {.lex_state = 1, .external_lex_state = 2},
  [351] = {.lex_state = 1, .external_lex_state = 2},
  [352] = {.lex_state = 1, .external_lex_state = 2},
  [353] = {.lex_state = 1, .external_lex_state = 2},
  [354] = {.lex_state = 1, .external_lex_state = 2},
  [355] = {.lex_state = 1, .external_lex_state = 2},
  [356] = {.lex_state = 1, .external_lex_state = 2},
  [357] = {.lex_state = 1, .external_lex_state = 2},
  [358] = {.lex_state = 1, .external_lex_state = 2},
  [359] = {.lex_state = 1, .external_lex_state = 2},
  [360] = {.lex_state = 1, .external_lex_state = 2},
  [361] = {.lex_state = 1, .external_lex_state = 2},
  [362] = {.lex_state = 1},
  [363] = {.lex_state = 1},
  [364] = {.lex_state = 0},
  [365] = {.lex_state = 0},
  [366] = {.lex_state = 0},
  [367] = {.lex_state = 0},
  [368] = {.lex_state = 0},
  [369] = {.lex_state = 0},
  [370] = {.lex_state = 0},
  [371] = {.lex_state = 0},
  [372] = {.lex_state = 0},
  [373] = {.lex_state = 0},
  [374] = {.lex_state = 0},
  [375] = {.lex_state = 0},
  [376] = {.lex_state = 0},
  [377] = {.lex_state = 0},
  [378] = {.lex_state = 0},
  [379] = {.lex_state = 0},
  [380] = {.lex_state = 0},
  [381] = {.lex_state = 0},
  [382] = {.lex_state = 0},
  [383] = {.lex_state = 0},
  [384] = {.lex_state = 0},
  [385] = {.lex_state = 0},
  [386] = {.lex_state = 0},
  [387] = {.lex_state = 0},
  [388] = {.lex_state = 0},
  [389] = {.lex_state = 0},
  [390] = {.lex_state = 0},
  [391] = {.lex_state = 0},
  [392] = {.lex_state = 0},
  [393] = {.lex_state = 0},
  [394] = {.lex_state = 0},
  [395] = {.lex_state = 0},
  [396] = {.lex_state = 0},
  [397] = {.lex_state = 0},
  [398] = {.lex_state = 0},
  [399] = {.lex_state = 0},
  [400] = {.lex_state = 0},
  [401] = {.lex_state = 0},
  [402] = {.lex_state = 0},
  [403] = {.lex_state = 0},
  [404] = {.lex_state = 0},
  [405] = {.lex_state = 0},
  [406] = {.lex_state = 0},
  [407] = {.lex_state = 0},
  [408] = {.lex_state = 0},
  [409] = {.lex_state = 0},
  [410] = {.lex_state = 0},
  [411] = {.lex_state = 0},
  [412] = {.lex_state = 0},
  [413] = {.lex_state = 0},
  [414] = {.lex_state = 0},
  [415] = {.lex_state = 0},
  [416] = {.lex_state = 0},
  [417] = {.lex_state = 0},
  [418] = {.lex_state = 0},
  [419] = {.lex_state = 0},
  [420] = {.lex_state = 0},
  [421] = {.lex_state = 0},
  [422] = {.lex_state = 0},
  [423] = {.lex_state = 0},
  [424] = {.lex_state = 0},
  [425] = {.lex_state = 0},
  [426] = {.lex_state = 0},
  [427] = {.lex_state = 0},
  [428] = {.lex_state = 0},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 0},
  [431] = {.lex_state = 0},
  [432] = {.lex_state = 0},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 0},
  [435] = {.lex_state = 0},
  [436] = {.lex_state = 0},
  [437] = {.lex_state = 0},
  [438] = {.lex_state = 0},
  [439] = {.lex_state = 0},
  [440] = {.lex_state = 0},
  [441] = {.lex_state = 0},
  [442] = {.lex_state = 0},
  [443] = {.lex_state = 0},
  [444] = {.lex_state = 0},
  [445] = {.lex_state = 0},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 0},
  [449] = {.lex_state = 0},
  [450] = {.lex_state = 0},
  [451] = {.lex_state = 0},
  [452] = {.lex_state = 0},
  [453] = {.lex_state = 0},
  [454] = {.lex_state = 0},
  [455] = {.lex_state = 0},
  [456] = {.lex_state = 0},
  [457] = {.lex_state = 0},
  [458] = {.lex_state = 0},
  [459] = {.lex_state = 0},
  [460] = {.lex_state = 0},
  [461] = {.lex_state = 0},
  [462] = {.lex_state = 0},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 0},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 0},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 0},
  [470] = {.lex_state = 0},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 0},
  [473] = {.lex_state = 0},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 0},
};

enum {
  ts_external_token__long_str = 0,
  ts_external_token__long_buffer = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__long_str] = sym__long_str,
  [ts_external_token__long_buffer] = sym__long_buffer,
};

static bool ts_external_scanner_states[3][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__long_str] = true,
    [ts_external_token__long_buffer] = true,
  },
  [2] = {
    [ts_external_token__long_str] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_symbol] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_AT_LPAREN] = ACTIONS(1),
    [anon_sym_AT_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_AT_LBRACE] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_quote] = ACTIONS(1),
    [anon_sym_splice] = ACTIONS(1),
    [anon_sym_quasiquote] = ACTIONS(1),
    [anon_sym_unquote] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_defn] = ACTIONS(1),
    [anon_sym_defn_DASH] = ACTIONS(1),
    [anon_sym_varfn] = ACTIONS(1),
    [anon_sym_varfn_DASH] = ACTIONS(1),
    [anon_sym_defmacro] = ACTIONS(1),
    [anon_sym_defmacro_DASH] = ACTIONS(1),
    [sym_str_literal] = ACTIONS(1),
    [sym_buffer_literal] = ACTIONS(1),
    [aux_sym_number_literal_token1] = ACTIONS(1),
    [aux_sym_number_literal_token2] = ACTIONS(1),
    [aux_sym_number_literal_token3] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_nil_literal] = ACTIONS(1),
    [aux_sym_escape_sequence_token1] = ACTIONS(1),
    [aux_sym_escape_sequence_token2] = ACTIONS(1),
    [aux_sym_escape_sequence_token3] = ACTIONS(1),
    [aux_sym_escape_sequence_token4] = ACTIONS(1),
    [sym_keyword] = ACTIONS(1),
    [sym__long_str] = ACTIONS(1),
    [sym__long_buffer] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(459),
    [sym__expr] = STATE(71),
    [sym_tuple] = STATE(71),
    [sym_sqr_tuple] = STATE(71),
    [sym_array] = STATE(71),
    [sym_sqr_array] = STATE(71),
    [sym_struct] = STATE(71),
    [sym_table] = STATE(71),
    [sym__special_forms] = STATE(71),
    [sym_def] = STATE(71),
    [sym_var] = STATE(71),
    [sym_quote] = STATE(71),
    [sym_splice] = STATE(71),
    [sym_quasiquote] = STATE(71),
    [sym_unquote] = STATE(71),
    [sym_break] = STATE(71),
    [sym_set] = STATE(71),
    [sym_if] = STATE(71),
    [sym_do] = STATE(71),
    [sym_while] = STATE(71),
    [sym_fn] = STATE(71),
    [sym__shorthand] = STATE(71),
    [sym_short_quote] = STATE(71),
    [sym_short_splice] = STATE(71),
    [sym_short_quasiquote] = STATE(71),
    [sym_short_unquote] = STATE(71),
    [sym_short_fn] = STATE(71),
    [sym__specials] = STATE(71),
    [sym_extra_defs] = STATE(71),
    [sym__literals] = STATE(71),
    [sym_long_str_literal] = STATE(71),
    [sym_long_buffer_literal] = STATE(71),
    [sym_number_literal] = STATE(71),
    [sym_bool_literal] = STATE(71),
    [sym__identifier] = STATE(71),
    [aux_sym_source_file_repeat1] = STATE(71),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_symbol] = ACTIONS(7),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(31),
    [sym_buffer_literal] = ACTIONS(31),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(7),
    [sym_keyword] = ACTIONS(31),
    [sym__long_str] = ACTIONS(37),
    [sym__long_buffer] = ACTIONS(39),
  },
  [2] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(80),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_def] = ACTIONS(57),
    [anon_sym_var] = ACTIONS(59),
    [anon_sym_quote] = ACTIONS(61),
    [anon_sym_splice] = ACTIONS(63),
    [anon_sym_quasiquote] = ACTIONS(65),
    [anon_sym_unquote] = ACTIONS(67),
    [anon_sym_break] = ACTIONS(69),
    [anon_sym_set] = ACTIONS(71),
    [anon_sym_if] = ACTIONS(73),
    [anon_sym_do] = ACTIONS(75),
    [anon_sym_while] = ACTIONS(77),
    [anon_sym_fn] = ACTIONS(79),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_defn] = ACTIONS(91),
    [anon_sym_defn_DASH] = ACTIONS(91),
    [anon_sym_varfn] = ACTIONS(91),
    [anon_sym_varfn_DASH] = ACTIONS(91),
    [anon_sym_defmacro] = ACTIONS(91),
    [anon_sym_defmacro_DASH] = ACTIONS(91),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [3] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(48),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_def] = ACTIONS(105),
    [anon_sym_var] = ACTIONS(107),
    [anon_sym_quote] = ACTIONS(109),
    [anon_sym_splice] = ACTIONS(111),
    [anon_sym_quasiquote] = ACTIONS(113),
    [anon_sym_unquote] = ACTIONS(115),
    [anon_sym_break] = ACTIONS(117),
    [anon_sym_set] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(121),
    [anon_sym_do] = ACTIONS(123),
    [anon_sym_while] = ACTIONS(125),
    [anon_sym_fn] = ACTIONS(127),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_defn] = ACTIONS(129),
    [anon_sym_defn_DASH] = ACTIONS(129),
    [anon_sym_varfn] = ACTIONS(129),
    [anon_sym_varfn_DASH] = ACTIONS(129),
    [anon_sym_defmacro] = ACTIONS(129),
    [anon_sym_defmacro_DASH] = ACTIONS(129),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [4] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(98),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_def] = ACTIONS(133),
    [anon_sym_var] = ACTIONS(135),
    [anon_sym_quote] = ACTIONS(137),
    [anon_sym_splice] = ACTIONS(139),
    [anon_sym_quasiquote] = ACTIONS(141),
    [anon_sym_unquote] = ACTIONS(143),
    [anon_sym_break] = ACTIONS(145),
    [anon_sym_set] = ACTIONS(147),
    [anon_sym_if] = ACTIONS(149),
    [anon_sym_do] = ACTIONS(151),
    [anon_sym_while] = ACTIONS(153),
    [anon_sym_fn] = ACTIONS(155),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_defn] = ACTIONS(157),
    [anon_sym_defn_DASH] = ACTIONS(157),
    [anon_sym_varfn] = ACTIONS(157),
    [anon_sym_varfn_DASH] = ACTIONS(157),
    [anon_sym_defmacro] = ACTIONS(157),
    [anon_sym_defmacro_DASH] = ACTIONS(157),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [5] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(72),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(159),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_def] = ACTIONS(161),
    [anon_sym_var] = ACTIONS(163),
    [anon_sym_quote] = ACTIONS(137),
    [anon_sym_splice] = ACTIONS(139),
    [anon_sym_quasiquote] = ACTIONS(141),
    [anon_sym_unquote] = ACTIONS(143),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_set] = ACTIONS(167),
    [anon_sym_if] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_while] = ACTIONS(173),
    [anon_sym_fn] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_defn] = ACTIONS(177),
    [anon_sym_defn_DASH] = ACTIONS(177),
    [anon_sym_varfn] = ACTIONS(177),
    [anon_sym_varfn_DASH] = ACTIONS(177),
    [anon_sym_defmacro] = ACTIONS(177),
    [anon_sym_defmacro_DASH] = ACTIONS(177),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [6] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(72),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(159),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_def] = ACTIONS(161),
    [anon_sym_var] = ACTIONS(163),
    [anon_sym_quote] = ACTIONS(179),
    [anon_sym_splice] = ACTIONS(181),
    [anon_sym_quasiquote] = ACTIONS(183),
    [anon_sym_unquote] = ACTIONS(185),
    [anon_sym_break] = ACTIONS(165),
    [anon_sym_set] = ACTIONS(167),
    [anon_sym_if] = ACTIONS(169),
    [anon_sym_do] = ACTIONS(171),
    [anon_sym_while] = ACTIONS(173),
    [anon_sym_fn] = ACTIONS(175),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_defn] = ACTIONS(177),
    [anon_sym_defn_DASH] = ACTIONS(177),
    [anon_sym_varfn] = ACTIONS(177),
    [anon_sym_varfn_DASH] = ACTIONS(177),
    [anon_sym_defmacro] = ACTIONS(177),
    [anon_sym_defmacro_DASH] = ACTIONS(177),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [7] = {
    [sym__expr] = STATE(231),
    [sym_tuple] = STATE(231),
    [sym_sqr_tuple] = STATE(231),
    [sym_array] = STATE(231),
    [sym_sqr_array] = STATE(231),
    [sym_struct] = STATE(231),
    [sym_table] = STATE(231),
    [sym__special_forms] = STATE(231),
    [sym_def] = STATE(231),
    [sym_var] = STATE(231),
    [sym_quote] = STATE(231),
    [sym_splice] = STATE(231),
    [sym_quasiquote] = STATE(231),
    [sym_unquote] = STATE(231),
    [sym_break] = STATE(231),
    [sym_set] = STATE(231),
    [sym_if] = STATE(231),
    [sym_do] = STATE(231),
    [sym_while] = STATE(231),
    [sym_fn] = STATE(231),
    [sym__shorthand] = STATE(231),
    [sym_short_quote] = STATE(231),
    [sym_short_splice] = STATE(231),
    [sym_short_quasiquote] = STATE(231),
    [sym_short_unquote] = STATE(231),
    [sym_short_fn] = STATE(231),
    [sym__specials] = STATE(231),
    [sym_extra_defs] = STATE(231),
    [sym__literals] = STATE(231),
    [sym_long_str_literal] = STATE(231),
    [sym_long_buffer_literal] = STATE(231),
    [sym_number_literal] = STATE(231),
    [sym_bool_literal] = STATE(231),
    [sym__identifier] = STATE(231),
    [aux_sym_parameters_repeat1] = STATE(101),
    [sym_symbol] = ACTIONS(187),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_quote] = ACTIONS(137),
    [anon_sym_splice] = ACTIONS(139),
    [anon_sym_quasiquote] = ACTIONS(141),
    [anon_sym_unquote] = ACTIONS(143),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(191),
    [sym_buffer_literal] = ACTIONS(191),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(187),
    [sym_keyword] = ACTIONS(191),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [8] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(414),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [9] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(416),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [10] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(46),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(203),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [11] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(45),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(207),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [12] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(460),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(209),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [13] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(413),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(211),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [14] = {
    [sym__expr] = STATE(231),
    [sym_tuple] = STATE(231),
    [sym_sqr_tuple] = STATE(231),
    [sym_array] = STATE(231),
    [sym_sqr_array] = STATE(231),
    [sym_struct] = STATE(231),
    [sym_table] = STATE(231),
    [sym__special_forms] = STATE(231),
    [sym_def] = STATE(231),
    [sym_var] = STATE(231),
    [sym_quote] = STATE(231),
    [sym_splice] = STATE(231),
    [sym_quasiquote] = STATE(231),
    [sym_unquote] = STATE(231),
    [sym_break] = STATE(231),
    [sym_set] = STATE(231),
    [sym_if] = STATE(231),
    [sym_do] = STATE(231),
    [sym_while] = STATE(231),
    [sym_fn] = STATE(231),
    [sym__shorthand] = STATE(231),
    [sym_short_quote] = STATE(231),
    [sym_short_splice] = STATE(231),
    [sym_short_quasiquote] = STATE(231),
    [sym_short_unquote] = STATE(231),
    [sym_short_fn] = STATE(231),
    [sym__specials] = STATE(231),
    [sym_extra_defs] = STATE(231),
    [sym__literals] = STATE(231),
    [sym_long_str_literal] = STATE(231),
    [sym_long_buffer_literal] = STATE(231),
    [sym_number_literal] = STATE(231),
    [sym_bool_literal] = STATE(231),
    [sym__identifier] = STATE(231),
    [aux_sym_parameters_repeat1] = STATE(14),
    [sym_symbol] = ACTIONS(213),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_RPAREN] = ACTIONS(219),
    [anon_sym_LBRACK] = ACTIONS(221),
    [anon_sym_RBRACK] = ACTIONS(219),
    [anon_sym_AT_LPAREN] = ACTIONS(224),
    [anon_sym_AT_LBRACK] = ACTIONS(227),
    [anon_sym_LBRACE] = ACTIONS(230),
    [anon_sym_AT_LBRACE] = ACTIONS(233),
    [anon_sym_SQUOTE] = ACTIONS(236),
    [anon_sym_SEMI] = ACTIONS(239),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_COMMA] = ACTIONS(245),
    [anon_sym_PIPE] = ACTIONS(248),
    [sym_str_literal] = ACTIONS(251),
    [sym_buffer_literal] = ACTIONS(251),
    [aux_sym_number_literal_token1] = ACTIONS(254),
    [aux_sym_number_literal_token2] = ACTIONS(254),
    [aux_sym_number_literal_token3] = ACTIONS(254),
    [anon_sym_true] = ACTIONS(257),
    [anon_sym_false] = ACTIONS(257),
    [sym_nil_literal] = ACTIONS(213),
    [sym_keyword] = ACTIONS(251),
    [sym__long_str] = ACTIONS(260),
    [sym__long_buffer] = ACTIONS(263),
  },
  [15] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(22),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(266),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [16] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(461),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(268),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [17] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(376),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(270),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [18] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(375),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(272),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [19] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(23),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(274),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [20] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(462),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [21] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(392),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(278),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [22] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(29),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(280),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [23] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(29),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(282),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [24] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(407),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(284),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [25] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(29),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(286),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [26] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(29),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(288),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [27] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(378),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(290),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [28] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(388),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(292),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [29] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(29),
    [sym_symbol] = ACTIONS(294),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_LBRACK] = ACTIONS(300),
    [anon_sym_AT_LPAREN] = ACTIONS(303),
    [anon_sym_AT_LBRACK] = ACTIONS(306),
    [anon_sym_LBRACE] = ACTIONS(309),
    [anon_sym_RBRACE] = ACTIONS(312),
    [anon_sym_AT_LBRACE] = ACTIONS(314),
    [anon_sym_SQUOTE] = ACTIONS(317),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_TILDE] = ACTIONS(323),
    [anon_sym_COMMA] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(329),
    [sym_str_literal] = ACTIONS(332),
    [sym_buffer_literal] = ACTIONS(332),
    [aux_sym_number_literal_token1] = ACTIONS(335),
    [aux_sym_number_literal_token2] = ACTIONS(335),
    [aux_sym_number_literal_token3] = ACTIONS(335),
    [anon_sym_true] = ACTIONS(338),
    [anon_sym_false] = ACTIONS(338),
    [sym_nil_literal] = ACTIONS(294),
    [sym_keyword] = ACTIONS(332),
    [sym__long_str] = ACTIONS(341),
    [sym__long_buffer] = ACTIONS(344),
  },
  [30] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(384),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(347),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [31] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(470),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(349),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [32] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(383),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [33] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(369),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [34] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(399),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(355),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [35] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(357),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(360),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(365),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_AT_LPAREN] = ACTIONS(368),
    [anon_sym_AT_LBRACK] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(374),
    [anon_sym_AT_LBRACE] = ACTIONS(377),
    [anon_sym_SQUOTE] = ACTIONS(380),
    [anon_sym_SEMI] = ACTIONS(383),
    [anon_sym_TILDE] = ACTIONS(386),
    [anon_sym_COMMA] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(392),
    [sym_str_literal] = ACTIONS(395),
    [sym_buffer_literal] = ACTIONS(395),
    [aux_sym_number_literal_token1] = ACTIONS(398),
    [aux_sym_number_literal_token2] = ACTIONS(398),
    [aux_sym_number_literal_token3] = ACTIONS(398),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [sym_nil_literal] = ACTIONS(357),
    [sym_keyword] = ACTIONS(395),
    [sym__long_str] = ACTIONS(404),
    [sym__long_buffer] = ACTIONS(407),
  },
  [36] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(25),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(410),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [37] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(38),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [38] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(29),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(414),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [39] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(29),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(416),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [40] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(466),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(418),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [41] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(382),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(420),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [42] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(39),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(422),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [43] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(26),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(424),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [44] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym_body] = STATE(371),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(67),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [45] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(29),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(428),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [46] = {
    [sym__expr] = STATE(122),
    [sym_tuple] = STATE(122),
    [sym_sqr_tuple] = STATE(122),
    [sym_array] = STATE(122),
    [sym_sqr_array] = STATE(122),
    [sym_struct] = STATE(122),
    [sym_table] = STATE(122),
    [sym__struct_tables_commom] = STATE(267),
    [sym__special_forms] = STATE(122),
    [sym_def] = STATE(122),
    [sym_var] = STATE(122),
    [sym_quote] = STATE(122),
    [sym_splice] = STATE(122),
    [sym_quasiquote] = STATE(122),
    [sym_unquote] = STATE(122),
    [sym_break] = STATE(122),
    [sym_set] = STATE(122),
    [sym_if] = STATE(122),
    [sym_do] = STATE(122),
    [sym_while] = STATE(122),
    [sym_fn] = STATE(122),
    [sym__shorthand] = STATE(122),
    [sym_short_quote] = STATE(122),
    [sym_short_splice] = STATE(122),
    [sym_short_quasiquote] = STATE(122),
    [sym_short_unquote] = STATE(122),
    [sym_short_fn] = STATE(122),
    [sym__specials] = STATE(122),
    [sym_extra_defs] = STATE(122),
    [sym__literals] = STATE(122),
    [sym_long_str_literal] = STATE(122),
    [sym_long_buffer_literal] = STATE(122),
    [sym_number_literal] = STATE(122),
    [sym_bool_literal] = STATE(122),
    [sym__identifier] = STATE(122),
    [aux_sym_struct_repeat1] = STATE(29),
    [sym_symbol] = ACTIONS(201),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_RBRACE] = ACTIONS(430),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(205),
    [sym_buffer_literal] = ACTIONS(205),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(201),
    [sym_keyword] = ACTIONS(205),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [47] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(96),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(432),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [48] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(434),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [49] = {
    [sym__expr] = STATE(403),
    [sym_tuple] = STATE(403),
    [sym_sqr_tuple] = STATE(403),
    [sym_array] = STATE(403),
    [sym_sqr_array] = STATE(403),
    [sym_struct] = STATE(403),
    [sym_table] = STATE(403),
    [sym__special_forms] = STATE(403),
    [sym_def] = STATE(403),
    [sym_var] = STATE(403),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(403),
    [sym_set] = STATE(403),
    [sym_if] = STATE(403),
    [sym_do] = STATE(403),
    [sym_while] = STATE(403),
    [sym_fn] = STATE(403),
    [sym__shorthand] = STATE(403),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(403),
    [sym__specials] = STATE(403),
    [sym_extra_defs] = STATE(403),
    [sym__literals] = STATE(403),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(403),
    [sym_number_literal] = STATE(403),
    [sym_bool_literal] = STATE(403),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(403),
    [aux_sym_def_repeat1] = STATE(83),
    [sym_symbol] = ACTIONS(436),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(454),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(436),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [50] = {
    [sym__expr] = STATE(386),
    [sym_tuple] = STATE(386),
    [sym_sqr_tuple] = STATE(386),
    [sym_array] = STATE(386),
    [sym_sqr_array] = STATE(386),
    [sym_struct] = STATE(386),
    [sym_table] = STATE(386),
    [sym__special_forms] = STATE(386),
    [sym_def] = STATE(386),
    [sym_var] = STATE(386),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(386),
    [sym_set] = STATE(386),
    [sym_if] = STATE(386),
    [sym_do] = STATE(386),
    [sym_while] = STATE(386),
    [sym_fn] = STATE(386),
    [sym__shorthand] = STATE(386),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(386),
    [sym__specials] = STATE(386),
    [sym_extra_defs] = STATE(386),
    [sym__literals] = STATE(386),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(386),
    [sym_number_literal] = STATE(386),
    [sym_bool_literal] = STATE(386),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(386),
    [aux_sym_def_repeat1] = STATE(179),
    [sym_symbol] = ACTIONS(464),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(466),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(464),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [51] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(468),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [52] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(470),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [53] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(70),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(472),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [54] = {
    [sym__expr] = STATE(54),
    [sym_tuple] = STATE(54),
    [sym_sqr_tuple] = STATE(54),
    [sym_array] = STATE(54),
    [sym_sqr_array] = STATE(54),
    [sym_struct] = STATE(54),
    [sym_table] = STATE(54),
    [sym__special_forms] = STATE(54),
    [sym_def] = STATE(54),
    [sym_var] = STATE(54),
    [sym_quote] = STATE(54),
    [sym_splice] = STATE(54),
    [sym_quasiquote] = STATE(54),
    [sym_unquote] = STATE(54),
    [sym_break] = STATE(54),
    [sym_set] = STATE(54),
    [sym_if] = STATE(54),
    [sym_do] = STATE(54),
    [sym_while] = STATE(54),
    [sym_fn] = STATE(54),
    [sym__shorthand] = STATE(54),
    [sym_short_quote] = STATE(54),
    [sym_short_splice] = STATE(54),
    [sym_short_quasiquote] = STATE(54),
    [sym_short_unquote] = STATE(54),
    [sym_short_fn] = STATE(54),
    [sym__specials] = STATE(54),
    [sym_extra_defs] = STATE(54),
    [sym__literals] = STATE(54),
    [sym_long_str_literal] = STATE(54),
    [sym_long_buffer_literal] = STATE(54),
    [sym_number_literal] = STATE(54),
    [sym_bool_literal] = STATE(54),
    [sym__identifier] = STATE(54),
    [aux_sym_source_file_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(474),
    [sym_symbol] = ACTIONS(476),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(482),
    [anon_sym_AT_LPAREN] = ACTIONS(485),
    [anon_sym_AT_LBRACK] = ACTIONS(488),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_AT_LBRACE] = ACTIONS(494),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_SEMI] = ACTIONS(500),
    [anon_sym_TILDE] = ACTIONS(503),
    [anon_sym_COMMA] = ACTIONS(506),
    [anon_sym_PIPE] = ACTIONS(509),
    [sym_str_literal] = ACTIONS(512),
    [sym_buffer_literal] = ACTIONS(512),
    [aux_sym_number_literal_token1] = ACTIONS(515),
    [aux_sym_number_literal_token2] = ACTIONS(515),
    [aux_sym_number_literal_token3] = ACTIONS(515),
    [anon_sym_true] = ACTIONS(518),
    [anon_sym_false] = ACTIONS(518),
    [sym_nil_literal] = ACTIONS(476),
    [sym_keyword] = ACTIONS(512),
    [sym__long_str] = ACTIONS(521),
    [sym__long_buffer] = ACTIONS(524),
  },
  [55] = {
    [sym__expr] = STATE(469),
    [sym_tuple] = STATE(469),
    [sym_sqr_tuple] = STATE(469),
    [sym_array] = STATE(469),
    [sym_sqr_array] = STATE(469),
    [sym_struct] = STATE(469),
    [sym_table] = STATE(469),
    [sym__special_forms] = STATE(469),
    [sym_def] = STATE(469),
    [sym_var] = STATE(469),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(469),
    [sym_set] = STATE(469),
    [sym_if] = STATE(469),
    [sym_do] = STATE(469),
    [sym_while] = STATE(469),
    [sym_fn] = STATE(469),
    [sym__shorthand] = STATE(469),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(469),
    [sym__specials] = STATE(469),
    [sym_extra_defs] = STATE(469),
    [sym__literals] = STATE(469),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(469),
    [sym_number_literal] = STATE(469),
    [sym_bool_literal] = STATE(469),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(469),
    [aux_sym_def_repeat1] = STATE(90),
    [sym_symbol] = ACTIONS(527),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(529),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(527),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [56] = {
    [sym__expr] = STATE(468),
    [sym_tuple] = STATE(468),
    [sym_sqr_tuple] = STATE(468),
    [sym_array] = STATE(468),
    [sym_sqr_array] = STATE(468),
    [sym_struct] = STATE(468),
    [sym_table] = STATE(468),
    [sym__special_forms] = STATE(468),
    [sym_def] = STATE(468),
    [sym_var] = STATE(468),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(468),
    [sym_set] = STATE(468),
    [sym_if] = STATE(468),
    [sym_do] = STATE(468),
    [sym_while] = STATE(468),
    [sym_fn] = STATE(468),
    [sym__shorthand] = STATE(468),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(468),
    [sym__specials] = STATE(468),
    [sym_extra_defs] = STATE(468),
    [sym__literals] = STATE(468),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(468),
    [sym_number_literal] = STATE(468),
    [sym_bool_literal] = STATE(468),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(468),
    [aux_sym_def_repeat1] = STATE(62),
    [sym_symbol] = ACTIONS(531),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(533),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(531),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [57] = {
    [sym__expr] = STATE(380),
    [sym_tuple] = STATE(380),
    [sym_sqr_tuple] = STATE(380),
    [sym_array] = STATE(380),
    [sym_sqr_array] = STATE(380),
    [sym_struct] = STATE(380),
    [sym_table] = STATE(380),
    [sym__special_forms] = STATE(380),
    [sym_def] = STATE(380),
    [sym_var] = STATE(380),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(380),
    [sym_set] = STATE(380),
    [sym_if] = STATE(380),
    [sym_do] = STATE(380),
    [sym_while] = STATE(380),
    [sym_fn] = STATE(380),
    [sym__shorthand] = STATE(380),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(380),
    [sym__specials] = STATE(380),
    [sym_extra_defs] = STATE(380),
    [sym__literals] = STATE(380),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(380),
    [sym_number_literal] = STATE(380),
    [sym_bool_literal] = STATE(380),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(380),
    [aux_sym_def_repeat1] = STATE(63),
    [sym_symbol] = ACTIONS(535),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(537),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(535),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [58] = {
    [sym__expr] = STATE(365),
    [sym_tuple] = STATE(365),
    [sym_sqr_tuple] = STATE(365),
    [sym_array] = STATE(365),
    [sym_sqr_array] = STATE(365),
    [sym_struct] = STATE(365),
    [sym_table] = STATE(365),
    [sym__special_forms] = STATE(365),
    [sym_def] = STATE(365),
    [sym_var] = STATE(365),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(365),
    [sym_set] = STATE(365),
    [sym_if] = STATE(365),
    [sym_do] = STATE(365),
    [sym_while] = STATE(365),
    [sym_fn] = STATE(365),
    [sym__shorthand] = STATE(365),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(365),
    [sym__specials] = STATE(365),
    [sym_extra_defs] = STATE(365),
    [sym__literals] = STATE(365),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(365),
    [sym_number_literal] = STATE(365),
    [sym_bool_literal] = STATE(365),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(365),
    [aux_sym_def_repeat1] = STATE(64),
    [sym_symbol] = ACTIONS(539),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(541),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(539),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [59] = {
    [sym__expr] = STATE(387),
    [sym_tuple] = STATE(387),
    [sym_sqr_tuple] = STATE(387),
    [sym_array] = STATE(387),
    [sym_sqr_array] = STATE(387),
    [sym_struct] = STATE(387),
    [sym_table] = STATE(387),
    [sym__special_forms] = STATE(387),
    [sym_def] = STATE(387),
    [sym_var] = STATE(387),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(387),
    [sym_set] = STATE(387),
    [sym_if] = STATE(387),
    [sym_do] = STATE(387),
    [sym_while] = STATE(387),
    [sym_fn] = STATE(387),
    [sym__shorthand] = STATE(387),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(387),
    [sym__specials] = STATE(387),
    [sym_extra_defs] = STATE(387),
    [sym__literals] = STATE(387),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(387),
    [sym_number_literal] = STATE(387),
    [sym_bool_literal] = STATE(387),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(387),
    [aux_sym_def_repeat1] = STATE(179),
    [sym_symbol] = ACTIONS(543),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(545),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(543),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [60] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(51),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(547),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [61] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(94),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(549),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [62] = {
    [sym__expr] = STATE(464),
    [sym_tuple] = STATE(464),
    [sym_sqr_tuple] = STATE(464),
    [sym_array] = STATE(464),
    [sym_sqr_array] = STATE(464),
    [sym_struct] = STATE(464),
    [sym_table] = STATE(464),
    [sym__special_forms] = STATE(464),
    [sym_def] = STATE(464),
    [sym_var] = STATE(464),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(464),
    [sym_set] = STATE(464),
    [sym_if] = STATE(464),
    [sym_do] = STATE(464),
    [sym_while] = STATE(464),
    [sym_fn] = STATE(464),
    [sym__shorthand] = STATE(464),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(464),
    [sym__specials] = STATE(464),
    [sym_extra_defs] = STATE(464),
    [sym__literals] = STATE(464),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(464),
    [sym_number_literal] = STATE(464),
    [sym_bool_literal] = STATE(464),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(464),
    [aux_sym_def_repeat1] = STATE(179),
    [sym_symbol] = ACTIONS(551),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(553),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(551),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [63] = {
    [sym__expr] = STATE(372),
    [sym_tuple] = STATE(372),
    [sym_sqr_tuple] = STATE(372),
    [sym_array] = STATE(372),
    [sym_sqr_array] = STATE(372),
    [sym_struct] = STATE(372),
    [sym_table] = STATE(372),
    [sym__special_forms] = STATE(372),
    [sym_def] = STATE(372),
    [sym_var] = STATE(372),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(372),
    [sym_set] = STATE(372),
    [sym_if] = STATE(372),
    [sym_do] = STATE(372),
    [sym_while] = STATE(372),
    [sym_fn] = STATE(372),
    [sym__shorthand] = STATE(372),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(372),
    [sym__specials] = STATE(372),
    [sym_extra_defs] = STATE(372),
    [sym__literals] = STATE(372),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(372),
    [sym_number_literal] = STATE(372),
    [sym_bool_literal] = STATE(372),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(372),
    [aux_sym_def_repeat1] = STATE(179),
    [sym_symbol] = ACTIONS(555),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(557),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(555),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [64] = {
    [sym__expr] = STATE(373),
    [sym_tuple] = STATE(373),
    [sym_sqr_tuple] = STATE(373),
    [sym_array] = STATE(373),
    [sym_sqr_array] = STATE(373),
    [sym_struct] = STATE(373),
    [sym_table] = STATE(373),
    [sym__special_forms] = STATE(373),
    [sym_def] = STATE(373),
    [sym_var] = STATE(373),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(373),
    [sym_set] = STATE(373),
    [sym_if] = STATE(373),
    [sym_do] = STATE(373),
    [sym_while] = STATE(373),
    [sym_fn] = STATE(373),
    [sym__shorthand] = STATE(373),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(373),
    [sym__specials] = STATE(373),
    [sym_extra_defs] = STATE(373),
    [sym__literals] = STATE(373),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(373),
    [sym_number_literal] = STATE(373),
    [sym_bool_literal] = STATE(373),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(373),
    [aux_sym_def_repeat1] = STATE(179),
    [sym_symbol] = ACTIONS(559),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(561),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(559),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [65] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(85),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(563),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [66] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(84),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [67] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(102),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(567),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [68] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(104),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [69] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(102),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(571),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [70] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [71] = {
    [sym__expr] = STATE(54),
    [sym_tuple] = STATE(54),
    [sym_sqr_tuple] = STATE(54),
    [sym_array] = STATE(54),
    [sym_sqr_array] = STATE(54),
    [sym_struct] = STATE(54),
    [sym_table] = STATE(54),
    [sym__special_forms] = STATE(54),
    [sym_def] = STATE(54),
    [sym_var] = STATE(54),
    [sym_quote] = STATE(54),
    [sym_splice] = STATE(54),
    [sym_quasiquote] = STATE(54),
    [sym_unquote] = STATE(54),
    [sym_break] = STATE(54),
    [sym_set] = STATE(54),
    [sym_if] = STATE(54),
    [sym_do] = STATE(54),
    [sym_while] = STATE(54),
    [sym_fn] = STATE(54),
    [sym__shorthand] = STATE(54),
    [sym_short_quote] = STATE(54),
    [sym_short_splice] = STATE(54),
    [sym_short_quasiquote] = STATE(54),
    [sym_short_unquote] = STATE(54),
    [sym_short_fn] = STATE(54),
    [sym__specials] = STATE(54),
    [sym_extra_defs] = STATE(54),
    [sym__literals] = STATE(54),
    [sym_long_str_literal] = STATE(54),
    [sym_long_buffer_literal] = STATE(54),
    [sym_number_literal] = STATE(54),
    [sym_bool_literal] = STATE(54),
    [sym__identifier] = STATE(54),
    [aux_sym_source_file_repeat1] = STATE(54),
    [ts_builtin_sym_end] = ACTIONS(575),
    [sym_symbol] = ACTIONS(577),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(579),
    [sym_buffer_literal] = ACTIONS(579),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(577),
    [sym_keyword] = ACTIONS(579),
    [sym__long_str] = ACTIONS(37),
    [sym__long_buffer] = ACTIONS(39),
  },
  [72] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(581),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [73] = {
    [sym__expr] = STATE(390),
    [sym_tuple] = STATE(390),
    [sym_sqr_tuple] = STATE(390),
    [sym_array] = STATE(390),
    [sym_sqr_array] = STATE(390),
    [sym_struct] = STATE(390),
    [sym_table] = STATE(390),
    [sym__special_forms] = STATE(390),
    [sym_def] = STATE(390),
    [sym_var] = STATE(390),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(390),
    [sym_set] = STATE(390),
    [sym_if] = STATE(390),
    [sym_do] = STATE(390),
    [sym_while] = STATE(390),
    [sym_fn] = STATE(390),
    [sym__shorthand] = STATE(390),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(390),
    [sym__specials] = STATE(390),
    [sym_extra_defs] = STATE(390),
    [sym__literals] = STATE(390),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(390),
    [sym_number_literal] = STATE(390),
    [sym_bool_literal] = STATE(390),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(390),
    [aux_sym_def_repeat1] = STATE(50),
    [sym_symbol] = ACTIONS(583),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(585),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(583),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [74] = {
    [sym__expr] = STATE(231),
    [sym_tuple] = STATE(231),
    [sym_sqr_tuple] = STATE(231),
    [sym_array] = STATE(231),
    [sym_sqr_array] = STATE(231),
    [sym_struct] = STATE(231),
    [sym_table] = STATE(231),
    [sym__special_forms] = STATE(231),
    [sym_def] = STATE(231),
    [sym_var] = STATE(231),
    [sym_quote] = STATE(231),
    [sym_splice] = STATE(231),
    [sym_quasiquote] = STATE(231),
    [sym_unquote] = STATE(231),
    [sym_break] = STATE(231),
    [sym_set] = STATE(231),
    [sym_if] = STATE(231),
    [sym_do] = STATE(231),
    [sym_while] = STATE(231),
    [sym_fn] = STATE(231),
    [sym__shorthand] = STATE(231),
    [sym_short_quote] = STATE(231),
    [sym_short_splice] = STATE(231),
    [sym_short_quasiquote] = STATE(231),
    [sym_short_unquote] = STATE(231),
    [sym_short_fn] = STATE(231),
    [sym__specials] = STATE(231),
    [sym_extra_defs] = STATE(231),
    [sym__literals] = STATE(231),
    [sym_long_str_literal] = STATE(231),
    [sym_long_buffer_literal] = STATE(231),
    [sym_number_literal] = STATE(231),
    [sym_bool_literal] = STATE(231),
    [sym__identifier] = STATE(231),
    [aux_sym_parameters_repeat1] = STATE(99),
    [sym_symbol] = ACTIONS(187),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(587),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(191),
    [sym_buffer_literal] = ACTIONS(191),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(187),
    [sym_keyword] = ACTIONS(191),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [75] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(93),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(589),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [76] = {
    [sym__expr] = STATE(391),
    [sym_tuple] = STATE(391),
    [sym_sqr_tuple] = STATE(391),
    [sym_array] = STATE(391),
    [sym_sqr_array] = STATE(391),
    [sym_struct] = STATE(391),
    [sym_table] = STATE(391),
    [sym__special_forms] = STATE(391),
    [sym_def] = STATE(391),
    [sym_var] = STATE(391),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(391),
    [sym_set] = STATE(391),
    [sym_if] = STATE(391),
    [sym_do] = STATE(391),
    [sym_while] = STATE(391),
    [sym_fn] = STATE(391),
    [sym__shorthand] = STATE(391),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(391),
    [sym__specials] = STATE(391),
    [sym_extra_defs] = STATE(391),
    [sym__literals] = STATE(391),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(391),
    [sym_number_literal] = STATE(391),
    [sym_bool_literal] = STATE(391),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(391),
    [aux_sym_def_repeat1] = STATE(59),
    [sym_symbol] = ACTIONS(591),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(593),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(591),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [77] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(69),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [78] = {
    [sym__expr] = STATE(410),
    [sym_tuple] = STATE(410),
    [sym_sqr_tuple] = STATE(410),
    [sym_array] = STATE(410),
    [sym_sqr_array] = STATE(410),
    [sym_struct] = STATE(410),
    [sym_table] = STATE(410),
    [sym__special_forms] = STATE(410),
    [sym_def] = STATE(410),
    [sym_var] = STATE(410),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(410),
    [sym_set] = STATE(410),
    [sym_if] = STATE(410),
    [sym_do] = STATE(410),
    [sym_while] = STATE(410),
    [sym_fn] = STATE(410),
    [sym__shorthand] = STATE(410),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(410),
    [sym__specials] = STATE(410),
    [sym_extra_defs] = STATE(410),
    [sym__literals] = STATE(410),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(410),
    [sym_number_literal] = STATE(410),
    [sym_bool_literal] = STATE(410),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(410),
    [aux_sym_def_repeat1] = STATE(179),
    [sym_symbol] = ACTIONS(597),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(599),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(597),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [79] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(52),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(601),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [80] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(603),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [81] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(102),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(605),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [82] = {
    [sym__expr] = STATE(402),
    [sym_tuple] = STATE(402),
    [sym_sqr_tuple] = STATE(402),
    [sym_array] = STATE(402),
    [sym_sqr_array] = STATE(402),
    [sym_struct] = STATE(402),
    [sym_table] = STATE(402),
    [sym__special_forms] = STATE(402),
    [sym_def] = STATE(402),
    [sym_var] = STATE(402),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(402),
    [sym_set] = STATE(402),
    [sym_if] = STATE(402),
    [sym_do] = STATE(402),
    [sym_while] = STATE(402),
    [sym_fn] = STATE(402),
    [sym__shorthand] = STATE(402),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(402),
    [sym__specials] = STATE(402),
    [sym_extra_defs] = STATE(402),
    [sym__literals] = STATE(402),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(402),
    [sym_number_literal] = STATE(402),
    [sym_bool_literal] = STATE(402),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(402),
    [aux_sym_def_repeat1] = STATE(78),
    [sym_symbol] = ACTIONS(607),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(609),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(607),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [83] = {
    [sym__expr] = STATE(411),
    [sym_tuple] = STATE(411),
    [sym_sqr_tuple] = STATE(411),
    [sym_array] = STATE(411),
    [sym_sqr_array] = STATE(411),
    [sym_struct] = STATE(411),
    [sym_table] = STATE(411),
    [sym__special_forms] = STATE(411),
    [sym_def] = STATE(411),
    [sym_var] = STATE(411),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(411),
    [sym_set] = STATE(411),
    [sym_if] = STATE(411),
    [sym_do] = STATE(411),
    [sym_while] = STATE(411),
    [sym_fn] = STATE(411),
    [sym__shorthand] = STATE(411),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(411),
    [sym__specials] = STATE(411),
    [sym_extra_defs] = STATE(411),
    [sym__literals] = STATE(411),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(411),
    [sym_number_literal] = STATE(411),
    [sym_bool_literal] = STATE(411),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(411),
    [aux_sym_def_repeat1] = STATE(179),
    [sym_symbol] = ACTIONS(611),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(613),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(611),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [84] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(615),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [85] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(617),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [86] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(102),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(619),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [87] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(621),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [88] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(100),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(623),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [89] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(81),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(625),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [90] = {
    [sym__expr] = STATE(465),
    [sym_tuple] = STATE(465),
    [sym_sqr_tuple] = STATE(465),
    [sym_array] = STATE(465),
    [sym_sqr_array] = STATE(465),
    [sym_struct] = STATE(465),
    [sym_table] = STATE(465),
    [sym__special_forms] = STATE(465),
    [sym_def] = STATE(465),
    [sym_var] = STATE(465),
    [sym_quote] = STATE(291),
    [sym_splice] = STATE(291),
    [sym_quasiquote] = STATE(291),
    [sym_unquote] = STATE(291),
    [sym_break] = STATE(465),
    [sym_set] = STATE(465),
    [sym_if] = STATE(465),
    [sym_do] = STATE(465),
    [sym_while] = STATE(465),
    [sym_fn] = STATE(465),
    [sym__shorthand] = STATE(465),
    [sym_short_quote] = STATE(292),
    [sym_short_splice] = STATE(292),
    [sym_short_quasiquote] = STATE(292),
    [sym_short_unquote] = STATE(292),
    [sym_short_fn] = STATE(465),
    [sym__specials] = STATE(465),
    [sym_extra_defs] = STATE(465),
    [sym__literals] = STATE(465),
    [sym_long_str_literal] = STATE(289),
    [sym_long_buffer_literal] = STATE(465),
    [sym_number_literal] = STATE(465),
    [sym_bool_literal] = STATE(465),
    [sym_metadata] = STATE(298),
    [sym__identifier] = STATE(465),
    [aux_sym_def_repeat1] = STATE(179),
    [sym_symbol] = ACTIONS(627),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(452),
    [sym_buffer_literal] = ACTIONS(629),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(627),
    [sym_keyword] = ACTIONS(460),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(462),
  },
  [91] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(103),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(631),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [92] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(105),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(633),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [93] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(635),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [94] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(637),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [95] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(87),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [96] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(641),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [97] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(86),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(643),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [98] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [99] = {
    [sym__expr] = STATE(231),
    [sym_tuple] = STATE(231),
    [sym_sqr_tuple] = STATE(231),
    [sym_array] = STATE(231),
    [sym_sqr_array] = STATE(231),
    [sym_struct] = STATE(231),
    [sym_table] = STATE(231),
    [sym__special_forms] = STATE(231),
    [sym_def] = STATE(231),
    [sym_var] = STATE(231),
    [sym_quote] = STATE(231),
    [sym_splice] = STATE(231),
    [sym_quasiquote] = STATE(231),
    [sym_unquote] = STATE(231),
    [sym_break] = STATE(231),
    [sym_set] = STATE(231),
    [sym_if] = STATE(231),
    [sym_do] = STATE(231),
    [sym_while] = STATE(231),
    [sym_fn] = STATE(231),
    [sym__shorthand] = STATE(231),
    [sym_short_quote] = STATE(231),
    [sym_short_splice] = STATE(231),
    [sym_short_quasiquote] = STATE(231),
    [sym_short_unquote] = STATE(231),
    [sym_short_fn] = STATE(231),
    [sym__specials] = STATE(231),
    [sym_extra_defs] = STATE(231),
    [sym__literals] = STATE(231),
    [sym_long_str_literal] = STATE(231),
    [sym_long_buffer_literal] = STATE(231),
    [sym_number_literal] = STATE(231),
    [sym_bool_literal] = STATE(231),
    [sym__identifier] = STATE(231),
    [aux_sym_parameters_repeat1] = STATE(14),
    [sym_symbol] = ACTIONS(187),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(647),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(191),
    [sym_buffer_literal] = ACTIONS(191),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(187),
    [sym_keyword] = ACTIONS(191),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [100] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(649),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [101] = {
    [sym__expr] = STATE(231),
    [sym_tuple] = STATE(231),
    [sym_sqr_tuple] = STATE(231),
    [sym_array] = STATE(231),
    [sym_sqr_array] = STATE(231),
    [sym_struct] = STATE(231),
    [sym_table] = STATE(231),
    [sym__special_forms] = STATE(231),
    [sym_def] = STATE(231),
    [sym_var] = STATE(231),
    [sym_quote] = STATE(231),
    [sym_splice] = STATE(231),
    [sym_quasiquote] = STATE(231),
    [sym_unquote] = STATE(231),
    [sym_break] = STATE(231),
    [sym_set] = STATE(231),
    [sym_if] = STATE(231),
    [sym_do] = STATE(231),
    [sym_while] = STATE(231),
    [sym_fn] = STATE(231),
    [sym__shorthand] = STATE(231),
    [sym_short_quote] = STATE(231),
    [sym_short_splice] = STATE(231),
    [sym_short_quasiquote] = STATE(231),
    [sym_short_unquote] = STATE(231),
    [sym_short_fn] = STATE(231),
    [sym__specials] = STATE(231),
    [sym_extra_defs] = STATE(231),
    [sym__literals] = STATE(231),
    [sym_long_str_literal] = STATE(231),
    [sym_long_buffer_literal] = STATE(231),
    [sym_number_literal] = STATE(231),
    [sym_bool_literal] = STATE(231),
    [sym__identifier] = STATE(231),
    [aux_sym_parameters_repeat1] = STATE(14),
    [sym_symbol] = ACTIONS(187),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(191),
    [sym_buffer_literal] = ACTIONS(191),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(187),
    [sym_keyword] = ACTIONS(191),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [102] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(102),
    [sym_symbol] = ACTIONS(653),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(656),
    [anon_sym_RPAREN] = ACTIONS(659),
    [anon_sym_LBRACK] = ACTIONS(661),
    [anon_sym_AT_LPAREN] = ACTIONS(664),
    [anon_sym_AT_LBRACK] = ACTIONS(667),
    [anon_sym_LBRACE] = ACTIONS(670),
    [anon_sym_AT_LBRACE] = ACTIONS(673),
    [anon_sym_SQUOTE] = ACTIONS(676),
    [anon_sym_SEMI] = ACTIONS(679),
    [anon_sym_TILDE] = ACTIONS(682),
    [anon_sym_COMMA] = ACTIONS(685),
    [anon_sym_PIPE] = ACTIONS(688),
    [sym_str_literal] = ACTIONS(691),
    [sym_buffer_literal] = ACTIONS(691),
    [aux_sym_number_literal_token1] = ACTIONS(694),
    [aux_sym_number_literal_token2] = ACTIONS(694),
    [aux_sym_number_literal_token3] = ACTIONS(694),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_nil_literal] = ACTIONS(653),
    [sym_keyword] = ACTIONS(691),
    [sym__long_str] = ACTIONS(700),
    [sym__long_buffer] = ACTIONS(703),
  },
  [103] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(706),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [104] = {
    [sym__expr] = STATE(278),
    [sym_tuple] = STATE(278),
    [sym_sqr_tuple] = STATE(278),
    [sym_array] = STATE(278),
    [sym_sqr_array] = STATE(278),
    [sym_struct] = STATE(278),
    [sym_table] = STATE(278),
    [sym__special_forms] = STATE(278),
    [sym_def] = STATE(278),
    [sym_var] = STATE(278),
    [sym_quote] = STATE(278),
    [sym_splice] = STATE(278),
    [sym_quasiquote] = STATE(278),
    [sym_unquote] = STATE(278),
    [sym_break] = STATE(278),
    [sym_set] = STATE(278),
    [sym_if] = STATE(278),
    [sym_do] = STATE(278),
    [sym_while] = STATE(278),
    [sym_fn] = STATE(278),
    [sym__shorthand] = STATE(278),
    [sym_short_quote] = STATE(278),
    [sym_short_splice] = STATE(278),
    [sym_short_quasiquote] = STATE(278),
    [sym_short_unquote] = STATE(278),
    [sym_short_fn] = STATE(278),
    [sym__specials] = STATE(278),
    [sym_extra_defs] = STATE(278),
    [sym__literals] = STATE(278),
    [sym_long_str_literal] = STATE(278),
    [sym_long_buffer_literal] = STATE(278),
    [sym_number_literal] = STATE(278),
    [sym_bool_literal] = STATE(278),
    [sym__identifier] = STATE(278),
    [aux_sym_while_repeat1] = STATE(102),
    [sym_symbol] = ACTIONS(193),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_RPAREN] = ACTIONS(708),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(197),
    [sym_buffer_literal] = ACTIONS(197),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(193),
    [sym_keyword] = ACTIONS(197),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [105] = {
    [sym__expr] = STATE(236),
    [sym_tuple] = STATE(236),
    [sym_sqr_tuple] = STATE(236),
    [sym_array] = STATE(236),
    [sym_sqr_array] = STATE(236),
    [sym_struct] = STATE(236),
    [sym_table] = STATE(236),
    [sym__special_forms] = STATE(236),
    [sym_def] = STATE(236),
    [sym_var] = STATE(236),
    [sym_quote] = STATE(236),
    [sym_splice] = STATE(236),
    [sym_quasiquote] = STATE(236),
    [sym_unquote] = STATE(236),
    [sym_break] = STATE(236),
    [sym_set] = STATE(236),
    [sym_if] = STATE(236),
    [sym_do] = STATE(236),
    [sym_while] = STATE(236),
    [sym_fn] = STATE(236),
    [sym__shorthand] = STATE(236),
    [sym_short_quote] = STATE(236),
    [sym_short_splice] = STATE(236),
    [sym_short_quasiquote] = STATE(236),
    [sym_short_unquote] = STATE(236),
    [sym_short_fn] = STATE(236),
    [sym__specials] = STATE(236),
    [sym_extra_defs] = STATE(236),
    [sym__literals] = STATE(236),
    [sym_long_str_literal] = STATE(236),
    [sym_long_buffer_literal] = STATE(236),
    [sym_number_literal] = STATE(236),
    [sym_bool_literal] = STATE(236),
    [sym__identifier] = STATE(236),
    [aux_sym_tuple_repeat1] = STATE(35),
    [sym_symbol] = ACTIONS(41),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_RBRACK] = ACTIONS(710),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(93),
    [sym_buffer_literal] = ACTIONS(93),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(41),
    [sym_keyword] = ACTIONS(93),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [106] = {
    [sym__expr] = STATE(385),
    [sym_tuple] = STATE(385),
    [sym_sqr_tuple] = STATE(385),
    [sym_array] = STATE(385),
    [sym_sqr_array] = STATE(385),
    [sym_struct] = STATE(385),
    [sym_table] = STATE(385),
    [sym__special_forms] = STATE(385),
    [sym_def] = STATE(385),
    [sym_var] = STATE(385),
    [sym_quote] = STATE(385),
    [sym_splice] = STATE(385),
    [sym_quasiquote] = STATE(385),
    [sym_unquote] = STATE(385),
    [sym_break] = STATE(385),
    [sym_set] = STATE(385),
    [sym_if] = STATE(385),
    [sym_do] = STATE(385),
    [sym_while] = STATE(385),
    [sym_fn] = STATE(385),
    [sym__shorthand] = STATE(385),
    [sym_short_quote] = STATE(385),
    [sym_short_splice] = STATE(385),
    [sym_short_quasiquote] = STATE(385),
    [sym_short_unquote] = STATE(385),
    [sym_short_fn] = STATE(385),
    [sym__specials] = STATE(385),
    [sym_extra_defs] = STATE(385),
    [sym__literals] = STATE(385),
    [sym_long_str_literal] = STATE(385),
    [sym_long_buffer_literal] = STATE(385),
    [sym_number_literal] = STATE(385),
    [sym_bool_literal] = STATE(385),
    [sym__identifier] = STATE(385),
    [sym_symbol] = ACTIONS(712),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(716),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(726),
    [sym_buffer_literal] = ACTIONS(726),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(712),
    [sym_keyword] = ACTIONS(726),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [107] = {
    [sym__expr] = STATE(368),
    [sym_tuple] = STATE(368),
    [sym_sqr_tuple] = STATE(368),
    [sym_array] = STATE(368),
    [sym_sqr_array] = STATE(368),
    [sym_struct] = STATE(368),
    [sym_table] = STATE(368),
    [sym__special_forms] = STATE(368),
    [sym_def] = STATE(368),
    [sym_var] = STATE(368),
    [sym_quote] = STATE(368),
    [sym_splice] = STATE(368),
    [sym_quasiquote] = STATE(368),
    [sym_unquote] = STATE(368),
    [sym_break] = STATE(368),
    [sym_set] = STATE(368),
    [sym_if] = STATE(368),
    [sym_do] = STATE(368),
    [sym_while] = STATE(368),
    [sym_fn] = STATE(368),
    [sym__shorthand] = STATE(368),
    [sym_short_quote] = STATE(368),
    [sym_short_splice] = STATE(368),
    [sym_short_quasiquote] = STATE(368),
    [sym_short_unquote] = STATE(368),
    [sym_short_fn] = STATE(368),
    [sym__specials] = STATE(368),
    [sym_extra_defs] = STATE(368),
    [sym__literals] = STATE(368),
    [sym_long_str_literal] = STATE(368),
    [sym_long_buffer_literal] = STATE(368),
    [sym_number_literal] = STATE(368),
    [sym_bool_literal] = STATE(368),
    [sym__identifier] = STATE(368),
    [sym_symbol] = ACTIONS(730),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(732),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(734),
    [sym_buffer_literal] = ACTIONS(734),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(730),
    [sym_keyword] = ACTIONS(734),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [108] = {
    [sym__expr] = STATE(463),
    [sym_tuple] = STATE(463),
    [sym_sqr_tuple] = STATE(463),
    [sym_array] = STATE(463),
    [sym_sqr_array] = STATE(463),
    [sym_struct] = STATE(463),
    [sym_table] = STATE(463),
    [sym__special_forms] = STATE(463),
    [sym_def] = STATE(463),
    [sym_var] = STATE(463),
    [sym_quote] = STATE(463),
    [sym_splice] = STATE(463),
    [sym_quasiquote] = STATE(463),
    [sym_unquote] = STATE(463),
    [sym_break] = STATE(463),
    [sym_set] = STATE(463),
    [sym_if] = STATE(463),
    [sym_do] = STATE(463),
    [sym_while] = STATE(463),
    [sym_fn] = STATE(463),
    [sym__shorthand] = STATE(463),
    [sym_short_quote] = STATE(463),
    [sym_short_splice] = STATE(463),
    [sym_short_quasiquote] = STATE(463),
    [sym_short_unquote] = STATE(463),
    [sym_short_fn] = STATE(463),
    [sym__specials] = STATE(463),
    [sym_extra_defs] = STATE(463),
    [sym__literals] = STATE(463),
    [sym_long_str_literal] = STATE(463),
    [sym_long_buffer_literal] = STATE(463),
    [sym_number_literal] = STATE(463),
    [sym_bool_literal] = STATE(463),
    [sym__identifier] = STATE(463),
    [sym_symbol] = ACTIONS(736),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(738),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(740),
    [sym_buffer_literal] = ACTIONS(740),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(736),
    [sym_keyword] = ACTIONS(740),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [109] = {
    [sym__expr] = STATE(412),
    [sym_tuple] = STATE(412),
    [sym_sqr_tuple] = STATE(412),
    [sym_array] = STATE(412),
    [sym_sqr_array] = STATE(412),
    [sym_struct] = STATE(412),
    [sym_table] = STATE(412),
    [sym__special_forms] = STATE(412),
    [sym_def] = STATE(412),
    [sym_var] = STATE(412),
    [sym_quote] = STATE(412),
    [sym_splice] = STATE(412),
    [sym_quasiquote] = STATE(412),
    [sym_unquote] = STATE(412),
    [sym_break] = STATE(412),
    [sym_set] = STATE(412),
    [sym_if] = STATE(412),
    [sym_do] = STATE(412),
    [sym_while] = STATE(412),
    [sym_fn] = STATE(412),
    [sym__shorthand] = STATE(412),
    [sym_short_quote] = STATE(412),
    [sym_short_splice] = STATE(412),
    [sym_short_quasiquote] = STATE(412),
    [sym_short_unquote] = STATE(412),
    [sym_short_fn] = STATE(412),
    [sym__specials] = STATE(412),
    [sym_extra_defs] = STATE(412),
    [sym__literals] = STATE(412),
    [sym_long_str_literal] = STATE(412),
    [sym_long_buffer_literal] = STATE(412),
    [sym_number_literal] = STATE(412),
    [sym_bool_literal] = STATE(412),
    [sym__identifier] = STATE(412),
    [sym_symbol] = ACTIONS(742),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(744),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(746),
    [sym_buffer_literal] = ACTIONS(746),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(742),
    [sym_keyword] = ACTIONS(746),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [110] = {
    [sym__expr] = STATE(467),
    [sym_tuple] = STATE(467),
    [sym_sqr_tuple] = STATE(467),
    [sym_array] = STATE(467),
    [sym_sqr_array] = STATE(467),
    [sym_struct] = STATE(467),
    [sym_table] = STATE(467),
    [sym__special_forms] = STATE(467),
    [sym_def] = STATE(467),
    [sym_var] = STATE(467),
    [sym_quote] = STATE(467),
    [sym_splice] = STATE(467),
    [sym_quasiquote] = STATE(467),
    [sym_unquote] = STATE(467),
    [sym_break] = STATE(467),
    [sym_set] = STATE(467),
    [sym_if] = STATE(467),
    [sym_do] = STATE(467),
    [sym_while] = STATE(467),
    [sym_fn] = STATE(467),
    [sym__shorthand] = STATE(467),
    [sym_short_quote] = STATE(467),
    [sym_short_splice] = STATE(467),
    [sym_short_quasiquote] = STATE(467),
    [sym_short_unquote] = STATE(467),
    [sym_short_fn] = STATE(467),
    [sym__specials] = STATE(467),
    [sym_extra_defs] = STATE(467),
    [sym__literals] = STATE(467),
    [sym_long_str_literal] = STATE(467),
    [sym_long_buffer_literal] = STATE(467),
    [sym_number_literal] = STATE(467),
    [sym_bool_literal] = STATE(467),
    [sym__identifier] = STATE(467),
    [sym_symbol] = ACTIONS(748),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(750),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(752),
    [sym_buffer_literal] = ACTIONS(752),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(748),
    [sym_keyword] = ACTIONS(752),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [111] = {
    [sym__expr] = STATE(374),
    [sym_tuple] = STATE(374),
    [sym_sqr_tuple] = STATE(374),
    [sym_array] = STATE(374),
    [sym_sqr_array] = STATE(374),
    [sym_struct] = STATE(374),
    [sym_table] = STATE(374),
    [sym__special_forms] = STATE(374),
    [sym_def] = STATE(374),
    [sym_var] = STATE(374),
    [sym_quote] = STATE(374),
    [sym_splice] = STATE(374),
    [sym_quasiquote] = STATE(374),
    [sym_unquote] = STATE(374),
    [sym_break] = STATE(374),
    [sym_set] = STATE(374),
    [sym_if] = STATE(374),
    [sym_do] = STATE(374),
    [sym_while] = STATE(374),
    [sym_fn] = STATE(374),
    [sym__shorthand] = STATE(374),
    [sym_short_quote] = STATE(374),
    [sym_short_splice] = STATE(374),
    [sym_short_quasiquote] = STATE(374),
    [sym_short_unquote] = STATE(374),
    [sym_short_fn] = STATE(374),
    [sym__specials] = STATE(374),
    [sym_extra_defs] = STATE(374),
    [sym__literals] = STATE(374),
    [sym_long_str_literal] = STATE(374),
    [sym_long_buffer_literal] = STATE(374),
    [sym_number_literal] = STATE(374),
    [sym_bool_literal] = STATE(374),
    [sym__identifier] = STATE(374),
    [sym_symbol] = ACTIONS(754),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(756),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(758),
    [sym_buffer_literal] = ACTIONS(758),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(754),
    [sym_keyword] = ACTIONS(758),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [112] = {
    [sym__expr] = STATE(404),
    [sym_tuple] = STATE(404),
    [sym_sqr_tuple] = STATE(404),
    [sym_array] = STATE(404),
    [sym_sqr_array] = STATE(404),
    [sym_struct] = STATE(404),
    [sym_table] = STATE(404),
    [sym__special_forms] = STATE(404),
    [sym_def] = STATE(404),
    [sym_var] = STATE(404),
    [sym_quote] = STATE(404),
    [sym_splice] = STATE(404),
    [sym_quasiquote] = STATE(404),
    [sym_unquote] = STATE(404),
    [sym_break] = STATE(404),
    [sym_set] = STATE(404),
    [sym_if] = STATE(404),
    [sym_do] = STATE(404),
    [sym_while] = STATE(404),
    [sym_fn] = STATE(404),
    [sym__shorthand] = STATE(404),
    [sym_short_quote] = STATE(404),
    [sym_short_splice] = STATE(404),
    [sym_short_quasiquote] = STATE(404),
    [sym_short_unquote] = STATE(404),
    [sym_short_fn] = STATE(404),
    [sym__specials] = STATE(404),
    [sym_extra_defs] = STATE(404),
    [sym__literals] = STATE(404),
    [sym_long_str_literal] = STATE(404),
    [sym_long_buffer_literal] = STATE(404),
    [sym_number_literal] = STATE(404),
    [sym_bool_literal] = STATE(404),
    [sym__identifier] = STATE(404),
    [sym_symbol] = ACTIONS(760),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(762),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(764),
    [sym_buffer_literal] = ACTIONS(764),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(760),
    [sym_keyword] = ACTIONS(764),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [113] = {
    [sym__expr] = STATE(389),
    [sym_tuple] = STATE(389),
    [sym_sqr_tuple] = STATE(389),
    [sym_array] = STATE(389),
    [sym_sqr_array] = STATE(389),
    [sym_struct] = STATE(389),
    [sym_table] = STATE(389),
    [sym__special_forms] = STATE(389),
    [sym_def] = STATE(389),
    [sym_var] = STATE(389),
    [sym_quote] = STATE(389),
    [sym_splice] = STATE(389),
    [sym_quasiquote] = STATE(389),
    [sym_unquote] = STATE(389),
    [sym_break] = STATE(389),
    [sym_set] = STATE(389),
    [sym_if] = STATE(389),
    [sym_do] = STATE(389),
    [sym_while] = STATE(389),
    [sym_fn] = STATE(389),
    [sym__shorthand] = STATE(389),
    [sym_short_quote] = STATE(389),
    [sym_short_splice] = STATE(389),
    [sym_short_quasiquote] = STATE(389),
    [sym_short_unquote] = STATE(389),
    [sym_short_fn] = STATE(389),
    [sym__specials] = STATE(389),
    [sym_extra_defs] = STATE(389),
    [sym__literals] = STATE(389),
    [sym_long_str_literal] = STATE(389),
    [sym_long_buffer_literal] = STATE(389),
    [sym_number_literal] = STATE(389),
    [sym_bool_literal] = STATE(389),
    [sym__identifier] = STATE(389),
    [sym_symbol] = ACTIONS(766),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(768),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(770),
    [sym_buffer_literal] = ACTIONS(770),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(766),
    [sym_keyword] = ACTIONS(770),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [114] = {
    [sym__expr] = STATE(397),
    [sym_tuple] = STATE(397),
    [sym_sqr_tuple] = STATE(397),
    [sym_array] = STATE(397),
    [sym_sqr_array] = STATE(397),
    [sym_struct] = STATE(397),
    [sym_table] = STATE(397),
    [sym__special_forms] = STATE(397),
    [sym_def] = STATE(397),
    [sym_var] = STATE(397),
    [sym_quote] = STATE(397),
    [sym_splice] = STATE(397),
    [sym_quasiquote] = STATE(397),
    [sym_unquote] = STATE(397),
    [sym_break] = STATE(397),
    [sym_set] = STATE(397),
    [sym_if] = STATE(397),
    [sym_do] = STATE(397),
    [sym_while] = STATE(397),
    [sym_fn] = STATE(397),
    [sym__shorthand] = STATE(397),
    [sym_short_quote] = STATE(397),
    [sym_short_splice] = STATE(397),
    [sym_short_quasiquote] = STATE(397),
    [sym_short_unquote] = STATE(397),
    [sym_short_fn] = STATE(397),
    [sym__specials] = STATE(397),
    [sym_extra_defs] = STATE(397),
    [sym__literals] = STATE(397),
    [sym_long_str_literal] = STATE(397),
    [sym_long_buffer_literal] = STATE(397),
    [sym_number_literal] = STATE(397),
    [sym_bool_literal] = STATE(397),
    [sym__identifier] = STATE(397),
    [sym_symbol] = ACTIONS(772),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(774),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(776),
    [sym_buffer_literal] = ACTIONS(776),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(772),
    [sym_keyword] = ACTIONS(776),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [115] = {
    [sym__expr] = STATE(366),
    [sym_tuple] = STATE(366),
    [sym_sqr_tuple] = STATE(366),
    [sym_array] = STATE(366),
    [sym_sqr_array] = STATE(366),
    [sym_struct] = STATE(366),
    [sym_table] = STATE(366),
    [sym__special_forms] = STATE(366),
    [sym_def] = STATE(366),
    [sym_var] = STATE(366),
    [sym_quote] = STATE(366),
    [sym_splice] = STATE(366),
    [sym_quasiquote] = STATE(366),
    [sym_unquote] = STATE(366),
    [sym_break] = STATE(366),
    [sym_set] = STATE(366),
    [sym_if] = STATE(366),
    [sym_do] = STATE(366),
    [sym_while] = STATE(366),
    [sym_fn] = STATE(366),
    [sym__shorthand] = STATE(366),
    [sym_short_quote] = STATE(366),
    [sym_short_splice] = STATE(366),
    [sym_short_quasiquote] = STATE(366),
    [sym_short_unquote] = STATE(366),
    [sym_short_fn] = STATE(366),
    [sym__specials] = STATE(366),
    [sym_extra_defs] = STATE(366),
    [sym__literals] = STATE(366),
    [sym_long_str_literal] = STATE(366),
    [sym_long_buffer_literal] = STATE(366),
    [sym_number_literal] = STATE(366),
    [sym_bool_literal] = STATE(366),
    [sym__identifier] = STATE(366),
    [sym_symbol] = ACTIONS(778),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(780),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(782),
    [sym_buffer_literal] = ACTIONS(782),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(778),
    [sym_keyword] = ACTIONS(782),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [116] = {
    [sym__expr] = STATE(471),
    [sym_tuple] = STATE(471),
    [sym_sqr_tuple] = STATE(471),
    [sym_array] = STATE(471),
    [sym_sqr_array] = STATE(471),
    [sym_struct] = STATE(471),
    [sym_table] = STATE(471),
    [sym__special_forms] = STATE(471),
    [sym_def] = STATE(471),
    [sym_var] = STATE(471),
    [sym_quote] = STATE(471),
    [sym_splice] = STATE(471),
    [sym_quasiquote] = STATE(471),
    [sym_unquote] = STATE(471),
    [sym_break] = STATE(471),
    [sym_set] = STATE(471),
    [sym_if] = STATE(471),
    [sym_do] = STATE(471),
    [sym_while] = STATE(471),
    [sym_fn] = STATE(471),
    [sym__shorthand] = STATE(471),
    [sym_short_quote] = STATE(471),
    [sym_short_splice] = STATE(471),
    [sym_short_quasiquote] = STATE(471),
    [sym_short_unquote] = STATE(471),
    [sym_short_fn] = STATE(471),
    [sym__specials] = STATE(471),
    [sym_extra_defs] = STATE(471),
    [sym__literals] = STATE(471),
    [sym_long_str_literal] = STATE(471),
    [sym_long_buffer_literal] = STATE(471),
    [sym_number_literal] = STATE(471),
    [sym_bool_literal] = STATE(471),
    [sym__identifier] = STATE(471),
    [sym_symbol] = ACTIONS(784),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(786),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(788),
    [sym_buffer_literal] = ACTIONS(788),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(784),
    [sym_keyword] = ACTIONS(788),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [117] = {
    [sym__expr] = STATE(398),
    [sym_tuple] = STATE(398),
    [sym_sqr_tuple] = STATE(398),
    [sym_array] = STATE(398),
    [sym_sqr_array] = STATE(398),
    [sym_struct] = STATE(398),
    [sym_table] = STATE(398),
    [sym__special_forms] = STATE(398),
    [sym_def] = STATE(398),
    [sym_var] = STATE(398),
    [sym_quote] = STATE(398),
    [sym_splice] = STATE(398),
    [sym_quasiquote] = STATE(398),
    [sym_unquote] = STATE(398),
    [sym_break] = STATE(398),
    [sym_set] = STATE(398),
    [sym_if] = STATE(398),
    [sym_do] = STATE(398),
    [sym_while] = STATE(398),
    [sym_fn] = STATE(398),
    [sym__shorthand] = STATE(398),
    [sym_short_quote] = STATE(398),
    [sym_short_splice] = STATE(398),
    [sym_short_quasiquote] = STATE(398),
    [sym_short_unquote] = STATE(398),
    [sym_short_fn] = STATE(398),
    [sym__specials] = STATE(398),
    [sym_extra_defs] = STATE(398),
    [sym__literals] = STATE(398),
    [sym_long_str_literal] = STATE(398),
    [sym_long_buffer_literal] = STATE(398),
    [sym_number_literal] = STATE(398),
    [sym_bool_literal] = STATE(398),
    [sym__identifier] = STATE(398),
    [sym_symbol] = ACTIONS(790),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_RPAREN] = ACTIONS(792),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(794),
    [sym_buffer_literal] = ACTIONS(794),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(790),
    [sym_keyword] = ACTIONS(794),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [118] = {
    [sym__expr] = STATE(394),
    [sym_tuple] = STATE(394),
    [sym_sqr_tuple] = STATE(394),
    [sym_array] = STATE(394),
    [sym_sqr_array] = STATE(394),
    [sym_struct] = STATE(394),
    [sym_table] = STATE(394),
    [sym__special_forms] = STATE(394),
    [sym_def] = STATE(394),
    [sym_var] = STATE(394),
    [sym_quote] = STATE(394),
    [sym_splice] = STATE(394),
    [sym_quasiquote] = STATE(394),
    [sym_unquote] = STATE(394),
    [sym_break] = STATE(394),
    [sym_set] = STATE(394),
    [sym_if] = STATE(394),
    [sym_do] = STATE(394),
    [sym_while] = STATE(394),
    [sym_fn] = STATE(394),
    [sym__shorthand] = STATE(394),
    [sym_short_quote] = STATE(394),
    [sym_short_splice] = STATE(394),
    [sym_short_quasiquote] = STATE(394),
    [sym_short_unquote] = STATE(394),
    [sym_short_fn] = STATE(394),
    [sym__specials] = STATE(394),
    [sym_extra_defs] = STATE(394),
    [sym__literals] = STATE(394),
    [sym_long_str_literal] = STATE(394),
    [sym_long_buffer_literal] = STATE(394),
    [sym_number_literal] = STATE(394),
    [sym_bool_literal] = STATE(394),
    [sym__identifier] = STATE(394),
    [sym_symbol] = ACTIONS(796),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(798),
    [sym_buffer_literal] = ACTIONS(798),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(796),
    [sym_keyword] = ACTIONS(798),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [119] = {
    [sym__expr] = STATE(190),
    [sym_tuple] = STATE(190),
    [sym_sqr_tuple] = STATE(190),
    [sym_array] = STATE(190),
    [sym_sqr_array] = STATE(190),
    [sym_struct] = STATE(190),
    [sym_table] = STATE(190),
    [sym__special_forms] = STATE(190),
    [sym_def] = STATE(190),
    [sym_var] = STATE(190),
    [sym_quote] = STATE(190),
    [sym_splice] = STATE(190),
    [sym_quasiquote] = STATE(190),
    [sym_unquote] = STATE(190),
    [sym_break] = STATE(190),
    [sym_set] = STATE(190),
    [sym_if] = STATE(190),
    [sym_do] = STATE(190),
    [sym_while] = STATE(190),
    [sym_fn] = STATE(190),
    [sym__shorthand] = STATE(190),
    [sym_short_quote] = STATE(190),
    [sym_short_splice] = STATE(190),
    [sym_short_quasiquote] = STATE(190),
    [sym_short_unquote] = STATE(190),
    [sym_short_fn] = STATE(190),
    [sym__specials] = STATE(190),
    [sym_extra_defs] = STATE(190),
    [sym__literals] = STATE(190),
    [sym_long_str_literal] = STATE(190),
    [sym_long_buffer_literal] = STATE(190),
    [sym_number_literal] = STATE(190),
    [sym_bool_literal] = STATE(190),
    [sym__identifier] = STATE(190),
    [sym_symbol] = ACTIONS(800),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(802),
    [sym_buffer_literal] = ACTIONS(802),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(800),
    [sym_keyword] = ACTIONS(802),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [120] = {
    [sym__expr] = STATE(166),
    [sym_tuple] = STATE(166),
    [sym_sqr_tuple] = STATE(166),
    [sym_array] = STATE(166),
    [sym_sqr_array] = STATE(166),
    [sym_struct] = STATE(166),
    [sym_table] = STATE(166),
    [sym__special_forms] = STATE(166),
    [sym_def] = STATE(166),
    [sym_var] = STATE(166),
    [sym_quote] = STATE(166),
    [sym_splice] = STATE(166),
    [sym_quasiquote] = STATE(166),
    [sym_unquote] = STATE(166),
    [sym_break] = STATE(166),
    [sym_set] = STATE(166),
    [sym_if] = STATE(166),
    [sym_do] = STATE(166),
    [sym_while] = STATE(166),
    [sym_fn] = STATE(166),
    [sym__shorthand] = STATE(166),
    [sym_short_quote] = STATE(166),
    [sym_short_splice] = STATE(166),
    [sym_short_quasiquote] = STATE(166),
    [sym_short_unquote] = STATE(166),
    [sym_short_fn] = STATE(166),
    [sym__specials] = STATE(166),
    [sym_extra_defs] = STATE(166),
    [sym__literals] = STATE(166),
    [sym_long_str_literal] = STATE(166),
    [sym_long_buffer_literal] = STATE(166),
    [sym_number_literal] = STATE(166),
    [sym_bool_literal] = STATE(166),
    [sym__identifier] = STATE(166),
    [sym_symbol] = ACTIONS(804),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(806),
    [sym_buffer_literal] = ACTIONS(806),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(804),
    [sym_keyword] = ACTIONS(806),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [121] = {
    [sym__expr] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_sqr_tuple] = STATE(152),
    [sym_array] = STATE(152),
    [sym_sqr_array] = STATE(152),
    [sym_struct] = STATE(152),
    [sym_table] = STATE(152),
    [sym__special_forms] = STATE(152),
    [sym_def] = STATE(152),
    [sym_var] = STATE(152),
    [sym_quote] = STATE(152),
    [sym_splice] = STATE(152),
    [sym_quasiquote] = STATE(152),
    [sym_unquote] = STATE(152),
    [sym_break] = STATE(152),
    [sym_set] = STATE(152),
    [sym_if] = STATE(152),
    [sym_do] = STATE(152),
    [sym_while] = STATE(152),
    [sym_fn] = STATE(152),
    [sym__shorthand] = STATE(152),
    [sym_short_quote] = STATE(152),
    [sym_short_splice] = STATE(152),
    [sym_short_quasiquote] = STATE(152),
    [sym_short_unquote] = STATE(152),
    [sym_short_fn] = STATE(152),
    [sym__specials] = STATE(152),
    [sym_extra_defs] = STATE(152),
    [sym__literals] = STATE(152),
    [sym_long_str_literal] = STATE(152),
    [sym_long_buffer_literal] = STATE(152),
    [sym_number_literal] = STATE(152),
    [sym_bool_literal] = STATE(152),
    [sym__identifier] = STATE(152),
    [sym_symbol] = ACTIONS(808),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(810),
    [sym_buffer_literal] = ACTIONS(810),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(808),
    [sym_keyword] = ACTIONS(810),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [122] = {
    [sym__expr] = STATE(286),
    [sym_tuple] = STATE(286),
    [sym_sqr_tuple] = STATE(286),
    [sym_array] = STATE(286),
    [sym_sqr_array] = STATE(286),
    [sym_struct] = STATE(286),
    [sym_table] = STATE(286),
    [sym__special_forms] = STATE(286),
    [sym_def] = STATE(286),
    [sym_var] = STATE(286),
    [sym_quote] = STATE(286),
    [sym_splice] = STATE(286),
    [sym_quasiquote] = STATE(286),
    [sym_unquote] = STATE(286),
    [sym_break] = STATE(286),
    [sym_set] = STATE(286),
    [sym_if] = STATE(286),
    [sym_do] = STATE(286),
    [sym_while] = STATE(286),
    [sym_fn] = STATE(286),
    [sym__shorthand] = STATE(286),
    [sym_short_quote] = STATE(286),
    [sym_short_splice] = STATE(286),
    [sym_short_quasiquote] = STATE(286),
    [sym_short_unquote] = STATE(286),
    [sym_short_fn] = STATE(286),
    [sym__specials] = STATE(286),
    [sym_extra_defs] = STATE(286),
    [sym__literals] = STATE(286),
    [sym_long_str_literal] = STATE(286),
    [sym_long_buffer_literal] = STATE(286),
    [sym_number_literal] = STATE(286),
    [sym_bool_literal] = STATE(286),
    [sym__identifier] = STATE(286),
    [sym_symbol] = ACTIONS(812),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(814),
    [sym_buffer_literal] = ACTIONS(814),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(812),
    [sym_keyword] = ACTIONS(814),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [123] = {
    [sym__expr] = STATE(472),
    [sym_tuple] = STATE(472),
    [sym_sqr_tuple] = STATE(472),
    [sym_array] = STATE(472),
    [sym_sqr_array] = STATE(472),
    [sym_struct] = STATE(472),
    [sym_table] = STATE(472),
    [sym__special_forms] = STATE(472),
    [sym_def] = STATE(472),
    [sym_var] = STATE(472),
    [sym_quote] = STATE(472),
    [sym_splice] = STATE(472),
    [sym_quasiquote] = STATE(472),
    [sym_unquote] = STATE(472),
    [sym_break] = STATE(472),
    [sym_set] = STATE(472),
    [sym_if] = STATE(472),
    [sym_do] = STATE(472),
    [sym_while] = STATE(472),
    [sym_fn] = STATE(472),
    [sym__shorthand] = STATE(472),
    [sym_short_quote] = STATE(472),
    [sym_short_splice] = STATE(472),
    [sym_short_quasiquote] = STATE(472),
    [sym_short_unquote] = STATE(472),
    [sym_short_fn] = STATE(472),
    [sym__specials] = STATE(472),
    [sym_extra_defs] = STATE(472),
    [sym__literals] = STATE(472),
    [sym_long_str_literal] = STATE(472),
    [sym_long_buffer_literal] = STATE(472),
    [sym_number_literal] = STATE(472),
    [sym_bool_literal] = STATE(472),
    [sym__identifier] = STATE(472),
    [sym_symbol] = ACTIONS(816),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(818),
    [sym_buffer_literal] = ACTIONS(818),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(816),
    [sym_keyword] = ACTIONS(818),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [124] = {
    [sym__expr] = STATE(73),
    [sym_tuple] = STATE(73),
    [sym_sqr_tuple] = STATE(73),
    [sym_array] = STATE(73),
    [sym_sqr_array] = STATE(73),
    [sym_struct] = STATE(73),
    [sym_table] = STATE(73),
    [sym__special_forms] = STATE(73),
    [sym_def] = STATE(73),
    [sym_var] = STATE(73),
    [sym_quote] = STATE(73),
    [sym_splice] = STATE(73),
    [sym_quasiquote] = STATE(73),
    [sym_unquote] = STATE(73),
    [sym_break] = STATE(73),
    [sym_set] = STATE(73),
    [sym_if] = STATE(73),
    [sym_do] = STATE(73),
    [sym_while] = STATE(73),
    [sym_fn] = STATE(73),
    [sym__shorthand] = STATE(73),
    [sym_short_quote] = STATE(73),
    [sym_short_splice] = STATE(73),
    [sym_short_quasiquote] = STATE(73),
    [sym_short_unquote] = STATE(73),
    [sym_short_fn] = STATE(73),
    [sym__specials] = STATE(73),
    [sym_extra_defs] = STATE(73),
    [sym__literals] = STATE(73),
    [sym_long_str_literal] = STATE(73),
    [sym_long_buffer_literal] = STATE(73),
    [sym_number_literal] = STATE(73),
    [sym_bool_literal] = STATE(73),
    [sym__identifier] = STATE(73),
    [sym_symbol] = ACTIONS(820),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(822),
    [sym_buffer_literal] = ACTIONS(822),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(820),
    [sym_keyword] = ACTIONS(822),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [125] = {
    [sym__expr] = STATE(76),
    [sym_tuple] = STATE(76),
    [sym_sqr_tuple] = STATE(76),
    [sym_array] = STATE(76),
    [sym_sqr_array] = STATE(76),
    [sym_struct] = STATE(76),
    [sym_table] = STATE(76),
    [sym__special_forms] = STATE(76),
    [sym_def] = STATE(76),
    [sym_var] = STATE(76),
    [sym_quote] = STATE(76),
    [sym_splice] = STATE(76),
    [sym_quasiquote] = STATE(76),
    [sym_unquote] = STATE(76),
    [sym_break] = STATE(76),
    [sym_set] = STATE(76),
    [sym_if] = STATE(76),
    [sym_do] = STATE(76),
    [sym_while] = STATE(76),
    [sym_fn] = STATE(76),
    [sym__shorthand] = STATE(76),
    [sym_short_quote] = STATE(76),
    [sym_short_splice] = STATE(76),
    [sym_short_quasiquote] = STATE(76),
    [sym_short_unquote] = STATE(76),
    [sym_short_fn] = STATE(76),
    [sym__specials] = STATE(76),
    [sym_extra_defs] = STATE(76),
    [sym__literals] = STATE(76),
    [sym_long_str_literal] = STATE(76),
    [sym_long_buffer_literal] = STATE(76),
    [sym_number_literal] = STATE(76),
    [sym_bool_literal] = STATE(76),
    [sym__identifier] = STATE(76),
    [sym_symbol] = ACTIONS(824),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(826),
    [sym_buffer_literal] = ACTIONS(826),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(824),
    [sym_keyword] = ACTIONS(826),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [126] = {
    [sym__expr] = STATE(350),
    [sym_tuple] = STATE(350),
    [sym_sqr_tuple] = STATE(350),
    [sym_array] = STATE(350),
    [sym_sqr_array] = STATE(350),
    [sym_struct] = STATE(350),
    [sym_table] = STATE(350),
    [sym__special_forms] = STATE(350),
    [sym_def] = STATE(350),
    [sym_var] = STATE(350),
    [sym_quote] = STATE(350),
    [sym_splice] = STATE(350),
    [sym_quasiquote] = STATE(350),
    [sym_unquote] = STATE(350),
    [sym_break] = STATE(350),
    [sym_set] = STATE(350),
    [sym_if] = STATE(350),
    [sym_do] = STATE(350),
    [sym_while] = STATE(350),
    [sym_fn] = STATE(350),
    [sym__shorthand] = STATE(350),
    [sym_short_quote] = STATE(350),
    [sym_short_splice] = STATE(350),
    [sym_short_quasiquote] = STATE(350),
    [sym_short_unquote] = STATE(350),
    [sym_short_fn] = STATE(350),
    [sym__specials] = STATE(350),
    [sym_extra_defs] = STATE(350),
    [sym__literals] = STATE(350),
    [sym_long_str_literal] = STATE(350),
    [sym_long_buffer_literal] = STATE(350),
    [sym_number_literal] = STATE(350),
    [sym_bool_literal] = STATE(350),
    [sym__identifier] = STATE(350),
    [sym_symbol] = ACTIONS(828),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(832),
    [anon_sym_AT_LPAREN] = ACTIONS(834),
    [anon_sym_AT_LBRACK] = ACTIONS(836),
    [anon_sym_LBRACE] = ACTIONS(838),
    [anon_sym_AT_LBRACE] = ACTIONS(840),
    [anon_sym_SQUOTE] = ACTIONS(842),
    [anon_sym_SEMI] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_PIPE] = ACTIONS(850),
    [sym_str_literal] = ACTIONS(852),
    [sym_buffer_literal] = ACTIONS(852),
    [aux_sym_number_literal_token1] = ACTIONS(854),
    [aux_sym_number_literal_token2] = ACTIONS(854),
    [aux_sym_number_literal_token3] = ACTIONS(854),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(856),
    [sym_nil_literal] = ACTIONS(828),
    [sym_keyword] = ACTIONS(852),
    [sym__long_str] = ACTIONS(858),
    [sym__long_buffer] = ACTIONS(860),
  },
  [127] = {
    [sym__expr] = STATE(313),
    [sym_tuple] = STATE(313),
    [sym_sqr_tuple] = STATE(313),
    [sym_array] = STATE(313),
    [sym_sqr_array] = STATE(313),
    [sym_struct] = STATE(313),
    [sym_table] = STATE(313),
    [sym__special_forms] = STATE(313),
    [sym_def] = STATE(313),
    [sym_var] = STATE(313),
    [sym_quote] = STATE(313),
    [sym_splice] = STATE(313),
    [sym_quasiquote] = STATE(313),
    [sym_unquote] = STATE(313),
    [sym_break] = STATE(313),
    [sym_set] = STATE(313),
    [sym_if] = STATE(313),
    [sym_do] = STATE(313),
    [sym_while] = STATE(313),
    [sym_fn] = STATE(313),
    [sym__shorthand] = STATE(313),
    [sym_short_quote] = STATE(313),
    [sym_short_splice] = STATE(313),
    [sym_short_quasiquote] = STATE(313),
    [sym_short_unquote] = STATE(313),
    [sym_short_fn] = STATE(313),
    [sym__specials] = STATE(313),
    [sym_extra_defs] = STATE(313),
    [sym__literals] = STATE(313),
    [sym_long_str_literal] = STATE(313),
    [sym_long_buffer_literal] = STATE(313),
    [sym_number_literal] = STATE(313),
    [sym_bool_literal] = STATE(313),
    [sym__identifier] = STATE(313),
    [sym_symbol] = ACTIONS(862),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(832),
    [anon_sym_AT_LPAREN] = ACTIONS(834),
    [anon_sym_AT_LBRACK] = ACTIONS(836),
    [anon_sym_LBRACE] = ACTIONS(838),
    [anon_sym_AT_LBRACE] = ACTIONS(840),
    [anon_sym_SQUOTE] = ACTIONS(842),
    [anon_sym_SEMI] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_PIPE] = ACTIONS(850),
    [sym_str_literal] = ACTIONS(864),
    [sym_buffer_literal] = ACTIONS(864),
    [aux_sym_number_literal_token1] = ACTIONS(854),
    [aux_sym_number_literal_token2] = ACTIONS(854),
    [aux_sym_number_literal_token3] = ACTIONS(854),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(856),
    [sym_nil_literal] = ACTIONS(862),
    [sym_keyword] = ACTIONS(864),
    [sym__long_str] = ACTIONS(858),
    [sym__long_buffer] = ACTIONS(860),
  },
  [128] = {
    [sym__expr] = STATE(272),
    [sym_tuple] = STATE(272),
    [sym_sqr_tuple] = STATE(272),
    [sym_array] = STATE(272),
    [sym_sqr_array] = STATE(272),
    [sym_struct] = STATE(272),
    [sym_table] = STATE(272),
    [sym__special_forms] = STATE(272),
    [sym_def] = STATE(272),
    [sym_var] = STATE(272),
    [sym_quote] = STATE(272),
    [sym_splice] = STATE(272),
    [sym_quasiquote] = STATE(272),
    [sym_unquote] = STATE(272),
    [sym_break] = STATE(272),
    [sym_set] = STATE(272),
    [sym_if] = STATE(272),
    [sym_do] = STATE(272),
    [sym_while] = STATE(272),
    [sym_fn] = STATE(272),
    [sym__shorthand] = STATE(272),
    [sym_short_quote] = STATE(272),
    [sym_short_splice] = STATE(272),
    [sym_short_quasiquote] = STATE(272),
    [sym_short_unquote] = STATE(272),
    [sym_short_fn] = STATE(272),
    [sym__specials] = STATE(272),
    [sym_extra_defs] = STATE(272),
    [sym__literals] = STATE(272),
    [sym_long_str_literal] = STATE(272),
    [sym_long_buffer_literal] = STATE(272),
    [sym_number_literal] = STATE(272),
    [sym_bool_literal] = STATE(272),
    [sym__identifier] = STATE(272),
    [sym_symbol] = ACTIONS(866),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(868),
    [sym_buffer_literal] = ACTIONS(868),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(866),
    [sym_keyword] = ACTIONS(868),
    [sym__long_str] = ACTIONS(37),
    [sym__long_buffer] = ACTIONS(39),
  },
  [129] = {
    [sym__expr] = STATE(351),
    [sym_tuple] = STATE(351),
    [sym_sqr_tuple] = STATE(351),
    [sym_array] = STATE(351),
    [sym_sqr_array] = STATE(351),
    [sym_struct] = STATE(351),
    [sym_table] = STATE(351),
    [sym__special_forms] = STATE(351),
    [sym_def] = STATE(351),
    [sym_var] = STATE(351),
    [sym_quote] = STATE(351),
    [sym_splice] = STATE(351),
    [sym_quasiquote] = STATE(351),
    [sym_unquote] = STATE(351),
    [sym_break] = STATE(351),
    [sym_set] = STATE(351),
    [sym_if] = STATE(351),
    [sym_do] = STATE(351),
    [sym_while] = STATE(351),
    [sym_fn] = STATE(351),
    [sym__shorthand] = STATE(351),
    [sym_short_quote] = STATE(351),
    [sym_short_splice] = STATE(351),
    [sym_short_quasiquote] = STATE(351),
    [sym_short_unquote] = STATE(351),
    [sym_short_fn] = STATE(351),
    [sym__specials] = STATE(351),
    [sym_extra_defs] = STATE(351),
    [sym__literals] = STATE(351),
    [sym_long_str_literal] = STATE(351),
    [sym_long_buffer_literal] = STATE(351),
    [sym_number_literal] = STATE(351),
    [sym_bool_literal] = STATE(351),
    [sym__identifier] = STATE(351),
    [sym_symbol] = ACTIONS(870),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(832),
    [anon_sym_AT_LPAREN] = ACTIONS(834),
    [anon_sym_AT_LBRACK] = ACTIONS(836),
    [anon_sym_LBRACE] = ACTIONS(838),
    [anon_sym_AT_LBRACE] = ACTIONS(840),
    [anon_sym_SQUOTE] = ACTIONS(842),
    [anon_sym_SEMI] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_PIPE] = ACTIONS(850),
    [sym_str_literal] = ACTIONS(872),
    [sym_buffer_literal] = ACTIONS(872),
    [aux_sym_number_literal_token1] = ACTIONS(854),
    [aux_sym_number_literal_token2] = ACTIONS(854),
    [aux_sym_number_literal_token3] = ACTIONS(854),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(856),
    [sym_nil_literal] = ACTIONS(870),
    [sym_keyword] = ACTIONS(872),
    [sym__long_str] = ACTIONS(858),
    [sym__long_buffer] = ACTIONS(860),
  },
  [130] = {
    [sym__expr] = STATE(352),
    [sym_tuple] = STATE(352),
    [sym_sqr_tuple] = STATE(352),
    [sym_array] = STATE(352),
    [sym_sqr_array] = STATE(352),
    [sym_struct] = STATE(352),
    [sym_table] = STATE(352),
    [sym__special_forms] = STATE(352),
    [sym_def] = STATE(352),
    [sym_var] = STATE(352),
    [sym_quote] = STATE(352),
    [sym_splice] = STATE(352),
    [sym_quasiquote] = STATE(352),
    [sym_unquote] = STATE(352),
    [sym_break] = STATE(352),
    [sym_set] = STATE(352),
    [sym_if] = STATE(352),
    [sym_do] = STATE(352),
    [sym_while] = STATE(352),
    [sym_fn] = STATE(352),
    [sym__shorthand] = STATE(352),
    [sym_short_quote] = STATE(352),
    [sym_short_splice] = STATE(352),
    [sym_short_quasiquote] = STATE(352),
    [sym_short_unquote] = STATE(352),
    [sym_short_fn] = STATE(352),
    [sym__specials] = STATE(352),
    [sym_extra_defs] = STATE(352),
    [sym__literals] = STATE(352),
    [sym_long_str_literal] = STATE(352),
    [sym_long_buffer_literal] = STATE(352),
    [sym_number_literal] = STATE(352),
    [sym_bool_literal] = STATE(352),
    [sym__identifier] = STATE(352),
    [sym_symbol] = ACTIONS(874),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(832),
    [anon_sym_AT_LPAREN] = ACTIONS(834),
    [anon_sym_AT_LBRACK] = ACTIONS(836),
    [anon_sym_LBRACE] = ACTIONS(838),
    [anon_sym_AT_LBRACE] = ACTIONS(840),
    [anon_sym_SQUOTE] = ACTIONS(842),
    [anon_sym_SEMI] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_PIPE] = ACTIONS(850),
    [sym_str_literal] = ACTIONS(876),
    [sym_buffer_literal] = ACTIONS(876),
    [aux_sym_number_literal_token1] = ACTIONS(854),
    [aux_sym_number_literal_token2] = ACTIONS(854),
    [aux_sym_number_literal_token3] = ACTIONS(854),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(856),
    [sym_nil_literal] = ACTIONS(874),
    [sym_keyword] = ACTIONS(876),
    [sym__long_str] = ACTIONS(858),
    [sym__long_buffer] = ACTIONS(860),
  },
  [131] = {
    [sym__expr] = STATE(353),
    [sym_tuple] = STATE(353),
    [sym_sqr_tuple] = STATE(353),
    [sym_array] = STATE(353),
    [sym_sqr_array] = STATE(353),
    [sym_struct] = STATE(353),
    [sym_table] = STATE(353),
    [sym__special_forms] = STATE(353),
    [sym_def] = STATE(353),
    [sym_var] = STATE(353),
    [sym_quote] = STATE(353),
    [sym_splice] = STATE(353),
    [sym_quasiquote] = STATE(353),
    [sym_unquote] = STATE(353),
    [sym_break] = STATE(353),
    [sym_set] = STATE(353),
    [sym_if] = STATE(353),
    [sym_do] = STATE(353),
    [sym_while] = STATE(353),
    [sym_fn] = STATE(353),
    [sym__shorthand] = STATE(353),
    [sym_short_quote] = STATE(353),
    [sym_short_splice] = STATE(353),
    [sym_short_quasiquote] = STATE(353),
    [sym_short_unquote] = STATE(353),
    [sym_short_fn] = STATE(353),
    [sym__specials] = STATE(353),
    [sym_extra_defs] = STATE(353),
    [sym__literals] = STATE(353),
    [sym_long_str_literal] = STATE(353),
    [sym_long_buffer_literal] = STATE(353),
    [sym_number_literal] = STATE(353),
    [sym_bool_literal] = STATE(353),
    [sym__identifier] = STATE(353),
    [sym_symbol] = ACTIONS(878),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(830),
    [anon_sym_LBRACK] = ACTIONS(832),
    [anon_sym_AT_LPAREN] = ACTIONS(834),
    [anon_sym_AT_LBRACK] = ACTIONS(836),
    [anon_sym_LBRACE] = ACTIONS(838),
    [anon_sym_AT_LBRACE] = ACTIONS(840),
    [anon_sym_SQUOTE] = ACTIONS(842),
    [anon_sym_SEMI] = ACTIONS(844),
    [anon_sym_TILDE] = ACTIONS(846),
    [anon_sym_COMMA] = ACTIONS(848),
    [anon_sym_PIPE] = ACTIONS(850),
    [sym_str_literal] = ACTIONS(880),
    [sym_buffer_literal] = ACTIONS(880),
    [aux_sym_number_literal_token1] = ACTIONS(854),
    [aux_sym_number_literal_token2] = ACTIONS(854),
    [aux_sym_number_literal_token3] = ACTIONS(854),
    [anon_sym_true] = ACTIONS(856),
    [anon_sym_false] = ACTIONS(856),
    [sym_nil_literal] = ACTIONS(878),
    [sym_keyword] = ACTIONS(880),
    [sym__long_str] = ACTIONS(858),
    [sym__long_buffer] = ACTIONS(860),
  },
  [132] = {
    [sym__expr] = STATE(57),
    [sym_tuple] = STATE(57),
    [sym_sqr_tuple] = STATE(57),
    [sym_array] = STATE(57),
    [sym_sqr_array] = STATE(57),
    [sym_struct] = STATE(57),
    [sym_table] = STATE(57),
    [sym__special_forms] = STATE(57),
    [sym_def] = STATE(57),
    [sym_var] = STATE(57),
    [sym_quote] = STATE(57),
    [sym_splice] = STATE(57),
    [sym_quasiquote] = STATE(57),
    [sym_unquote] = STATE(57),
    [sym_break] = STATE(57),
    [sym_set] = STATE(57),
    [sym_if] = STATE(57),
    [sym_do] = STATE(57),
    [sym_while] = STATE(57),
    [sym_fn] = STATE(57),
    [sym__shorthand] = STATE(57),
    [sym_short_quote] = STATE(57),
    [sym_short_splice] = STATE(57),
    [sym_short_quasiquote] = STATE(57),
    [sym_short_unquote] = STATE(57),
    [sym_short_fn] = STATE(57),
    [sym__specials] = STATE(57),
    [sym_extra_defs] = STATE(57),
    [sym__literals] = STATE(57),
    [sym_long_str_literal] = STATE(57),
    [sym_long_buffer_literal] = STATE(57),
    [sym_number_literal] = STATE(57),
    [sym_bool_literal] = STATE(57),
    [sym__identifier] = STATE(57),
    [sym_symbol] = ACTIONS(882),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(884),
    [sym_buffer_literal] = ACTIONS(884),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(882),
    [sym_keyword] = ACTIONS(884),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [133] = {
    [sym__expr] = STATE(271),
    [sym_tuple] = STATE(271),
    [sym_sqr_tuple] = STATE(271),
    [sym_array] = STATE(271),
    [sym_sqr_array] = STATE(271),
    [sym_struct] = STATE(271),
    [sym_table] = STATE(271),
    [sym__special_forms] = STATE(271),
    [sym_def] = STATE(271),
    [sym_var] = STATE(271),
    [sym_quote] = STATE(271),
    [sym_splice] = STATE(271),
    [sym_quasiquote] = STATE(271),
    [sym_unquote] = STATE(271),
    [sym_break] = STATE(271),
    [sym_set] = STATE(271),
    [sym_if] = STATE(271),
    [sym_do] = STATE(271),
    [sym_while] = STATE(271),
    [sym_fn] = STATE(271),
    [sym__shorthand] = STATE(271),
    [sym_short_quote] = STATE(271),
    [sym_short_splice] = STATE(271),
    [sym_short_quasiquote] = STATE(271),
    [sym_short_unquote] = STATE(271),
    [sym_short_fn] = STATE(271),
    [sym__specials] = STATE(271),
    [sym_extra_defs] = STATE(271),
    [sym__literals] = STATE(271),
    [sym_long_str_literal] = STATE(271),
    [sym_long_buffer_literal] = STATE(271),
    [sym_number_literal] = STATE(271),
    [sym_bool_literal] = STATE(271),
    [sym__identifier] = STATE(271),
    [sym_symbol] = ACTIONS(886),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(888),
    [sym_buffer_literal] = ACTIONS(888),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(886),
    [sym_keyword] = ACTIONS(888),
    [sym__long_str] = ACTIONS(37),
    [sym__long_buffer] = ACTIONS(39),
  },
  [134] = {
    [sym__expr] = STATE(270),
    [sym_tuple] = STATE(270),
    [sym_sqr_tuple] = STATE(270),
    [sym_array] = STATE(270),
    [sym_sqr_array] = STATE(270),
    [sym_struct] = STATE(270),
    [sym_table] = STATE(270),
    [sym__special_forms] = STATE(270),
    [sym_def] = STATE(270),
    [sym_var] = STATE(270),
    [sym_quote] = STATE(270),
    [sym_splice] = STATE(270),
    [sym_quasiquote] = STATE(270),
    [sym_unquote] = STATE(270),
    [sym_break] = STATE(270),
    [sym_set] = STATE(270),
    [sym_if] = STATE(270),
    [sym_do] = STATE(270),
    [sym_while] = STATE(270),
    [sym_fn] = STATE(270),
    [sym__shorthand] = STATE(270),
    [sym_short_quote] = STATE(270),
    [sym_short_splice] = STATE(270),
    [sym_short_quasiquote] = STATE(270),
    [sym_short_unquote] = STATE(270),
    [sym_short_fn] = STATE(270),
    [sym__specials] = STATE(270),
    [sym_extra_defs] = STATE(270),
    [sym__literals] = STATE(270),
    [sym_long_str_literal] = STATE(270),
    [sym_long_buffer_literal] = STATE(270),
    [sym_number_literal] = STATE(270),
    [sym_bool_literal] = STATE(270),
    [sym__identifier] = STATE(270),
    [sym_symbol] = ACTIONS(890),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(892),
    [sym_buffer_literal] = ACTIONS(892),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(890),
    [sym_keyword] = ACTIONS(892),
    [sym__long_str] = ACTIONS(37),
    [sym__long_buffer] = ACTIONS(39),
  },
  [135] = {
    [sym__expr] = STATE(110),
    [sym_tuple] = STATE(110),
    [sym_sqr_tuple] = STATE(110),
    [sym_array] = STATE(110),
    [sym_sqr_array] = STATE(110),
    [sym_struct] = STATE(110),
    [sym_table] = STATE(110),
    [sym__special_forms] = STATE(110),
    [sym_def] = STATE(110),
    [sym_var] = STATE(110),
    [sym_quote] = STATE(110),
    [sym_splice] = STATE(110),
    [sym_quasiquote] = STATE(110),
    [sym_unquote] = STATE(110),
    [sym_break] = STATE(110),
    [sym_set] = STATE(110),
    [sym_if] = STATE(110),
    [sym_do] = STATE(110),
    [sym_while] = STATE(110),
    [sym_fn] = STATE(110),
    [sym__shorthand] = STATE(110),
    [sym_short_quote] = STATE(110),
    [sym_short_splice] = STATE(110),
    [sym_short_quasiquote] = STATE(110),
    [sym_short_unquote] = STATE(110),
    [sym_short_fn] = STATE(110),
    [sym__specials] = STATE(110),
    [sym_extra_defs] = STATE(110),
    [sym__literals] = STATE(110),
    [sym_long_str_literal] = STATE(110),
    [sym_long_buffer_literal] = STATE(110),
    [sym_number_literal] = STATE(110),
    [sym_bool_literal] = STATE(110),
    [sym__identifier] = STATE(110),
    [sym_symbol] = ACTIONS(894),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(896),
    [sym_buffer_literal] = ACTIONS(896),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(894),
    [sym_keyword] = ACTIONS(896),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [136] = {
    [sym__expr] = STATE(162),
    [sym_tuple] = STATE(162),
    [sym_sqr_tuple] = STATE(162),
    [sym_array] = STATE(162),
    [sym_sqr_array] = STATE(162),
    [sym_struct] = STATE(162),
    [sym_table] = STATE(162),
    [sym__special_forms] = STATE(162),
    [sym_def] = STATE(162),
    [sym_var] = STATE(162),
    [sym_quote] = STATE(162),
    [sym_splice] = STATE(162),
    [sym_quasiquote] = STATE(162),
    [sym_unquote] = STATE(162),
    [sym_break] = STATE(162),
    [sym_set] = STATE(162),
    [sym_if] = STATE(162),
    [sym_do] = STATE(162),
    [sym_while] = STATE(162),
    [sym_fn] = STATE(162),
    [sym__shorthand] = STATE(162),
    [sym_short_quote] = STATE(162),
    [sym_short_splice] = STATE(162),
    [sym_short_quasiquote] = STATE(162),
    [sym_short_unquote] = STATE(162),
    [sym_short_fn] = STATE(162),
    [sym__specials] = STATE(162),
    [sym_extra_defs] = STATE(162),
    [sym__literals] = STATE(162),
    [sym_long_str_literal] = STATE(162),
    [sym_long_buffer_literal] = STATE(162),
    [sym_number_literal] = STATE(162),
    [sym_bool_literal] = STATE(162),
    [sym__identifier] = STATE(162),
    [sym_symbol] = ACTIONS(898),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(900),
    [sym_buffer_literal] = ACTIONS(900),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(898),
    [sym_keyword] = ACTIONS(900),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [137] = {
    [sym__expr] = STATE(381),
    [sym_tuple] = STATE(381),
    [sym_sqr_tuple] = STATE(381),
    [sym_array] = STATE(381),
    [sym_sqr_array] = STATE(381),
    [sym_struct] = STATE(381),
    [sym_table] = STATE(381),
    [sym__special_forms] = STATE(381),
    [sym_def] = STATE(381),
    [sym_var] = STATE(381),
    [sym_quote] = STATE(381),
    [sym_splice] = STATE(381),
    [sym_quasiquote] = STATE(381),
    [sym_unquote] = STATE(381),
    [sym_break] = STATE(381),
    [sym_set] = STATE(381),
    [sym_if] = STATE(381),
    [sym_do] = STATE(381),
    [sym_while] = STATE(381),
    [sym_fn] = STATE(381),
    [sym__shorthand] = STATE(381),
    [sym_short_quote] = STATE(381),
    [sym_short_splice] = STATE(381),
    [sym_short_quasiquote] = STATE(381),
    [sym_short_unquote] = STATE(381),
    [sym_short_fn] = STATE(381),
    [sym__specials] = STATE(381),
    [sym_extra_defs] = STATE(381),
    [sym__literals] = STATE(381),
    [sym_long_str_literal] = STATE(381),
    [sym_long_buffer_literal] = STATE(381),
    [sym_number_literal] = STATE(381),
    [sym_bool_literal] = STATE(381),
    [sym__identifier] = STATE(381),
    [sym_symbol] = ACTIONS(902),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(904),
    [sym_buffer_literal] = ACTIONS(904),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(902),
    [sym_keyword] = ACTIONS(904),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [138] = {
    [sym__expr] = STATE(405),
    [sym_tuple] = STATE(405),
    [sym_sqr_tuple] = STATE(405),
    [sym_array] = STATE(405),
    [sym_sqr_array] = STATE(405),
    [sym_struct] = STATE(405),
    [sym_table] = STATE(405),
    [sym__special_forms] = STATE(405),
    [sym_def] = STATE(405),
    [sym_var] = STATE(405),
    [sym_quote] = STATE(405),
    [sym_splice] = STATE(405),
    [sym_quasiquote] = STATE(405),
    [sym_unquote] = STATE(405),
    [sym_break] = STATE(405),
    [sym_set] = STATE(405),
    [sym_if] = STATE(405),
    [sym_do] = STATE(405),
    [sym_while] = STATE(405),
    [sym_fn] = STATE(405),
    [sym__shorthand] = STATE(405),
    [sym_short_quote] = STATE(405),
    [sym_short_splice] = STATE(405),
    [sym_short_quasiquote] = STATE(405),
    [sym_short_unquote] = STATE(405),
    [sym_short_fn] = STATE(405),
    [sym__specials] = STATE(405),
    [sym_extra_defs] = STATE(405),
    [sym__literals] = STATE(405),
    [sym_long_str_literal] = STATE(405),
    [sym_long_buffer_literal] = STATE(405),
    [sym_number_literal] = STATE(405),
    [sym_bool_literal] = STATE(405),
    [sym__identifier] = STATE(405),
    [sym_symbol] = ACTIONS(906),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(908),
    [sym_buffer_literal] = ACTIONS(908),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(906),
    [sym_keyword] = ACTIONS(908),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [139] = {
    [sym__expr] = STATE(89),
    [sym_tuple] = STATE(89),
    [sym_sqr_tuple] = STATE(89),
    [sym_array] = STATE(89),
    [sym_sqr_array] = STATE(89),
    [sym_struct] = STATE(89),
    [sym_table] = STATE(89),
    [sym__special_forms] = STATE(89),
    [sym_def] = STATE(89),
    [sym_var] = STATE(89),
    [sym_quote] = STATE(89),
    [sym_splice] = STATE(89),
    [sym_quasiquote] = STATE(89),
    [sym_unquote] = STATE(89),
    [sym_break] = STATE(89),
    [sym_set] = STATE(89),
    [sym_if] = STATE(89),
    [sym_do] = STATE(89),
    [sym_while] = STATE(89),
    [sym_fn] = STATE(89),
    [sym__shorthand] = STATE(89),
    [sym_short_quote] = STATE(89),
    [sym_short_splice] = STATE(89),
    [sym_short_quasiquote] = STATE(89),
    [sym_short_unquote] = STATE(89),
    [sym_short_fn] = STATE(89),
    [sym__specials] = STATE(89),
    [sym_extra_defs] = STATE(89),
    [sym__literals] = STATE(89),
    [sym_long_str_literal] = STATE(89),
    [sym_long_buffer_literal] = STATE(89),
    [sym_number_literal] = STATE(89),
    [sym_bool_literal] = STATE(89),
    [sym__identifier] = STATE(89),
    [sym_symbol] = ACTIONS(910),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(912),
    [sym_buffer_literal] = ACTIONS(912),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(910),
    [sym_keyword] = ACTIONS(912),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [140] = {
    [sym__expr] = STATE(400),
    [sym_tuple] = STATE(400),
    [sym_sqr_tuple] = STATE(400),
    [sym_array] = STATE(400),
    [sym_sqr_array] = STATE(400),
    [sym_struct] = STATE(400),
    [sym_table] = STATE(400),
    [sym__special_forms] = STATE(400),
    [sym_def] = STATE(400),
    [sym_var] = STATE(400),
    [sym_quote] = STATE(400),
    [sym_splice] = STATE(400),
    [sym_quasiquote] = STATE(400),
    [sym_unquote] = STATE(400),
    [sym_break] = STATE(400),
    [sym_set] = STATE(400),
    [sym_if] = STATE(400),
    [sym_do] = STATE(400),
    [sym_while] = STATE(400),
    [sym_fn] = STATE(400),
    [sym__shorthand] = STATE(400),
    [sym_short_quote] = STATE(400),
    [sym_short_splice] = STATE(400),
    [sym_short_quasiquote] = STATE(400),
    [sym_short_unquote] = STATE(400),
    [sym_short_fn] = STATE(400),
    [sym__specials] = STATE(400),
    [sym_extra_defs] = STATE(400),
    [sym__literals] = STATE(400),
    [sym_long_str_literal] = STATE(400),
    [sym_long_buffer_literal] = STATE(400),
    [sym_number_literal] = STATE(400),
    [sym_bool_literal] = STATE(400),
    [sym__identifier] = STATE(400),
    [sym_symbol] = ACTIONS(914),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(916),
    [sym_buffer_literal] = ACTIONS(916),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(914),
    [sym_keyword] = ACTIONS(916),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [141] = {
    [sym__expr] = STATE(446),
    [sym_tuple] = STATE(446),
    [sym_sqr_tuple] = STATE(446),
    [sym_array] = STATE(446),
    [sym_sqr_array] = STATE(446),
    [sym_struct] = STATE(446),
    [sym_table] = STATE(446),
    [sym__special_forms] = STATE(446),
    [sym_def] = STATE(446),
    [sym_var] = STATE(446),
    [sym_quote] = STATE(446),
    [sym_splice] = STATE(446),
    [sym_quasiquote] = STATE(446),
    [sym_unquote] = STATE(446),
    [sym_break] = STATE(446),
    [sym_set] = STATE(446),
    [sym_if] = STATE(446),
    [sym_do] = STATE(446),
    [sym_while] = STATE(446),
    [sym_fn] = STATE(446),
    [sym__shorthand] = STATE(446),
    [sym_short_quote] = STATE(446),
    [sym_short_splice] = STATE(446),
    [sym_short_quasiquote] = STATE(446),
    [sym_short_unquote] = STATE(446),
    [sym_short_fn] = STATE(446),
    [sym__specials] = STATE(446),
    [sym_extra_defs] = STATE(446),
    [sym__literals] = STATE(446),
    [sym_long_str_literal] = STATE(446),
    [sym_long_buffer_literal] = STATE(446),
    [sym_number_literal] = STATE(446),
    [sym_bool_literal] = STATE(446),
    [sym__identifier] = STATE(446),
    [sym_symbol] = ACTIONS(918),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(920),
    [sym_buffer_literal] = ACTIONS(920),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(918),
    [sym_keyword] = ACTIONS(920),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [142] = {
    [sym__expr] = STATE(55),
    [sym_tuple] = STATE(55),
    [sym_sqr_tuple] = STATE(55),
    [sym_array] = STATE(55),
    [sym_sqr_array] = STATE(55),
    [sym_struct] = STATE(55),
    [sym_table] = STATE(55),
    [sym__special_forms] = STATE(55),
    [sym_def] = STATE(55),
    [sym_var] = STATE(55),
    [sym_quote] = STATE(55),
    [sym_splice] = STATE(55),
    [sym_quasiquote] = STATE(55),
    [sym_unquote] = STATE(55),
    [sym_break] = STATE(55),
    [sym_set] = STATE(55),
    [sym_if] = STATE(55),
    [sym_do] = STATE(55),
    [sym_while] = STATE(55),
    [sym_fn] = STATE(55),
    [sym__shorthand] = STATE(55),
    [sym_short_quote] = STATE(55),
    [sym_short_splice] = STATE(55),
    [sym_short_quasiquote] = STATE(55),
    [sym_short_unquote] = STATE(55),
    [sym_short_fn] = STATE(55),
    [sym__specials] = STATE(55),
    [sym_extra_defs] = STATE(55),
    [sym__literals] = STATE(55),
    [sym_long_str_literal] = STATE(55),
    [sym_long_buffer_literal] = STATE(55),
    [sym_number_literal] = STATE(55),
    [sym_bool_literal] = STATE(55),
    [sym__identifier] = STATE(55),
    [sym_symbol] = ACTIONS(922),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(924),
    [sym_buffer_literal] = ACTIONS(924),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(922),
    [sym_keyword] = ACTIONS(924),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [143] = {
    [sym__expr] = STATE(401),
    [sym_tuple] = STATE(401),
    [sym_sqr_tuple] = STATE(401),
    [sym_array] = STATE(401),
    [sym_sqr_array] = STATE(401),
    [sym_struct] = STATE(401),
    [sym_table] = STATE(401),
    [sym__special_forms] = STATE(401),
    [sym_def] = STATE(401),
    [sym_var] = STATE(401),
    [sym_quote] = STATE(401),
    [sym_splice] = STATE(401),
    [sym_quasiquote] = STATE(401),
    [sym_unquote] = STATE(401),
    [sym_break] = STATE(401),
    [sym_set] = STATE(401),
    [sym_if] = STATE(401),
    [sym_do] = STATE(401),
    [sym_while] = STATE(401),
    [sym_fn] = STATE(401),
    [sym__shorthand] = STATE(401),
    [sym_short_quote] = STATE(401),
    [sym_short_splice] = STATE(401),
    [sym_short_quasiquote] = STATE(401),
    [sym_short_unquote] = STATE(401),
    [sym_short_fn] = STATE(401),
    [sym__specials] = STATE(401),
    [sym_extra_defs] = STATE(401),
    [sym__literals] = STATE(401),
    [sym_long_str_literal] = STATE(401),
    [sym_long_buffer_literal] = STATE(401),
    [sym_number_literal] = STATE(401),
    [sym_bool_literal] = STATE(401),
    [sym__identifier] = STATE(401),
    [sym_symbol] = ACTIONS(926),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(928),
    [sym_buffer_literal] = ACTIONS(928),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(926),
    [sym_keyword] = ACTIONS(928),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [144] = {
    [sym__expr] = STATE(56),
    [sym_tuple] = STATE(56),
    [sym_sqr_tuple] = STATE(56),
    [sym_array] = STATE(56),
    [sym_sqr_array] = STATE(56),
    [sym_struct] = STATE(56),
    [sym_table] = STATE(56),
    [sym__special_forms] = STATE(56),
    [sym_def] = STATE(56),
    [sym_var] = STATE(56),
    [sym_quote] = STATE(56),
    [sym_splice] = STATE(56),
    [sym_quasiquote] = STATE(56),
    [sym_unquote] = STATE(56),
    [sym_break] = STATE(56),
    [sym_set] = STATE(56),
    [sym_if] = STATE(56),
    [sym_do] = STATE(56),
    [sym_while] = STATE(56),
    [sym_fn] = STATE(56),
    [sym__shorthand] = STATE(56),
    [sym_short_quote] = STATE(56),
    [sym_short_splice] = STATE(56),
    [sym_short_quasiquote] = STATE(56),
    [sym_short_unquote] = STATE(56),
    [sym_short_fn] = STATE(56),
    [sym__specials] = STATE(56),
    [sym_extra_defs] = STATE(56),
    [sym__literals] = STATE(56),
    [sym_long_str_literal] = STATE(56),
    [sym_long_buffer_literal] = STATE(56),
    [sym_number_literal] = STATE(56),
    [sym_bool_literal] = STATE(56),
    [sym__identifier] = STATE(56),
    [sym_symbol] = ACTIONS(930),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(932),
    [sym_buffer_literal] = ACTIONS(932),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(930),
    [sym_keyword] = ACTIONS(932),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [145] = {
    [sym__expr] = STATE(186),
    [sym_tuple] = STATE(186),
    [sym_sqr_tuple] = STATE(186),
    [sym_array] = STATE(186),
    [sym_sqr_array] = STATE(186),
    [sym_struct] = STATE(186),
    [sym_table] = STATE(186),
    [sym__special_forms] = STATE(186),
    [sym_def] = STATE(186),
    [sym_var] = STATE(186),
    [sym_quote] = STATE(186),
    [sym_splice] = STATE(186),
    [sym_quasiquote] = STATE(186),
    [sym_unquote] = STATE(186),
    [sym_break] = STATE(186),
    [sym_set] = STATE(186),
    [sym_if] = STATE(186),
    [sym_do] = STATE(186),
    [sym_while] = STATE(186),
    [sym_fn] = STATE(186),
    [sym__shorthand] = STATE(186),
    [sym_short_quote] = STATE(186),
    [sym_short_splice] = STATE(186),
    [sym_short_quasiquote] = STATE(186),
    [sym_short_unquote] = STATE(186),
    [sym_short_fn] = STATE(186),
    [sym__specials] = STATE(186),
    [sym_extra_defs] = STATE(186),
    [sym__literals] = STATE(186),
    [sym_long_str_literal] = STATE(186),
    [sym_long_buffer_literal] = STATE(186),
    [sym_number_literal] = STATE(186),
    [sym_bool_literal] = STATE(186),
    [sym__identifier] = STATE(186),
    [sym_symbol] = ACTIONS(934),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(936),
    [sym_buffer_literal] = ACTIONS(936),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(934),
    [sym_keyword] = ACTIONS(936),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [146] = {
    [sym__expr] = STATE(187),
    [sym_tuple] = STATE(187),
    [sym_sqr_tuple] = STATE(187),
    [sym_array] = STATE(187),
    [sym_sqr_array] = STATE(187),
    [sym_struct] = STATE(187),
    [sym_table] = STATE(187),
    [sym__special_forms] = STATE(187),
    [sym_def] = STATE(187),
    [sym_var] = STATE(187),
    [sym_quote] = STATE(187),
    [sym_splice] = STATE(187),
    [sym_quasiquote] = STATE(187),
    [sym_unquote] = STATE(187),
    [sym_break] = STATE(187),
    [sym_set] = STATE(187),
    [sym_if] = STATE(187),
    [sym_do] = STATE(187),
    [sym_while] = STATE(187),
    [sym_fn] = STATE(187),
    [sym__shorthand] = STATE(187),
    [sym_short_quote] = STATE(187),
    [sym_short_splice] = STATE(187),
    [sym_short_quasiquote] = STATE(187),
    [sym_short_unquote] = STATE(187),
    [sym_short_fn] = STATE(187),
    [sym__specials] = STATE(187),
    [sym_extra_defs] = STATE(187),
    [sym__literals] = STATE(187),
    [sym_long_str_literal] = STATE(187),
    [sym_long_buffer_literal] = STATE(187),
    [sym_number_literal] = STATE(187),
    [sym_bool_literal] = STATE(187),
    [sym__identifier] = STATE(187),
    [sym_symbol] = ACTIONS(938),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(940),
    [sym_buffer_literal] = ACTIONS(940),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(938),
    [sym_keyword] = ACTIONS(940),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [147] = {
    [sym__expr] = STATE(188),
    [sym_tuple] = STATE(188),
    [sym_sqr_tuple] = STATE(188),
    [sym_array] = STATE(188),
    [sym_sqr_array] = STATE(188),
    [sym_struct] = STATE(188),
    [sym_table] = STATE(188),
    [sym__special_forms] = STATE(188),
    [sym_def] = STATE(188),
    [sym_var] = STATE(188),
    [sym_quote] = STATE(188),
    [sym_splice] = STATE(188),
    [sym_quasiquote] = STATE(188),
    [sym_unquote] = STATE(188),
    [sym_break] = STATE(188),
    [sym_set] = STATE(188),
    [sym_if] = STATE(188),
    [sym_do] = STATE(188),
    [sym_while] = STATE(188),
    [sym_fn] = STATE(188),
    [sym__shorthand] = STATE(188),
    [sym_short_quote] = STATE(188),
    [sym_short_splice] = STATE(188),
    [sym_short_quasiquote] = STATE(188),
    [sym_short_unquote] = STATE(188),
    [sym_short_fn] = STATE(188),
    [sym__specials] = STATE(188),
    [sym_extra_defs] = STATE(188),
    [sym__literals] = STATE(188),
    [sym_long_str_literal] = STATE(188),
    [sym_long_buffer_literal] = STATE(188),
    [sym_number_literal] = STATE(188),
    [sym_bool_literal] = STATE(188),
    [sym__identifier] = STATE(188),
    [sym_symbol] = ACTIONS(942),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(944),
    [sym_buffer_literal] = ACTIONS(944),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(942),
    [sym_keyword] = ACTIONS(944),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [148] = {
    [sym__expr] = STATE(189),
    [sym_tuple] = STATE(189),
    [sym_sqr_tuple] = STATE(189),
    [sym_array] = STATE(189),
    [sym_sqr_array] = STATE(189),
    [sym_struct] = STATE(189),
    [sym_table] = STATE(189),
    [sym__special_forms] = STATE(189),
    [sym_def] = STATE(189),
    [sym_var] = STATE(189),
    [sym_quote] = STATE(189),
    [sym_splice] = STATE(189),
    [sym_quasiquote] = STATE(189),
    [sym_unquote] = STATE(189),
    [sym_break] = STATE(189),
    [sym_set] = STATE(189),
    [sym_if] = STATE(189),
    [sym_do] = STATE(189),
    [sym_while] = STATE(189),
    [sym_fn] = STATE(189),
    [sym__shorthand] = STATE(189),
    [sym_short_quote] = STATE(189),
    [sym_short_splice] = STATE(189),
    [sym_short_quasiquote] = STATE(189),
    [sym_short_unquote] = STATE(189),
    [sym_short_fn] = STATE(189),
    [sym__specials] = STATE(189),
    [sym_extra_defs] = STATE(189),
    [sym__literals] = STATE(189),
    [sym_long_str_literal] = STATE(189),
    [sym_long_buffer_literal] = STATE(189),
    [sym_number_literal] = STATE(189),
    [sym_bool_literal] = STATE(189),
    [sym__identifier] = STATE(189),
    [sym_symbol] = ACTIONS(946),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(948),
    [sym_buffer_literal] = ACTIONS(948),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(946),
    [sym_keyword] = ACTIONS(948),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [149] = {
    [sym__expr] = STATE(273),
    [sym_tuple] = STATE(273),
    [sym_sqr_tuple] = STATE(273),
    [sym_array] = STATE(273),
    [sym_sqr_array] = STATE(273),
    [sym_struct] = STATE(273),
    [sym_table] = STATE(273),
    [sym__special_forms] = STATE(273),
    [sym_def] = STATE(273),
    [sym_var] = STATE(273),
    [sym_quote] = STATE(273),
    [sym_splice] = STATE(273),
    [sym_quasiquote] = STATE(273),
    [sym_unquote] = STATE(273),
    [sym_break] = STATE(273),
    [sym_set] = STATE(273),
    [sym_if] = STATE(273),
    [sym_do] = STATE(273),
    [sym_while] = STATE(273),
    [sym_fn] = STATE(273),
    [sym__shorthand] = STATE(273),
    [sym_short_quote] = STATE(273),
    [sym_short_splice] = STATE(273),
    [sym_short_quasiquote] = STATE(273),
    [sym_short_unquote] = STATE(273),
    [sym_short_fn] = STATE(273),
    [sym__specials] = STATE(273),
    [sym_extra_defs] = STATE(273),
    [sym__literals] = STATE(273),
    [sym_long_str_literal] = STATE(273),
    [sym_long_buffer_literal] = STATE(273),
    [sym_number_literal] = STATE(273),
    [sym_bool_literal] = STATE(273),
    [sym__identifier] = STATE(273),
    [sym_symbol] = ACTIONS(950),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(952),
    [sym_buffer_literal] = ACTIONS(952),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(950),
    [sym_keyword] = ACTIONS(952),
    [sym__long_str] = ACTIONS(37),
    [sym__long_buffer] = ACTIONS(39),
  },
  [150] = {
    [sym__expr] = STATE(473),
    [sym_tuple] = STATE(473),
    [sym_sqr_tuple] = STATE(473),
    [sym_array] = STATE(473),
    [sym_sqr_array] = STATE(473),
    [sym_struct] = STATE(473),
    [sym_table] = STATE(473),
    [sym__special_forms] = STATE(473),
    [sym_def] = STATE(473),
    [sym_var] = STATE(473),
    [sym_quote] = STATE(473),
    [sym_splice] = STATE(473),
    [sym_quasiquote] = STATE(473),
    [sym_unquote] = STATE(473),
    [sym_break] = STATE(473),
    [sym_set] = STATE(473),
    [sym_if] = STATE(473),
    [sym_do] = STATE(473),
    [sym_while] = STATE(473),
    [sym_fn] = STATE(473),
    [sym__shorthand] = STATE(473),
    [sym_short_quote] = STATE(473),
    [sym_short_splice] = STATE(473),
    [sym_short_quasiquote] = STATE(473),
    [sym_short_unquote] = STATE(473),
    [sym_short_fn] = STATE(473),
    [sym__specials] = STATE(473),
    [sym_extra_defs] = STATE(473),
    [sym__literals] = STATE(473),
    [sym_long_str_literal] = STATE(473),
    [sym_long_buffer_literal] = STATE(473),
    [sym_number_literal] = STATE(473),
    [sym_bool_literal] = STATE(473),
    [sym__identifier] = STATE(473),
    [sym_symbol] = ACTIONS(954),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(956),
    [sym_buffer_literal] = ACTIONS(956),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(954),
    [sym_keyword] = ACTIONS(956),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [151] = {
    [sym__expr] = STATE(238),
    [sym_tuple] = STATE(238),
    [sym_sqr_tuple] = STATE(238),
    [sym_array] = STATE(238),
    [sym_sqr_array] = STATE(238),
    [sym_struct] = STATE(238),
    [sym_table] = STATE(238),
    [sym__special_forms] = STATE(238),
    [sym_def] = STATE(238),
    [sym_var] = STATE(238),
    [sym_quote] = STATE(238),
    [sym_splice] = STATE(238),
    [sym_quasiquote] = STATE(238),
    [sym_unquote] = STATE(238),
    [sym_break] = STATE(238),
    [sym_set] = STATE(238),
    [sym_if] = STATE(238),
    [sym_do] = STATE(238),
    [sym_while] = STATE(238),
    [sym_fn] = STATE(238),
    [sym__shorthand] = STATE(238),
    [sym_short_quote] = STATE(238),
    [sym_short_splice] = STATE(238),
    [sym_short_quasiquote] = STATE(238),
    [sym_short_unquote] = STATE(238),
    [sym_short_fn] = STATE(238),
    [sym__specials] = STATE(238),
    [sym_extra_defs] = STATE(238),
    [sym__literals] = STATE(238),
    [sym_long_str_literal] = STATE(238),
    [sym_long_buffer_literal] = STATE(238),
    [sym_number_literal] = STATE(238),
    [sym_bool_literal] = STATE(238),
    [sym__identifier] = STATE(238),
    [sym_symbol] = ACTIONS(958),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(9),
    [anon_sym_LBRACK] = ACTIONS(11),
    [anon_sym_AT_LPAREN] = ACTIONS(13),
    [anon_sym_AT_LBRACK] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(17),
    [anon_sym_AT_LBRACE] = ACTIONS(19),
    [anon_sym_SQUOTE] = ACTIONS(21),
    [anon_sym_SEMI] = ACTIONS(23),
    [anon_sym_TILDE] = ACTIONS(25),
    [anon_sym_COMMA] = ACTIONS(27),
    [anon_sym_PIPE] = ACTIONS(29),
    [sym_str_literal] = ACTIONS(960),
    [sym_buffer_literal] = ACTIONS(960),
    [aux_sym_number_literal_token1] = ACTIONS(33),
    [aux_sym_number_literal_token2] = ACTIONS(33),
    [aux_sym_number_literal_token3] = ACTIONS(33),
    [anon_sym_true] = ACTIONS(35),
    [anon_sym_false] = ACTIONS(35),
    [sym_nil_literal] = ACTIONS(958),
    [sym_keyword] = ACTIONS(960),
    [sym__long_str] = ACTIONS(37),
    [sym__long_buffer] = ACTIONS(39),
  },
  [152] = {
    [sym__expr] = STATE(106),
    [sym_tuple] = STATE(106),
    [sym_sqr_tuple] = STATE(106),
    [sym_array] = STATE(106),
    [sym_sqr_array] = STATE(106),
    [sym_struct] = STATE(106),
    [sym_table] = STATE(106),
    [sym__special_forms] = STATE(106),
    [sym_def] = STATE(106),
    [sym_var] = STATE(106),
    [sym_quote] = STATE(106),
    [sym_splice] = STATE(106),
    [sym_quasiquote] = STATE(106),
    [sym_unquote] = STATE(106),
    [sym_break] = STATE(106),
    [sym_set] = STATE(106),
    [sym_if] = STATE(106),
    [sym_do] = STATE(106),
    [sym_while] = STATE(106),
    [sym_fn] = STATE(106),
    [sym__shorthand] = STATE(106),
    [sym_short_quote] = STATE(106),
    [sym_short_splice] = STATE(106),
    [sym_short_quasiquote] = STATE(106),
    [sym_short_unquote] = STATE(106),
    [sym_short_fn] = STATE(106),
    [sym__specials] = STATE(106),
    [sym_extra_defs] = STATE(106),
    [sym__literals] = STATE(106),
    [sym_long_str_literal] = STATE(106),
    [sym_long_buffer_literal] = STATE(106),
    [sym_number_literal] = STATE(106),
    [sym_bool_literal] = STATE(106),
    [sym__identifier] = STATE(106),
    [sym_symbol] = ACTIONS(962),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(964),
    [sym_buffer_literal] = ACTIONS(964),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(962),
    [sym_keyword] = ACTIONS(964),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [153] = {
    [sym__expr] = STATE(379),
    [sym_tuple] = STATE(379),
    [sym_sqr_tuple] = STATE(379),
    [sym_array] = STATE(379),
    [sym_sqr_array] = STATE(379),
    [sym_struct] = STATE(379),
    [sym_table] = STATE(379),
    [sym__special_forms] = STATE(379),
    [sym_def] = STATE(379),
    [sym_var] = STATE(379),
    [sym_quote] = STATE(379),
    [sym_splice] = STATE(379),
    [sym_quasiquote] = STATE(379),
    [sym_unquote] = STATE(379),
    [sym_break] = STATE(379),
    [sym_set] = STATE(379),
    [sym_if] = STATE(379),
    [sym_do] = STATE(379),
    [sym_while] = STATE(379),
    [sym_fn] = STATE(379),
    [sym__shorthand] = STATE(379),
    [sym_short_quote] = STATE(379),
    [sym_short_splice] = STATE(379),
    [sym_short_quasiquote] = STATE(379),
    [sym_short_unquote] = STATE(379),
    [sym_short_fn] = STATE(379),
    [sym__specials] = STATE(379),
    [sym_extra_defs] = STATE(379),
    [sym__literals] = STATE(379),
    [sym_long_str_literal] = STATE(379),
    [sym_long_buffer_literal] = STATE(379),
    [sym_number_literal] = STATE(379),
    [sym_bool_literal] = STATE(379),
    [sym__identifier] = STATE(379),
    [sym_symbol] = ACTIONS(966),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(968),
    [sym_buffer_literal] = ACTIONS(968),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(966),
    [sym_keyword] = ACTIONS(968),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [154] = {
    [sym__expr] = STATE(97),
    [sym_tuple] = STATE(97),
    [sym_sqr_tuple] = STATE(97),
    [sym_array] = STATE(97),
    [sym_sqr_array] = STATE(97),
    [sym_struct] = STATE(97),
    [sym_table] = STATE(97),
    [sym__special_forms] = STATE(97),
    [sym_def] = STATE(97),
    [sym_var] = STATE(97),
    [sym_quote] = STATE(97),
    [sym_splice] = STATE(97),
    [sym_quasiquote] = STATE(97),
    [sym_unquote] = STATE(97),
    [sym_break] = STATE(97),
    [sym_set] = STATE(97),
    [sym_if] = STATE(97),
    [sym_do] = STATE(97),
    [sym_while] = STATE(97),
    [sym_fn] = STATE(97),
    [sym__shorthand] = STATE(97),
    [sym_short_quote] = STATE(97),
    [sym_short_splice] = STATE(97),
    [sym_short_quasiquote] = STATE(97),
    [sym_short_unquote] = STATE(97),
    [sym_short_fn] = STATE(97),
    [sym__specials] = STATE(97),
    [sym_extra_defs] = STATE(97),
    [sym__literals] = STATE(97),
    [sym_long_str_literal] = STATE(97),
    [sym_long_buffer_literal] = STATE(97),
    [sym_number_literal] = STATE(97),
    [sym_bool_literal] = STATE(97),
    [sym__identifier] = STATE(97),
    [sym_symbol] = ACTIONS(970),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(972),
    [sym_buffer_literal] = ACTIONS(972),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(970),
    [sym_keyword] = ACTIONS(972),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [155] = {
    [sym__expr] = STATE(58),
    [sym_tuple] = STATE(58),
    [sym_sqr_tuple] = STATE(58),
    [sym_array] = STATE(58),
    [sym_sqr_array] = STATE(58),
    [sym_struct] = STATE(58),
    [sym_table] = STATE(58),
    [sym__special_forms] = STATE(58),
    [sym_def] = STATE(58),
    [sym_var] = STATE(58),
    [sym_quote] = STATE(58),
    [sym_splice] = STATE(58),
    [sym_quasiquote] = STATE(58),
    [sym_unquote] = STATE(58),
    [sym_break] = STATE(58),
    [sym_set] = STATE(58),
    [sym_if] = STATE(58),
    [sym_do] = STATE(58),
    [sym_while] = STATE(58),
    [sym_fn] = STATE(58),
    [sym__shorthand] = STATE(58),
    [sym_short_quote] = STATE(58),
    [sym_short_splice] = STATE(58),
    [sym_short_quasiquote] = STATE(58),
    [sym_short_unquote] = STATE(58),
    [sym_short_fn] = STATE(58),
    [sym__specials] = STATE(58),
    [sym_extra_defs] = STATE(58),
    [sym__literals] = STATE(58),
    [sym_long_str_literal] = STATE(58),
    [sym_long_buffer_literal] = STATE(58),
    [sym_number_literal] = STATE(58),
    [sym_bool_literal] = STATE(58),
    [sym__identifier] = STATE(58),
    [sym_symbol] = ACTIONS(974),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(976),
    [sym_buffer_literal] = ACTIONS(976),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(974),
    [sym_keyword] = ACTIONS(976),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [156] = {
    [sym__expr] = STATE(112),
    [sym_tuple] = STATE(112),
    [sym_sqr_tuple] = STATE(112),
    [sym_array] = STATE(112),
    [sym_sqr_array] = STATE(112),
    [sym_struct] = STATE(112),
    [sym_table] = STATE(112),
    [sym__special_forms] = STATE(112),
    [sym_def] = STATE(112),
    [sym_var] = STATE(112),
    [sym_quote] = STATE(112),
    [sym_splice] = STATE(112),
    [sym_quasiquote] = STATE(112),
    [sym_unquote] = STATE(112),
    [sym_break] = STATE(112),
    [sym_set] = STATE(112),
    [sym_if] = STATE(112),
    [sym_do] = STATE(112),
    [sym_while] = STATE(112),
    [sym_fn] = STATE(112),
    [sym__shorthand] = STATE(112),
    [sym_short_quote] = STATE(112),
    [sym_short_splice] = STATE(112),
    [sym_short_quasiquote] = STATE(112),
    [sym_short_unquote] = STATE(112),
    [sym_short_fn] = STATE(112),
    [sym__specials] = STATE(112),
    [sym_extra_defs] = STATE(112),
    [sym__literals] = STATE(112),
    [sym_long_str_literal] = STATE(112),
    [sym_long_buffer_literal] = STATE(112),
    [sym_number_literal] = STATE(112),
    [sym_bool_literal] = STATE(112),
    [sym__identifier] = STATE(112),
    [sym_symbol] = ACTIONS(978),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(980),
    [sym_buffer_literal] = ACTIONS(980),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(978),
    [sym_keyword] = ACTIONS(980),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [157] = {
    [sym__expr] = STATE(396),
    [sym_tuple] = STATE(396),
    [sym_sqr_tuple] = STATE(396),
    [sym_array] = STATE(396),
    [sym_sqr_array] = STATE(396),
    [sym_struct] = STATE(396),
    [sym_table] = STATE(396),
    [sym__special_forms] = STATE(396),
    [sym_def] = STATE(396),
    [sym_var] = STATE(396),
    [sym_quote] = STATE(396),
    [sym_splice] = STATE(396),
    [sym_quasiquote] = STATE(396),
    [sym_unquote] = STATE(396),
    [sym_break] = STATE(396),
    [sym_set] = STATE(396),
    [sym_if] = STATE(396),
    [sym_do] = STATE(396),
    [sym_while] = STATE(396),
    [sym_fn] = STATE(396),
    [sym__shorthand] = STATE(396),
    [sym_short_quote] = STATE(396),
    [sym_short_splice] = STATE(396),
    [sym_short_quasiquote] = STATE(396),
    [sym_short_unquote] = STATE(396),
    [sym_short_fn] = STATE(396),
    [sym__specials] = STATE(396),
    [sym_extra_defs] = STATE(396),
    [sym__literals] = STATE(396),
    [sym_long_str_literal] = STATE(396),
    [sym_long_buffer_literal] = STATE(396),
    [sym_number_literal] = STATE(396),
    [sym_bool_literal] = STATE(396),
    [sym__identifier] = STATE(396),
    [sym_symbol] = ACTIONS(982),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(984),
    [sym_buffer_literal] = ACTIONS(984),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(982),
    [sym_keyword] = ACTIONS(984),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [158] = {
    [sym__expr] = STATE(395),
    [sym_tuple] = STATE(395),
    [sym_sqr_tuple] = STATE(395),
    [sym_array] = STATE(395),
    [sym_sqr_array] = STATE(395),
    [sym_struct] = STATE(395),
    [sym_table] = STATE(395),
    [sym__special_forms] = STATE(395),
    [sym_def] = STATE(395),
    [sym_var] = STATE(395),
    [sym_quote] = STATE(395),
    [sym_splice] = STATE(395),
    [sym_quasiquote] = STATE(395),
    [sym_unquote] = STATE(395),
    [sym_break] = STATE(395),
    [sym_set] = STATE(395),
    [sym_if] = STATE(395),
    [sym_do] = STATE(395),
    [sym_while] = STATE(395),
    [sym_fn] = STATE(395),
    [sym__shorthand] = STATE(395),
    [sym_short_quote] = STATE(395),
    [sym_short_splice] = STATE(395),
    [sym_short_quasiquote] = STATE(395),
    [sym_short_unquote] = STATE(395),
    [sym_short_fn] = STATE(395),
    [sym__specials] = STATE(395),
    [sym_extra_defs] = STATE(395),
    [sym__literals] = STATE(395),
    [sym_long_str_literal] = STATE(395),
    [sym_long_buffer_literal] = STATE(395),
    [sym_number_literal] = STATE(395),
    [sym_bool_literal] = STATE(395),
    [sym__identifier] = STATE(395),
    [sym_symbol] = ACTIONS(986),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(988),
    [sym_buffer_literal] = ACTIONS(988),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(986),
    [sym_keyword] = ACTIONS(988),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [159] = {
    [sym__expr] = STATE(113),
    [sym_tuple] = STATE(113),
    [sym_sqr_tuple] = STATE(113),
    [sym_array] = STATE(113),
    [sym_sqr_array] = STATE(113),
    [sym_struct] = STATE(113),
    [sym_table] = STATE(113),
    [sym__special_forms] = STATE(113),
    [sym_def] = STATE(113),
    [sym_var] = STATE(113),
    [sym_quote] = STATE(113),
    [sym_splice] = STATE(113),
    [sym_quasiquote] = STATE(113),
    [sym_unquote] = STATE(113),
    [sym_break] = STATE(113),
    [sym_set] = STATE(113),
    [sym_if] = STATE(113),
    [sym_do] = STATE(113),
    [sym_while] = STATE(113),
    [sym_fn] = STATE(113),
    [sym__shorthand] = STATE(113),
    [sym_short_quote] = STATE(113),
    [sym_short_splice] = STATE(113),
    [sym_short_quasiquote] = STATE(113),
    [sym_short_unquote] = STATE(113),
    [sym_short_fn] = STATE(113),
    [sym__specials] = STATE(113),
    [sym_extra_defs] = STATE(113),
    [sym__literals] = STATE(113),
    [sym_long_str_literal] = STATE(113),
    [sym_long_buffer_literal] = STATE(113),
    [sym_number_literal] = STATE(113),
    [sym_bool_literal] = STATE(113),
    [sym__identifier] = STATE(113),
    [sym_symbol] = ACTIONS(990),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(992),
    [sym_buffer_literal] = ACTIONS(992),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(990),
    [sym_keyword] = ACTIONS(992),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [160] = {
    [sym__expr] = STATE(393),
    [sym_tuple] = STATE(393),
    [sym_sqr_tuple] = STATE(393),
    [sym_array] = STATE(393),
    [sym_sqr_array] = STATE(393),
    [sym_struct] = STATE(393),
    [sym_table] = STATE(393),
    [sym__special_forms] = STATE(393),
    [sym_def] = STATE(393),
    [sym_var] = STATE(393),
    [sym_quote] = STATE(393),
    [sym_splice] = STATE(393),
    [sym_quasiquote] = STATE(393),
    [sym_unquote] = STATE(393),
    [sym_break] = STATE(393),
    [sym_set] = STATE(393),
    [sym_if] = STATE(393),
    [sym_do] = STATE(393),
    [sym_while] = STATE(393),
    [sym_fn] = STATE(393),
    [sym__shorthand] = STATE(393),
    [sym_short_quote] = STATE(393),
    [sym_short_splice] = STATE(393),
    [sym_short_quasiquote] = STATE(393),
    [sym_short_unquote] = STATE(393),
    [sym_short_fn] = STATE(393),
    [sym__specials] = STATE(393),
    [sym_extra_defs] = STATE(393),
    [sym__literals] = STATE(393),
    [sym_long_str_literal] = STATE(393),
    [sym_long_buffer_literal] = STATE(393),
    [sym_number_literal] = STATE(393),
    [sym_bool_literal] = STATE(393),
    [sym__identifier] = STATE(393),
    [sym_symbol] = ACTIONS(994),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(996),
    [sym_buffer_literal] = ACTIONS(996),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(994),
    [sym_keyword] = ACTIONS(996),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [161] = {
    [sym__expr] = STATE(377),
    [sym_tuple] = STATE(377),
    [sym_sqr_tuple] = STATE(377),
    [sym_array] = STATE(377),
    [sym_sqr_array] = STATE(377),
    [sym_struct] = STATE(377),
    [sym_table] = STATE(377),
    [sym__special_forms] = STATE(377),
    [sym_def] = STATE(377),
    [sym_var] = STATE(377),
    [sym_quote] = STATE(377),
    [sym_splice] = STATE(377),
    [sym_quasiquote] = STATE(377),
    [sym_unquote] = STATE(377),
    [sym_break] = STATE(377),
    [sym_set] = STATE(377),
    [sym_if] = STATE(377),
    [sym_do] = STATE(377),
    [sym_while] = STATE(377),
    [sym_fn] = STATE(377),
    [sym__shorthand] = STATE(377),
    [sym_short_quote] = STATE(377),
    [sym_short_splice] = STATE(377),
    [sym_short_quasiquote] = STATE(377),
    [sym_short_unquote] = STATE(377),
    [sym_short_fn] = STATE(377),
    [sym__specials] = STATE(377),
    [sym_extra_defs] = STATE(377),
    [sym__literals] = STATE(377),
    [sym_long_str_literal] = STATE(377),
    [sym_long_buffer_literal] = STATE(377),
    [sym_number_literal] = STATE(377),
    [sym_bool_literal] = STATE(377),
    [sym__identifier] = STATE(377),
    [sym_symbol] = ACTIONS(998),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(1000),
    [sym_buffer_literal] = ACTIONS(1000),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(998),
    [sym_keyword] = ACTIONS(1000),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [162] = {
    [sym__expr] = STATE(108),
    [sym_tuple] = STATE(108),
    [sym_sqr_tuple] = STATE(108),
    [sym_array] = STATE(108),
    [sym_sqr_array] = STATE(108),
    [sym_struct] = STATE(108),
    [sym_table] = STATE(108),
    [sym__special_forms] = STATE(108),
    [sym_def] = STATE(108),
    [sym_var] = STATE(108),
    [sym_quote] = STATE(108),
    [sym_splice] = STATE(108),
    [sym_quasiquote] = STATE(108),
    [sym_unquote] = STATE(108),
    [sym_break] = STATE(108),
    [sym_set] = STATE(108),
    [sym_if] = STATE(108),
    [sym_do] = STATE(108),
    [sym_while] = STATE(108),
    [sym_fn] = STATE(108),
    [sym__shorthand] = STATE(108),
    [sym_short_quote] = STATE(108),
    [sym_short_splice] = STATE(108),
    [sym_short_quasiquote] = STATE(108),
    [sym_short_unquote] = STATE(108),
    [sym_short_fn] = STATE(108),
    [sym__specials] = STATE(108),
    [sym_extra_defs] = STATE(108),
    [sym__literals] = STATE(108),
    [sym_long_str_literal] = STATE(108),
    [sym_long_buffer_literal] = STATE(108),
    [sym_number_literal] = STATE(108),
    [sym_bool_literal] = STATE(108),
    [sym__identifier] = STATE(108),
    [sym_symbol] = ACTIONS(1002),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(1004),
    [sym_buffer_literal] = ACTIONS(1004),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(1002),
    [sym_keyword] = ACTIONS(1004),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [163] = {
    [sym__expr] = STATE(474),
    [sym_tuple] = STATE(474),
    [sym_sqr_tuple] = STATE(474),
    [sym_array] = STATE(474),
    [sym_sqr_array] = STATE(474),
    [sym_struct] = STATE(474),
    [sym_table] = STATE(474),
    [sym__special_forms] = STATE(474),
    [sym_def] = STATE(474),
    [sym_var] = STATE(474),
    [sym_quote] = STATE(474),
    [sym_splice] = STATE(474),
    [sym_quasiquote] = STATE(474),
    [sym_unquote] = STATE(474),
    [sym_break] = STATE(474),
    [sym_set] = STATE(474),
    [sym_if] = STATE(474),
    [sym_do] = STATE(474),
    [sym_while] = STATE(474),
    [sym_fn] = STATE(474),
    [sym__shorthand] = STATE(474),
    [sym_short_quote] = STATE(474),
    [sym_short_splice] = STATE(474),
    [sym_short_quasiquote] = STATE(474),
    [sym_short_unquote] = STATE(474),
    [sym_short_fn] = STATE(474),
    [sym__specials] = STATE(474),
    [sym_extra_defs] = STATE(474),
    [sym__literals] = STATE(474),
    [sym_long_str_literal] = STATE(474),
    [sym_long_buffer_literal] = STATE(474),
    [sym_number_literal] = STATE(474),
    [sym_bool_literal] = STATE(474),
    [sym__identifier] = STATE(474),
    [sym_symbol] = ACTIONS(1006),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(1008),
    [sym_buffer_literal] = ACTIONS(1008),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(1006),
    [sym_keyword] = ACTIONS(1008),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [164] = {
    [sym__expr] = STATE(370),
    [sym_tuple] = STATE(370),
    [sym_sqr_tuple] = STATE(370),
    [sym_array] = STATE(370),
    [sym_sqr_array] = STATE(370),
    [sym_struct] = STATE(370),
    [sym_table] = STATE(370),
    [sym__special_forms] = STATE(370),
    [sym_def] = STATE(370),
    [sym_var] = STATE(370),
    [sym_quote] = STATE(370),
    [sym_splice] = STATE(370),
    [sym_quasiquote] = STATE(370),
    [sym_unquote] = STATE(370),
    [sym_break] = STATE(370),
    [sym_set] = STATE(370),
    [sym_if] = STATE(370),
    [sym_do] = STATE(370),
    [sym_while] = STATE(370),
    [sym_fn] = STATE(370),
    [sym__shorthand] = STATE(370),
    [sym_short_quote] = STATE(370),
    [sym_short_splice] = STATE(370),
    [sym_short_quasiquote] = STATE(370),
    [sym_short_unquote] = STATE(370),
    [sym_short_fn] = STATE(370),
    [sym__specials] = STATE(370),
    [sym_extra_defs] = STATE(370),
    [sym__literals] = STATE(370),
    [sym_long_str_literal] = STATE(370),
    [sym_long_buffer_literal] = STATE(370),
    [sym_number_literal] = STATE(370),
    [sym_bool_literal] = STATE(370),
    [sym__identifier] = STATE(370),
    [sym_symbol] = ACTIONS(1010),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(1012),
    [sym_buffer_literal] = ACTIONS(1012),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(1010),
    [sym_keyword] = ACTIONS(1012),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [165] = {
    [sym__expr] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_sqr_tuple] = STATE(82),
    [sym_array] = STATE(82),
    [sym_sqr_array] = STATE(82),
    [sym_struct] = STATE(82),
    [sym_table] = STATE(82),
    [sym__special_forms] = STATE(82),
    [sym_def] = STATE(82),
    [sym_var] = STATE(82),
    [sym_quote] = STATE(82),
    [sym_splice] = STATE(82),
    [sym_quasiquote] = STATE(82),
    [sym_unquote] = STATE(82),
    [sym_break] = STATE(82),
    [sym_set] = STATE(82),
    [sym_if] = STATE(82),
    [sym_do] = STATE(82),
    [sym_while] = STATE(82),
    [sym_fn] = STATE(82),
    [sym__shorthand] = STATE(82),
    [sym_short_quote] = STATE(82),
    [sym_short_splice] = STATE(82),
    [sym_short_quasiquote] = STATE(82),
    [sym_short_unquote] = STATE(82),
    [sym_short_fn] = STATE(82),
    [sym__specials] = STATE(82),
    [sym_extra_defs] = STATE(82),
    [sym__literals] = STATE(82),
    [sym_long_str_literal] = STATE(82),
    [sym_long_buffer_literal] = STATE(82),
    [sym_number_literal] = STATE(82),
    [sym_bool_literal] = STATE(82),
    [sym__identifier] = STATE(82),
    [sym_symbol] = ACTIONS(1014),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(1016),
    [sym_buffer_literal] = ACTIONS(1016),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(1014),
    [sym_keyword] = ACTIONS(1016),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [166] = {
    [sym__expr] = STATE(111),
    [sym_tuple] = STATE(111),
    [sym_sqr_tuple] = STATE(111),
    [sym_array] = STATE(111),
    [sym_sqr_array] = STATE(111),
    [sym_struct] = STATE(111),
    [sym_table] = STATE(111),
    [sym__special_forms] = STATE(111),
    [sym_def] = STATE(111),
    [sym_var] = STATE(111),
    [sym_quote] = STATE(111),
    [sym_splice] = STATE(111),
    [sym_quasiquote] = STATE(111),
    [sym_unquote] = STATE(111),
    [sym_break] = STATE(111),
    [sym_set] = STATE(111),
    [sym_if] = STATE(111),
    [sym_do] = STATE(111),
    [sym_while] = STATE(111),
    [sym_fn] = STATE(111),
    [sym__shorthand] = STATE(111),
    [sym_short_quote] = STATE(111),
    [sym_short_splice] = STATE(111),
    [sym_short_quasiquote] = STATE(111),
    [sym_short_unquote] = STATE(111),
    [sym_short_fn] = STATE(111),
    [sym__specials] = STATE(111),
    [sym_extra_defs] = STATE(111),
    [sym__literals] = STATE(111),
    [sym_long_str_literal] = STATE(111),
    [sym_long_buffer_literal] = STATE(111),
    [sym_number_literal] = STATE(111),
    [sym_bool_literal] = STATE(111),
    [sym__identifier] = STATE(111),
    [sym_symbol] = ACTIONS(1018),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(1020),
    [sym_buffer_literal] = ACTIONS(1020),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(1018),
    [sym_keyword] = ACTIONS(1020),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [167] = {
    [sym__expr] = STATE(49),
    [sym_tuple] = STATE(49),
    [sym_sqr_tuple] = STATE(49),
    [sym_array] = STATE(49),
    [sym_sqr_array] = STATE(49),
    [sym_struct] = STATE(49),
    [sym_table] = STATE(49),
    [sym__special_forms] = STATE(49),
    [sym_def] = STATE(49),
    [sym_var] = STATE(49),
    [sym_quote] = STATE(49),
    [sym_splice] = STATE(49),
    [sym_quasiquote] = STATE(49),
    [sym_unquote] = STATE(49),
    [sym_break] = STATE(49),
    [sym_set] = STATE(49),
    [sym_if] = STATE(49),
    [sym_do] = STATE(49),
    [sym_while] = STATE(49),
    [sym_fn] = STATE(49),
    [sym__shorthand] = STATE(49),
    [sym_short_quote] = STATE(49),
    [sym_short_splice] = STATE(49),
    [sym_short_quasiquote] = STATE(49),
    [sym_short_unquote] = STATE(49),
    [sym_short_fn] = STATE(49),
    [sym__specials] = STATE(49),
    [sym_extra_defs] = STATE(49),
    [sym__literals] = STATE(49),
    [sym_long_str_literal] = STATE(49),
    [sym_long_buffer_literal] = STATE(49),
    [sym_number_literal] = STATE(49),
    [sym_bool_literal] = STATE(49),
    [sym__identifier] = STATE(49),
    [sym_symbol] = ACTIONS(1022),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(1024),
    [sym_buffer_literal] = ACTIONS(1024),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(1022),
    [sym_keyword] = ACTIONS(1024),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [168] = {
    [sym__expr] = STATE(178),
    [sym_tuple] = STATE(178),
    [sym_sqr_tuple] = STATE(178),
    [sym_array] = STATE(178),
    [sym_sqr_array] = STATE(178),
    [sym_struct] = STATE(178),
    [sym_table] = STATE(178),
    [sym__special_forms] = STATE(178),
    [sym_def] = STATE(178),
    [sym_var] = STATE(178),
    [sym_quote] = STATE(178),
    [sym_splice] = STATE(178),
    [sym_quasiquote] = STATE(178),
    [sym_unquote] = STATE(178),
    [sym_break] = STATE(178),
    [sym_set] = STATE(178),
    [sym_if] = STATE(178),
    [sym_do] = STATE(178),
    [sym_while] = STATE(178),
    [sym_fn] = STATE(178),
    [sym__shorthand] = STATE(178),
    [sym_short_quote] = STATE(178),
    [sym_short_splice] = STATE(178),
    [sym_short_quasiquote] = STATE(178),
    [sym_short_unquote] = STATE(178),
    [sym_short_fn] = STATE(178),
    [sym__specials] = STATE(178),
    [sym_extra_defs] = STATE(178),
    [sym__literals] = STATE(178),
    [sym_long_str_literal] = STATE(178),
    [sym_long_buffer_literal] = STATE(178),
    [sym_number_literal] = STATE(178),
    [sym_bool_literal] = STATE(178),
    [sym__identifier] = STATE(178),
    [sym_symbol] = ACTIONS(1026),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(1028),
    [sym_buffer_literal] = ACTIONS(1028),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(1026),
    [sym_keyword] = ACTIONS(1028),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [169] = {
    [sym__expr] = STATE(475),
    [sym_tuple] = STATE(475),
    [sym_sqr_tuple] = STATE(475),
    [sym_array] = STATE(475),
    [sym_sqr_array] = STATE(475),
    [sym_struct] = STATE(475),
    [sym_table] = STATE(475),
    [sym__special_forms] = STATE(475),
    [sym_def] = STATE(475),
    [sym_var] = STATE(475),
    [sym_quote] = STATE(475),
    [sym_splice] = STATE(475),
    [sym_quasiquote] = STATE(475),
    [sym_unquote] = STATE(475),
    [sym_break] = STATE(475),
    [sym_set] = STATE(475),
    [sym_if] = STATE(475),
    [sym_do] = STATE(475),
    [sym_while] = STATE(475),
    [sym_fn] = STATE(475),
    [sym__shorthand] = STATE(475),
    [sym_short_quote] = STATE(475),
    [sym_short_splice] = STATE(475),
    [sym_short_quasiquote] = STATE(475),
    [sym_short_unquote] = STATE(475),
    [sym_short_fn] = STATE(475),
    [sym__specials] = STATE(475),
    [sym_extra_defs] = STATE(475),
    [sym__literals] = STATE(475),
    [sym_long_str_literal] = STATE(475),
    [sym_long_buffer_literal] = STATE(475),
    [sym_number_literal] = STATE(475),
    [sym_bool_literal] = STATE(475),
    [sym__identifier] = STATE(475),
    [sym_symbol] = ACTIONS(1030),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(1032),
    [sym_buffer_literal] = ACTIONS(1032),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(1030),
    [sym_keyword] = ACTIONS(1032),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [170] = {
    [sym__expr] = STATE(77),
    [sym_tuple] = STATE(77),
    [sym_sqr_tuple] = STATE(77),
    [sym_array] = STATE(77),
    [sym_sqr_array] = STATE(77),
    [sym_struct] = STATE(77),
    [sym_table] = STATE(77),
    [sym__special_forms] = STATE(77),
    [sym_def] = STATE(77),
    [sym_var] = STATE(77),
    [sym_quote] = STATE(77),
    [sym_splice] = STATE(77),
    [sym_quasiquote] = STATE(77),
    [sym_unquote] = STATE(77),
    [sym_break] = STATE(77),
    [sym_set] = STATE(77),
    [sym_if] = STATE(77),
    [sym_do] = STATE(77),
    [sym_while] = STATE(77),
    [sym_fn] = STATE(77),
    [sym__shorthand] = STATE(77),
    [sym_short_quote] = STATE(77),
    [sym_short_splice] = STATE(77),
    [sym_short_quasiquote] = STATE(77),
    [sym_short_unquote] = STATE(77),
    [sym_short_fn] = STATE(77),
    [sym__specials] = STATE(77),
    [sym_extra_defs] = STATE(77),
    [sym__literals] = STATE(77),
    [sym_long_str_literal] = STATE(77),
    [sym_long_buffer_literal] = STATE(77),
    [sym_number_literal] = STATE(77),
    [sym_bool_literal] = STATE(77),
    [sym__identifier] = STATE(77),
    [sym_symbol] = ACTIONS(1034),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(1036),
    [sym_buffer_literal] = ACTIONS(1036),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(1034),
    [sym_keyword] = ACTIONS(1036),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [171] = {
    [sym__expr] = STATE(115),
    [sym_tuple] = STATE(115),
    [sym_sqr_tuple] = STATE(115),
    [sym_array] = STATE(115),
    [sym_sqr_array] = STATE(115),
    [sym_struct] = STATE(115),
    [sym_table] = STATE(115),
    [sym__special_forms] = STATE(115),
    [sym_def] = STATE(115),
    [sym_var] = STATE(115),
    [sym_quote] = STATE(115),
    [sym_splice] = STATE(115),
    [sym_quasiquote] = STATE(115),
    [sym_unquote] = STATE(115),
    [sym_break] = STATE(115),
    [sym_set] = STATE(115),
    [sym_if] = STATE(115),
    [sym_do] = STATE(115),
    [sym_while] = STATE(115),
    [sym_fn] = STATE(115),
    [sym__shorthand] = STATE(115),
    [sym_short_quote] = STATE(115),
    [sym_short_splice] = STATE(115),
    [sym_short_quasiquote] = STATE(115),
    [sym_short_unquote] = STATE(115),
    [sym_short_fn] = STATE(115),
    [sym__specials] = STATE(115),
    [sym_extra_defs] = STATE(115),
    [sym__literals] = STATE(115),
    [sym_long_str_literal] = STATE(115),
    [sym_long_buffer_literal] = STATE(115),
    [sym_number_literal] = STATE(115),
    [sym_bool_literal] = STATE(115),
    [sym__identifier] = STATE(115),
    [sym_symbol] = ACTIONS(1038),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(1040),
    [sym_buffer_literal] = ACTIONS(1040),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(1038),
    [sym_keyword] = ACTIONS(1040),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [172] = {
    [sym__expr] = STATE(367),
    [sym_tuple] = STATE(367),
    [sym_sqr_tuple] = STATE(367),
    [sym_array] = STATE(367),
    [sym_sqr_array] = STATE(367),
    [sym_struct] = STATE(367),
    [sym_table] = STATE(367),
    [sym__special_forms] = STATE(367),
    [sym_def] = STATE(367),
    [sym_var] = STATE(367),
    [sym_quote] = STATE(367),
    [sym_splice] = STATE(367),
    [sym_quasiquote] = STATE(367),
    [sym_unquote] = STATE(367),
    [sym_break] = STATE(367),
    [sym_set] = STATE(367),
    [sym_if] = STATE(367),
    [sym_do] = STATE(367),
    [sym_while] = STATE(367),
    [sym_fn] = STATE(367),
    [sym__shorthand] = STATE(367),
    [sym_short_quote] = STATE(367),
    [sym_short_splice] = STATE(367),
    [sym_short_quasiquote] = STATE(367),
    [sym_short_unquote] = STATE(367),
    [sym_short_fn] = STATE(367),
    [sym__specials] = STATE(367),
    [sym_extra_defs] = STATE(367),
    [sym__literals] = STATE(367),
    [sym_long_str_literal] = STATE(367),
    [sym_long_buffer_literal] = STATE(367),
    [sym_number_literal] = STATE(367),
    [sym_bool_literal] = STATE(367),
    [sym__identifier] = STATE(367),
    [sym_symbol] = ACTIONS(1042),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(1044),
    [sym_buffer_literal] = ACTIONS(1044),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(1042),
    [sym_keyword] = ACTIONS(1044),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [173] = {
    [sym__expr] = STATE(449),
    [sym_tuple] = STATE(449),
    [sym_sqr_tuple] = STATE(449),
    [sym_array] = STATE(449),
    [sym_sqr_array] = STATE(449),
    [sym_struct] = STATE(449),
    [sym_table] = STATE(449),
    [sym__special_forms] = STATE(449),
    [sym_def] = STATE(449),
    [sym_var] = STATE(449),
    [sym_quote] = STATE(449),
    [sym_splice] = STATE(449),
    [sym_quasiquote] = STATE(449),
    [sym_unquote] = STATE(449),
    [sym_break] = STATE(449),
    [sym_set] = STATE(449),
    [sym_if] = STATE(449),
    [sym_do] = STATE(449),
    [sym_while] = STATE(449),
    [sym_fn] = STATE(449),
    [sym__shorthand] = STATE(449),
    [sym_short_quote] = STATE(449),
    [sym_short_splice] = STATE(449),
    [sym_short_quasiquote] = STATE(449),
    [sym_short_unquote] = STATE(449),
    [sym_short_fn] = STATE(449),
    [sym__specials] = STATE(449),
    [sym_extra_defs] = STATE(449),
    [sym__literals] = STATE(449),
    [sym_long_str_literal] = STATE(449),
    [sym_long_buffer_literal] = STATE(449),
    [sym_number_literal] = STATE(449),
    [sym_bool_literal] = STATE(449),
    [sym__identifier] = STATE(449),
    [sym_symbol] = ACTIONS(1046),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(1048),
    [sym_buffer_literal] = ACTIONS(1048),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(1046),
    [sym_keyword] = ACTIONS(1048),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [174] = {
    [sym__expr] = STATE(448),
    [sym_tuple] = STATE(448),
    [sym_sqr_tuple] = STATE(448),
    [sym_array] = STATE(448),
    [sym_sqr_array] = STATE(448),
    [sym_struct] = STATE(448),
    [sym_table] = STATE(448),
    [sym__special_forms] = STATE(448),
    [sym_def] = STATE(448),
    [sym_var] = STATE(448),
    [sym_quote] = STATE(448),
    [sym_splice] = STATE(448),
    [sym_quasiquote] = STATE(448),
    [sym_unquote] = STATE(448),
    [sym_break] = STATE(448),
    [sym_set] = STATE(448),
    [sym_if] = STATE(448),
    [sym_do] = STATE(448),
    [sym_while] = STATE(448),
    [sym_fn] = STATE(448),
    [sym__shorthand] = STATE(448),
    [sym_short_quote] = STATE(448),
    [sym_short_splice] = STATE(448),
    [sym_short_quasiquote] = STATE(448),
    [sym_short_unquote] = STATE(448),
    [sym_short_fn] = STATE(448),
    [sym__specials] = STATE(448),
    [sym_extra_defs] = STATE(448),
    [sym__literals] = STATE(448),
    [sym_long_str_literal] = STATE(448),
    [sym_long_buffer_literal] = STATE(448),
    [sym_number_literal] = STATE(448),
    [sym_bool_literal] = STATE(448),
    [sym__identifier] = STATE(448),
    [sym_symbol] = ACTIONS(1050),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(1052),
    [sym_buffer_literal] = ACTIONS(1052),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(1050),
    [sym_keyword] = ACTIONS(1052),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [175] = {
    [sym__expr] = STATE(447),
    [sym_tuple] = STATE(447),
    [sym_sqr_tuple] = STATE(447),
    [sym_array] = STATE(447),
    [sym_sqr_array] = STATE(447),
    [sym_struct] = STATE(447),
    [sym_table] = STATE(447),
    [sym__special_forms] = STATE(447),
    [sym_def] = STATE(447),
    [sym_var] = STATE(447),
    [sym_quote] = STATE(447),
    [sym_splice] = STATE(447),
    [sym_quasiquote] = STATE(447),
    [sym_unquote] = STATE(447),
    [sym_break] = STATE(447),
    [sym_set] = STATE(447),
    [sym_if] = STATE(447),
    [sym_do] = STATE(447),
    [sym_while] = STATE(447),
    [sym_fn] = STATE(447),
    [sym__shorthand] = STATE(447),
    [sym_short_quote] = STATE(447),
    [sym_short_splice] = STATE(447),
    [sym_short_quasiquote] = STATE(447),
    [sym_short_unquote] = STATE(447),
    [sym_short_fn] = STATE(447),
    [sym__specials] = STATE(447),
    [sym_extra_defs] = STATE(447),
    [sym__literals] = STATE(447),
    [sym_long_str_literal] = STATE(447),
    [sym_long_buffer_literal] = STATE(447),
    [sym_number_literal] = STATE(447),
    [sym_bool_literal] = STATE(447),
    [sym__identifier] = STATE(447),
    [sym_symbol] = ACTIONS(1054),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(1056),
    [sym_buffer_literal] = ACTIONS(1056),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(1054),
    [sym_keyword] = ACTIONS(1056),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [176] = {
    [sym__expr] = STATE(68),
    [sym_tuple] = STATE(68),
    [sym_sqr_tuple] = STATE(68),
    [sym_array] = STATE(68),
    [sym_sqr_array] = STATE(68),
    [sym_struct] = STATE(68),
    [sym_table] = STATE(68),
    [sym__special_forms] = STATE(68),
    [sym_def] = STATE(68),
    [sym_var] = STATE(68),
    [sym_quote] = STATE(68),
    [sym_splice] = STATE(68),
    [sym_quasiquote] = STATE(68),
    [sym_unquote] = STATE(68),
    [sym_break] = STATE(68),
    [sym_set] = STATE(68),
    [sym_if] = STATE(68),
    [sym_do] = STATE(68),
    [sym_while] = STATE(68),
    [sym_fn] = STATE(68),
    [sym__shorthand] = STATE(68),
    [sym_short_quote] = STATE(68),
    [sym_short_splice] = STATE(68),
    [sym_short_quasiquote] = STATE(68),
    [sym_short_unquote] = STATE(68),
    [sym_short_fn] = STATE(68),
    [sym__specials] = STATE(68),
    [sym_extra_defs] = STATE(68),
    [sym__literals] = STATE(68),
    [sym_long_str_literal] = STATE(68),
    [sym_long_buffer_literal] = STATE(68),
    [sym_number_literal] = STATE(68),
    [sym_bool_literal] = STATE(68),
    [sym__identifier] = STATE(68),
    [sym_symbol] = ACTIONS(1058),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(1060),
    [sym_buffer_literal] = ACTIONS(1060),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(1058),
    [sym_keyword] = ACTIONS(1060),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
  [177] = {
    [sym__expr] = STATE(445),
    [sym_tuple] = STATE(445),
    [sym_sqr_tuple] = STATE(445),
    [sym_array] = STATE(445),
    [sym_sqr_array] = STATE(445),
    [sym_struct] = STATE(445),
    [sym_table] = STATE(445),
    [sym__special_forms] = STATE(445),
    [sym_def] = STATE(445),
    [sym_var] = STATE(445),
    [sym_quote] = STATE(445),
    [sym_splice] = STATE(445),
    [sym_quasiquote] = STATE(445),
    [sym_unquote] = STATE(445),
    [sym_break] = STATE(445),
    [sym_set] = STATE(445),
    [sym_if] = STATE(445),
    [sym_do] = STATE(445),
    [sym_while] = STATE(445),
    [sym_fn] = STATE(445),
    [sym__shorthand] = STATE(445),
    [sym_short_quote] = STATE(445),
    [sym_short_splice] = STATE(445),
    [sym_short_quasiquote] = STATE(445),
    [sym_short_unquote] = STATE(445),
    [sym_short_fn] = STATE(445),
    [sym__specials] = STATE(445),
    [sym_extra_defs] = STATE(445),
    [sym__literals] = STATE(445),
    [sym_long_str_literal] = STATE(445),
    [sym_long_buffer_literal] = STATE(445),
    [sym_number_literal] = STATE(445),
    [sym_bool_literal] = STATE(445),
    [sym__identifier] = STATE(445),
    [sym_symbol] = ACTIONS(1062),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(714),
    [anon_sym_LBRACK] = ACTIONS(440),
    [anon_sym_AT_LPAREN] = ACTIONS(442),
    [anon_sym_AT_LBRACK] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_AT_LBRACE] = ACTIONS(448),
    [anon_sym_SQUOTE] = ACTIONS(718),
    [anon_sym_SEMI] = ACTIONS(720),
    [anon_sym_TILDE] = ACTIONS(722),
    [anon_sym_COMMA] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(450),
    [sym_str_literal] = ACTIONS(1064),
    [sym_buffer_literal] = ACTIONS(1064),
    [aux_sym_number_literal_token1] = ACTIONS(456),
    [aux_sym_number_literal_token2] = ACTIONS(456),
    [aux_sym_number_literal_token3] = ACTIONS(456),
    [anon_sym_true] = ACTIONS(458),
    [anon_sym_false] = ACTIONS(458),
    [sym_nil_literal] = ACTIONS(1062),
    [sym_keyword] = ACTIONS(1064),
    [sym__long_str] = ACTIONS(728),
    [sym__long_buffer] = ACTIONS(462),
  },
  [178] = {
    [sym__expr] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_sqr_tuple] = STATE(109),
    [sym_array] = STATE(109),
    [sym_sqr_array] = STATE(109),
    [sym_struct] = STATE(109),
    [sym_table] = STATE(109),
    [sym__special_forms] = STATE(109),
    [sym_def] = STATE(109),
    [sym_var] = STATE(109),
    [sym_quote] = STATE(109),
    [sym_splice] = STATE(109),
    [sym_quasiquote] = STATE(109),
    [sym_unquote] = STATE(109),
    [sym_break] = STATE(109),
    [sym_set] = STATE(109),
    [sym_if] = STATE(109),
    [sym_do] = STATE(109),
    [sym_while] = STATE(109),
    [sym_fn] = STATE(109),
    [sym__shorthand] = STATE(109),
    [sym_short_quote] = STATE(109),
    [sym_short_splice] = STATE(109),
    [sym_short_quasiquote] = STATE(109),
    [sym_short_unquote] = STATE(109),
    [sym_short_fn] = STATE(109),
    [sym__specials] = STATE(109),
    [sym_extra_defs] = STATE(109),
    [sym__literals] = STATE(109),
    [sym_long_str_literal] = STATE(109),
    [sym_long_buffer_literal] = STATE(109),
    [sym_number_literal] = STATE(109),
    [sym_bool_literal] = STATE(109),
    [sym__identifier] = STATE(109),
    [sym_symbol] = ACTIONS(1066),
    [sym_line_comment] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(47),
    [anon_sym_AT_LPAREN] = ACTIONS(49),
    [anon_sym_AT_LBRACK] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(53),
    [anon_sym_AT_LBRACE] = ACTIONS(55),
    [anon_sym_SQUOTE] = ACTIONS(81),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_TILDE] = ACTIONS(85),
    [anon_sym_COMMA] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(89),
    [sym_str_literal] = ACTIONS(1068),
    [sym_buffer_literal] = ACTIONS(1068),
    [aux_sym_number_literal_token1] = ACTIONS(95),
    [aux_sym_number_literal_token2] = ACTIONS(95),
    [aux_sym_number_literal_token3] = ACTIONS(95),
    [anon_sym_true] = ACTIONS(97),
    [anon_sym_false] = ACTIONS(97),
    [sym_nil_literal] = ACTIONS(1066),
    [sym_keyword] = ACTIONS(1068),
    [sym__long_str] = ACTIONS(99),
    [sym__long_buffer] = ACTIONS(101),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 13,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1072), 1,
      anon_sym_LPAREN,
    ACTIONS(1077), 1,
      anon_sym_SQUOTE,
    ACTIONS(1080), 1,
      anon_sym_SEMI,
    ACTIONS(1083), 1,
      anon_sym_TILDE,
    ACTIONS(1086), 1,
      anon_sym_COMMA,
    ACTIONS(1092), 1,
      sym__long_str,
    STATE(179), 1,
      aux_sym_def_repeat1,
    STATE(298), 1,
      sym_metadata,
    ACTIONS(1089), 2,
      sym_str_literal,
      sym_keyword,
    ACTIONS(1070), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1075), 8,
      sym__long_buffer,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    STATE(299), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym_long_str_literal,
  [62] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1095), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1097), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [96] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1099), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1101), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [130] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1103), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1105), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [164] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1109), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [198] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1111), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1113), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [232] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1115), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1117), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [266] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1119), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1121), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [300] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1125), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [334] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1129), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [368] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1131), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1133), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [402] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1137), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [436] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1139), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1141), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [470] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1143), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1145), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [504] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1147), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1149), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [538] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1151), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1153), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [572] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1155), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1157), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [606] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1159), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1161), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [640] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1165), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [674] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1169), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [708] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1173), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [742] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1177), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [776] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1179), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1181), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [810] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1185), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [844] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1187), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1189), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [878] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1191), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1193), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [912] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [946] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1199), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [980] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1203), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1205), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1014] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1207), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1209), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1048] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1213), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1082] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1116] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1221), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1150] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1225), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1184] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1229), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1218] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1252] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1235), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1237), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1286] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1241), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1320] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1243), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1245), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1354] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1247), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1249), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1388] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1253), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1422] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1257), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1456] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1261), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1490] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1263), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1265), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1524] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1267), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1269), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1558] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1271), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1273), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1592] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1275), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1277), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1626] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1279), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1281), 19,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1660] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(858), 1,
      sym__long_str,
    ACTIONS(1283), 1,
      sym_symbol,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1289), 1,
      sym_str_literal,
    ACTIONS(1291), 1,
      sym_keyword,
    STATE(300), 1,
      aux_sym_def_repeat1,
    STATE(339), 1,
      sym_long_str_literal,
    STATE(356), 1,
      sym_metadata,
    STATE(12), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(241), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [1719] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(858), 1,
      sym__long_str,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1289), 1,
      sym_str_literal,
    ACTIONS(1291), 1,
      sym_keyword,
    ACTIONS(1293), 1,
      sym_symbol,
    STATE(232), 1,
      aux_sym_def_repeat1,
    STATE(339), 1,
      sym_long_str_literal,
    STATE(356), 1,
      sym_metadata,
    STATE(8), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(241), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [1778] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(858), 1,
      sym__long_str,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1289), 1,
      sym_str_literal,
    ACTIONS(1291), 1,
      sym_keyword,
    ACTIONS(1295), 1,
      sym_symbol,
    STATE(300), 1,
      aux_sym_def_repeat1,
    STATE(339), 1,
      sym_long_str_literal,
    STATE(356), 1,
      sym_metadata,
    STATE(27), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(241), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [1837] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(858), 1,
      sym__long_str,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1289), 1,
      sym_str_literal,
    ACTIONS(1291), 1,
      sym_keyword,
    ACTIONS(1297), 1,
      sym_symbol,
    STATE(229), 1,
      aux_sym_def_repeat1,
    STATE(339), 1,
      sym_long_str_literal,
    STATE(356), 1,
      sym_metadata,
    STATE(17), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(241), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [1896] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1299), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1301), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [1929] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(858), 1,
      sym__long_str,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1289), 1,
      sym_str_literal,
    ACTIONS(1291), 1,
      sym_keyword,
    ACTIONS(1303), 1,
      sym_symbol,
    STATE(300), 1,
      aux_sym_def_repeat1,
    STATE(339), 1,
      sym_long_str_literal,
    STATE(356), 1,
      sym_metadata,
    STATE(9), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(241), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [1988] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(858), 1,
      sym__long_str,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1289), 1,
      sym_str_literal,
    ACTIONS(1291), 1,
      sym_keyword,
    ACTIONS(1305), 1,
      sym_symbol,
    STATE(300), 1,
      aux_sym_def_repeat1,
    STATE(339), 1,
      sym_long_str_literal,
    STATE(356), 1,
      sym_metadata,
    STATE(41), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(241), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2047] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(858), 1,
      sym__long_str,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1289), 1,
      sym_str_literal,
    ACTIONS(1291), 1,
      sym_keyword,
    ACTIONS(1307), 1,
      sym_symbol,
    STATE(233), 1,
      aux_sym_def_repeat1,
    STATE(339), 1,
      sym_long_str_literal,
    STATE(356), 1,
      sym_metadata,
    STATE(32), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(241), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2106] = 16,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(858), 1,
      sym__long_str,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1289), 1,
      sym_str_literal,
    ACTIONS(1291), 1,
      sym_keyword,
    ACTIONS(1309), 1,
      sym_symbol,
    STATE(227), 1,
      aux_sym_def_repeat1,
    STATE(339), 1,
      sym_long_str_literal,
    STATE(356), 1,
      sym_metadata,
    STATE(16), 4,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym__identifier,
    STATE(241), 8,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
  [2165] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1311), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1313), 18,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2198] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1199), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1201), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2230] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1137), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2262] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1315), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1317), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2294] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1203), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1205), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2326] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1319), 1,
      sym_symbol,
    ACTIONS(1325), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1323), 8,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    ACTIONS(1321), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [2362] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1233), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2394] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1319), 1,
      sym_symbol,
    ACTIONS(1329), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1327), 8,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_buffer_literal,
    ACTIONS(1321), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [2430] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1263), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1265), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2462] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1261), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2494] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1257), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2526] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1253), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2558] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1247), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1249), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2590] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1243), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1245), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2622] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1241), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2654] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1235), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1237), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2686] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1271), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1273), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2718] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1275), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1277), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2750] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1267), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1269), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2782] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1229), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2814] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1331), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1333), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2846] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1335), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1337), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2878] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1279), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1281), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2910] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1095), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1097), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2942] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1213), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [2974] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1099), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1101), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3006] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1217), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3038] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1207), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1209), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3070] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1103), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1105), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3102] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1109), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3134] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1111), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1113), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3166] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1339), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1341), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3198] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1115), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1117), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3230] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1221), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3262] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1119), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1121), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3294] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1125), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3326] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1129), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3358] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1131), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1133), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3390] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1225), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3422] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1343), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1345), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3454] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1139), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1141), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3486] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1143), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1145), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3518] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1347), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1349), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3550] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1351), 1,
      sym_symbol,
    ACTIONS(1325), 6,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
    ACTIONS(1353), 7,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_keyword,
    ACTIONS(1323), 10,
      sym__long_str,
      sym__long_buffer,
      anon_sym_RPAREN,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
  [3586] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1195), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1197), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3618] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1191), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1193), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3650] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1147), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1149), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3682] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1151), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1153), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3714] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1155), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1157), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3746] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1159), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1161), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3778] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1355), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1357), 17,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3810] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1165), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3842] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1169), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3874] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1359), 1,
      anon_sym_RPAREN,
    ACTIONS(1319), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1321), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3908] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1327), 1,
      anon_sym_RPAREN,
    ACTIONS(1319), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1321), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3942] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1361), 1,
      anon_sym_RPAREN,
    ACTIONS(1319), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1321), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [3976] = 4,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1363), 1,
      anon_sym_RPAREN,
    ACTIONS(1319), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1321), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4010] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1187), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1189), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4042] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1173), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4074] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1177), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4106] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1179), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1181), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4138] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1185), 17,
      sym__long_str,
      sym__long_buffer,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4170] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1365), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1367), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4201] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1319), 7,
      aux_sym_number_literal_token1,
      aux_sym_number_literal_token2,
      aux_sym_number_literal_token3,
      anon_sym_true,
      anon_sym_false,
      sym_nil_literal,
      sym_symbol,
    ACTIONS(1321), 16,
      sym__long_str,
      sym__long_buffer,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AT_LPAREN,
      anon_sym_AT_LBRACK,
      anon_sym_LBRACE,
      anon_sym_AT_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      anon_sym_PIPE,
      sym_str_literal,
      sym_buffer_literal,
      sym_keyword,
  [4232] = 13,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1070), 1,
      sym_symbol,
    ACTIONS(1075), 1,
      anon_sym_LBRACK,
    ACTIONS(1369), 1,
      anon_sym_LPAREN,
    ACTIONS(1372), 1,
      anon_sym_SQUOTE,
    ACTIONS(1375), 1,
      anon_sym_SEMI,
    ACTIONS(1378), 1,
      anon_sym_TILDE,
    ACTIONS(1381), 1,
      anon_sym_COMMA,
    ACTIONS(1387), 1,
      sym__long_str,
    STATE(300), 1,
      aux_sym_def_repeat1,
    STATE(356), 1,
      sym_metadata,
    ACTIONS(1384), 2,
      sym_str_literal,
      sym_keyword,
    STATE(339), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym_long_str_literal,
  [4281] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1390), 1,
      sym_symbol,
    ACTIONS(1392), 1,
      sym_keyword,
    STATE(306), 1,
      sym__name,
    STATE(24), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(279), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [4328] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1390), 1,
      sym_symbol,
    ACTIONS(1392), 1,
      sym_keyword,
    STATE(305), 1,
      sym__name,
    STATE(40), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(279), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [4375] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1390), 1,
      sym_symbol,
    ACTIONS(1392), 1,
      sym_keyword,
    STATE(307), 1,
      sym__name,
    STATE(28), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(279), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [4422] = 12,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1390), 1,
      sym_symbol,
    ACTIONS(1392), 1,
      sym_keyword,
    STATE(308), 1,
      sym__name,
    STATE(33), 3,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
    STATE(279), 9,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [4469] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1394), 1,
      sym_symbol,
    ACTIONS(1396), 1,
      sym_keyword,
    STATE(20), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [4511] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1398), 1,
      sym_symbol,
    ACTIONS(1400), 1,
      sym_keyword,
    STATE(13), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [4553] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1402), 1,
      sym_symbol,
    ACTIONS(1404), 1,
      sym_keyword,
    STATE(30), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [4595] = 10,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(81), 1,
      anon_sym_SQUOTE,
    ACTIONS(83), 1,
      anon_sym_SEMI,
    ACTIONS(85), 1,
      anon_sym_TILDE,
    ACTIONS(87), 1,
      anon_sym_COMMA,
    ACTIONS(1285), 1,
      anon_sym_LPAREN,
    ACTIONS(1287), 1,
      anon_sym_LBRACK,
    ACTIONS(1406), 1,
      sym_symbol,
    ACTIONS(1408), 1,
      sym_keyword,
    STATE(18), 12,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym__parameters,
      sym_parameters,
      sym_tuple_parameters,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__identifier,
  [4637] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(842), 1,
      anon_sym_SQUOTE,
    ACTIONS(844), 1,
      anon_sym_SEMI,
    ACTIONS(846), 1,
      anon_sym_TILDE,
    ACTIONS(848), 1,
      anon_sym_COMMA,
    ACTIONS(1410), 1,
      sym_symbol,
    ACTIONS(1412), 1,
      anon_sym_LPAREN,
    ACTIONS(1414), 1,
      sym_keyword,
    STATE(230), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [4674] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(842), 1,
      anon_sym_SQUOTE,
    ACTIONS(844), 1,
      anon_sym_SEMI,
    ACTIONS(846), 1,
      anon_sym_TILDE,
    ACTIONS(848), 1,
      anon_sym_COMMA,
    ACTIONS(1412), 1,
      anon_sym_LPAREN,
    ACTIONS(1416), 1,
      sym_symbol,
    ACTIONS(1418), 1,
      sym_keyword,
    STATE(235), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [4711] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(842), 1,
      anon_sym_SQUOTE,
    ACTIONS(844), 1,
      anon_sym_SEMI,
    ACTIONS(846), 1,
      anon_sym_TILDE,
    ACTIONS(848), 1,
      anon_sym_COMMA,
    ACTIONS(1412), 1,
      anon_sym_LPAREN,
    ACTIONS(1420), 1,
      sym_symbol,
    ACTIONS(1422), 1,
      sym_keyword,
    STATE(228), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [4748] = 9,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(842), 1,
      anon_sym_SQUOTE,
    ACTIONS(844), 1,
      anon_sym_SEMI,
    ACTIONS(846), 1,
      anon_sym_TILDE,
    ACTIONS(848), 1,
      anon_sym_COMMA,
    ACTIONS(1412), 1,
      anon_sym_LPAREN,
    ACTIONS(1424), 1,
      sym_symbol,
    ACTIONS(1426), 1,
      sym_keyword,
    STATE(234), 10,
      sym_quote,
      sym_splice,
      sym_quasiquote,
      sym_unquote,
      sym_short_quote,
      sym_short_splice,
      sym_short_quasiquote,
      sym_short_unquote,
      sym__name,
      sym__identifier,
  [4785] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1131), 1,
      sym_symbol,
    ACTIONS(1133), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [4803] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1179), 1,
      sym_symbol,
    ACTIONS(1181), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [4821] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1267), 1,
      sym_symbol,
    ACTIONS(1269), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [4839] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1263), 1,
      sym_symbol,
    ACTIONS(1265), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [4857] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1259), 1,
      sym_symbol,
    ACTIONS(1261), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [4875] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1271), 1,
      sym_symbol,
    ACTIONS(1273), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [4893] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1255), 1,
      sym_symbol,
    ACTIONS(1257), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [4911] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1251), 1,
      sym_symbol,
    ACTIONS(1253), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [4929] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1247), 1,
      sym_symbol,
    ACTIONS(1249), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [4947] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1243), 1,
      sym_symbol,
    ACTIONS(1245), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [4965] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1239), 1,
      sym_symbol,
    ACTIONS(1241), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [4983] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1235), 1,
      sym_symbol,
    ACTIONS(1237), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5001] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1231), 1,
      sym_symbol,
    ACTIONS(1233), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5019] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1227), 1,
      sym_symbol,
    ACTIONS(1229), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5037] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1223), 1,
      sym_symbol,
    ACTIONS(1225), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5055] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1219), 1,
      sym_symbol,
    ACTIONS(1221), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5073] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1215), 1,
      sym_symbol,
    ACTIONS(1217), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5091] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1099), 1,
      sym_symbol,
    ACTIONS(1101), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5109] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1095), 1,
      sym_symbol,
    ACTIONS(1097), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5127] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1203), 1,
      sym_symbol,
    ACTIONS(1205), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5145] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1199), 1,
      sym_symbol,
    ACTIONS(1201), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5163] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1195), 1,
      sym_symbol,
    ACTIONS(1197), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5181] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1191), 1,
      sym_symbol,
    ACTIONS(1193), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5199] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1187), 1,
      sym_symbol,
    ACTIONS(1189), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5217] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1183), 1,
      sym_symbol,
    ACTIONS(1185), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5235] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1275), 1,
      sym_symbol,
    ACTIONS(1277), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5253] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1319), 1,
      sym_symbol,
    ACTIONS(1321), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5271] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1175), 1,
      sym_symbol,
    ACTIONS(1177), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5289] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1171), 1,
      sym_symbol,
    ACTIONS(1173), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5307] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1167), 1,
      sym_symbol,
    ACTIONS(1169), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5325] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1163), 1,
      sym_symbol,
    ACTIONS(1165), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5343] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1159), 1,
      sym_symbol,
    ACTIONS(1161), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5361] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1155), 1,
      sym_symbol,
    ACTIONS(1157), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5379] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1151), 1,
      sym_symbol,
    ACTIONS(1153), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5397] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1147), 1,
      sym_symbol,
    ACTIONS(1149), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5415] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1143), 1,
      sym_symbol,
    ACTIONS(1145), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5433] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1139), 1,
      sym_symbol,
    ACTIONS(1141), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5451] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1135), 1,
      sym_symbol,
    ACTIONS(1137), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5469] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1127), 1,
      sym_symbol,
    ACTIONS(1129), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5487] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1123), 1,
      sym_symbol,
    ACTIONS(1125), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5505] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1119), 1,
      sym_symbol,
    ACTIONS(1121), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5523] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1115), 1,
      sym_symbol,
    ACTIONS(1117), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5541] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1111), 1,
      sym_symbol,
    ACTIONS(1113), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5559] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1365), 1,
      sym_symbol,
    ACTIONS(1367), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5577] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1107), 1,
      sym_symbol,
    ACTIONS(1109), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5595] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1103), 1,
      sym_symbol,
    ACTIONS(1105), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5613] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1207), 1,
      sym_symbol,
    ACTIONS(1209), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5631] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1211), 1,
      sym_symbol,
    ACTIONS(1213), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5649] = 3,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1279), 1,
      sym_symbol,
    ACTIONS(1281), 9,
      sym__long_str,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_SEMI,
      anon_sym_TILDE,
      anon_sym_COMMA,
      sym_str_literal,
      sym_keyword,
  [5667] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1428), 1,
      anon_sym_quote,
    ACTIONS(1430), 1,
      anon_sym_splice,
    ACTIONS(1432), 1,
      anon_sym_quasiquote,
    ACTIONS(1434), 1,
      anon_sym_unquote,
  [5683] = 5,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1436), 1,
      anon_sym_quote,
    ACTIONS(1438), 1,
      anon_sym_splice,
    ACTIONS(1440), 1,
      anon_sym_quasiquote,
    ACTIONS(1442), 1,
      anon_sym_unquote,
  [5699] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1217), 1,
      anon_sym_RPAREN,
  [5706] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1444), 1,
      anon_sym_RPAREN,
  [5713] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1446), 1,
      anon_sym_RPAREN,
  [5720] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1448), 1,
      anon_sym_RPAREN,
  [5727] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1450), 1,
      anon_sym_RPAREN,
  [5734] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1452), 1,
      anon_sym_RPAREN,
  [5741] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1454), 1,
      anon_sym_RPAREN,
  [5748] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1456), 1,
      anon_sym_RPAREN,
  [5755] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1458), 1,
      anon_sym_RPAREN,
  [5762] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1460), 1,
      anon_sym_RPAREN,
  [5769] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1462), 1,
      anon_sym_RPAREN,
  [5776] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1464), 1,
      anon_sym_RPAREN,
  [5783] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1466), 1,
      anon_sym_RPAREN,
  [5790] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1468), 1,
      anon_sym_RPAREN,
  [5797] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1470), 1,
      anon_sym_RPAREN,
  [5804] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1472), 1,
      anon_sym_RPAREN,
  [5811] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1474), 1,
      anon_sym_RPAREN,
  [5818] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1476), 1,
      anon_sym_RPAREN,
  [5825] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1478), 1,
      anon_sym_RPAREN,
  [5832] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1480), 1,
      anon_sym_RPAREN,
  [5839] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1482), 1,
      anon_sym_RPAREN,
  [5846] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1484), 1,
      anon_sym_RPAREN,
  [5853] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1486), 1,
      anon_sym_RPAREN,
  [5860] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1488), 1,
      anon_sym_RPAREN,
  [5867] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1490), 1,
      anon_sym_RPAREN,
  [5874] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1492), 1,
      anon_sym_RPAREN,
  [5881] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1494), 1,
      anon_sym_RPAREN,
  [5888] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1496), 1,
      anon_sym_RPAREN,
  [5895] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1498), 1,
      anon_sym_RPAREN,
  [5902] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1500), 1,
      anon_sym_RPAREN,
  [5909] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1502), 1,
      anon_sym_RPAREN,
  [5916] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1504), 1,
      anon_sym_RPAREN,
  [5923] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1506), 1,
      anon_sym_RPAREN,
  [5930] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1508), 1,
      anon_sym_RPAREN,
  [5937] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1510), 1,
      anon_sym_RPAREN,
  [5944] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1512), 1,
      anon_sym_RPAREN,
  [5951] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1514), 1,
      anon_sym_RPAREN,
  [5958] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1516), 1,
      anon_sym_RPAREN,
  [5965] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1518), 1,
      anon_sym_RPAREN,
  [5972] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1520), 1,
      anon_sym_RPAREN,
  [5979] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1522), 1,
      anon_sym_RPAREN,
  [5986] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1524), 1,
      anon_sym_RPAREN,
  [5993] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1269), 1,
      anon_sym_RPAREN,
  [6000] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1526), 1,
      anon_sym_RPAREN,
  [6007] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1265), 1,
      anon_sym_RPAREN,
  [6014] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1261), 1,
      anon_sym_RPAREN,
  [6021] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1528), 1,
      anon_sym_RPAREN,
  [6028] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1530), 1,
      anon_sym_RPAREN,
  [6035] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1532), 1,
      anon_sym_RPAREN,
  [6042] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1534), 1,
      anon_sym_RPAREN,
  [6049] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1536), 1,
      anon_sym_RPAREN,
  [6056] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1257), 1,
      anon_sym_RPAREN,
  [6063] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1538), 1,
      anon_sym_RPAREN,
  [6070] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1253), 1,
      anon_sym_RPAREN,
  [6077] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1249), 1,
      anon_sym_RPAREN,
  [6084] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1245), 1,
      anon_sym_RPAREN,
  [6091] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1241), 1,
      anon_sym_RPAREN,
  [6098] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1237), 1,
      anon_sym_RPAREN,
  [6105] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1233), 1,
      anon_sym_RPAREN,
  [6112] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1229), 1,
      anon_sym_RPAREN,
  [6119] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1225), 1,
      anon_sym_RPAREN,
  [6126] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1221), 1,
      anon_sym_RPAREN,
  [6133] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1101), 1,
      anon_sym_RPAREN,
  [6140] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1097), 1,
      anon_sym_RPAREN,
  [6147] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1205), 1,
      anon_sym_RPAREN,
  [6154] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1201), 1,
      anon_sym_RPAREN,
  [6161] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1197), 1,
      anon_sym_RPAREN,
  [6168] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1193), 1,
      anon_sym_RPAREN,
  [6175] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1189), 1,
      anon_sym_RPAREN,
  [6182] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1185), 1,
      anon_sym_RPAREN,
  [6189] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1181), 1,
      anon_sym_RPAREN,
  [6196] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1177), 1,
      anon_sym_RPAREN,
  [6203] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1173), 1,
      anon_sym_RPAREN,
  [6210] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1169), 1,
      anon_sym_RPAREN,
  [6217] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1165), 1,
      anon_sym_RPAREN,
  [6224] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1161), 1,
      anon_sym_RPAREN,
  [6231] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1157), 1,
      anon_sym_RPAREN,
  [6238] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1153), 1,
      anon_sym_RPAREN,
  [6245] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1149), 1,
      anon_sym_RPAREN,
  [6252] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1145), 1,
      anon_sym_RPAREN,
  [6259] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1141), 1,
      anon_sym_RPAREN,
  [6266] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1137), 1,
      anon_sym_RPAREN,
  [6273] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1133), 1,
      anon_sym_RPAREN,
  [6280] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1129), 1,
      anon_sym_RPAREN,
  [6287] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1125), 1,
      anon_sym_RPAREN,
  [6294] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1121), 1,
      anon_sym_RPAREN,
  [6301] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1117), 1,
      anon_sym_RPAREN,
  [6308] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1113), 1,
      anon_sym_RPAREN,
  [6315] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1109), 1,
      anon_sym_RPAREN,
  [6322] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1105), 1,
      anon_sym_RPAREN,
  [6329] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1209), 1,
      anon_sym_RPAREN,
  [6336] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1213), 1,
      anon_sym_RPAREN,
  [6343] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1281), 1,
      anon_sym_RPAREN,
  [6350] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1277), 1,
      anon_sym_RPAREN,
  [6357] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1273), 1,
      anon_sym_RPAREN,
  [6364] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1540), 1,
      ts_builtin_sym_end,
  [6371] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1542), 1,
      anon_sym_RPAREN,
  [6378] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1544), 1,
      anon_sym_RPAREN,
  [6385] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1546), 1,
      anon_sym_RPAREN,
  [6392] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1548), 1,
      anon_sym_RPAREN,
  [6399] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1550), 1,
      anon_sym_RPAREN,
  [6406] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1552), 1,
      anon_sym_RPAREN,
  [6413] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1554), 1,
      anon_sym_RPAREN,
  [6420] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1556), 1,
      anon_sym_RPAREN,
  [6427] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1558), 1,
      anon_sym_RPAREN,
  [6434] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1560), 1,
      anon_sym_RPAREN,
  [6441] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1562), 1,
      anon_sym_RPAREN,
  [6448] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1564), 1,
      anon_sym_RPAREN,
  [6455] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1566), 1,
      anon_sym_RPAREN,
  [6462] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1568), 1,
      anon_sym_RPAREN,
  [6469] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1570), 1,
      anon_sym_RPAREN,
  [6476] = 2,
    ACTIONS(3), 1,
      sym_line_comment,
    ACTIONS(1572), 1,
      anon_sym_RPAREN,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(179)] = 0,
  [SMALL_STATE(180)] = 62,
  [SMALL_STATE(181)] = 96,
  [SMALL_STATE(182)] = 130,
  [SMALL_STATE(183)] = 164,
  [SMALL_STATE(184)] = 198,
  [SMALL_STATE(185)] = 232,
  [SMALL_STATE(186)] = 266,
  [SMALL_STATE(187)] = 300,
  [SMALL_STATE(188)] = 334,
  [SMALL_STATE(189)] = 368,
  [SMALL_STATE(190)] = 402,
  [SMALL_STATE(191)] = 436,
  [SMALL_STATE(192)] = 470,
  [SMALL_STATE(193)] = 504,
  [SMALL_STATE(194)] = 538,
  [SMALL_STATE(195)] = 572,
  [SMALL_STATE(196)] = 606,
  [SMALL_STATE(197)] = 640,
  [SMALL_STATE(198)] = 674,
  [SMALL_STATE(199)] = 708,
  [SMALL_STATE(200)] = 742,
  [SMALL_STATE(201)] = 776,
  [SMALL_STATE(202)] = 810,
  [SMALL_STATE(203)] = 844,
  [SMALL_STATE(204)] = 878,
  [SMALL_STATE(205)] = 912,
  [SMALL_STATE(206)] = 946,
  [SMALL_STATE(207)] = 980,
  [SMALL_STATE(208)] = 1014,
  [SMALL_STATE(209)] = 1048,
  [SMALL_STATE(210)] = 1082,
  [SMALL_STATE(211)] = 1116,
  [SMALL_STATE(212)] = 1150,
  [SMALL_STATE(213)] = 1184,
  [SMALL_STATE(214)] = 1218,
  [SMALL_STATE(215)] = 1252,
  [SMALL_STATE(216)] = 1286,
  [SMALL_STATE(217)] = 1320,
  [SMALL_STATE(218)] = 1354,
  [SMALL_STATE(219)] = 1388,
  [SMALL_STATE(220)] = 1422,
  [SMALL_STATE(221)] = 1456,
  [SMALL_STATE(222)] = 1490,
  [SMALL_STATE(223)] = 1524,
  [SMALL_STATE(224)] = 1558,
  [SMALL_STATE(225)] = 1592,
  [SMALL_STATE(226)] = 1626,
  [SMALL_STATE(227)] = 1660,
  [SMALL_STATE(228)] = 1719,
  [SMALL_STATE(229)] = 1778,
  [SMALL_STATE(230)] = 1837,
  [SMALL_STATE(231)] = 1896,
  [SMALL_STATE(232)] = 1929,
  [SMALL_STATE(233)] = 1988,
  [SMALL_STATE(234)] = 2047,
  [SMALL_STATE(235)] = 2106,
  [SMALL_STATE(236)] = 2165,
  [SMALL_STATE(237)] = 2198,
  [SMALL_STATE(238)] = 2230,
  [SMALL_STATE(239)] = 2262,
  [SMALL_STATE(240)] = 2294,
  [SMALL_STATE(241)] = 2326,
  [SMALL_STATE(242)] = 2362,
  [SMALL_STATE(243)] = 2394,
  [SMALL_STATE(244)] = 2430,
  [SMALL_STATE(245)] = 2462,
  [SMALL_STATE(246)] = 2494,
  [SMALL_STATE(247)] = 2526,
  [SMALL_STATE(248)] = 2558,
  [SMALL_STATE(249)] = 2590,
  [SMALL_STATE(250)] = 2622,
  [SMALL_STATE(251)] = 2654,
  [SMALL_STATE(252)] = 2686,
  [SMALL_STATE(253)] = 2718,
  [SMALL_STATE(254)] = 2750,
  [SMALL_STATE(255)] = 2782,
  [SMALL_STATE(256)] = 2814,
  [SMALL_STATE(257)] = 2846,
  [SMALL_STATE(258)] = 2878,
  [SMALL_STATE(259)] = 2910,
  [SMALL_STATE(260)] = 2942,
  [SMALL_STATE(261)] = 2974,
  [SMALL_STATE(262)] = 3006,
  [SMALL_STATE(263)] = 3038,
  [SMALL_STATE(264)] = 3070,
  [SMALL_STATE(265)] = 3102,
  [SMALL_STATE(266)] = 3134,
  [SMALL_STATE(267)] = 3166,
  [SMALL_STATE(268)] = 3198,
  [SMALL_STATE(269)] = 3230,
  [SMALL_STATE(270)] = 3262,
  [SMALL_STATE(271)] = 3294,
  [SMALL_STATE(272)] = 3326,
  [SMALL_STATE(273)] = 3358,
  [SMALL_STATE(274)] = 3390,
  [SMALL_STATE(275)] = 3422,
  [SMALL_STATE(276)] = 3454,
  [SMALL_STATE(277)] = 3486,
  [SMALL_STATE(278)] = 3518,
  [SMALL_STATE(279)] = 3550,
  [SMALL_STATE(280)] = 3586,
  [SMALL_STATE(281)] = 3618,
  [SMALL_STATE(282)] = 3650,
  [SMALL_STATE(283)] = 3682,
  [SMALL_STATE(284)] = 3714,
  [SMALL_STATE(285)] = 3746,
  [SMALL_STATE(286)] = 3778,
  [SMALL_STATE(287)] = 3810,
  [SMALL_STATE(288)] = 3842,
  [SMALL_STATE(289)] = 3874,
  [SMALL_STATE(290)] = 3908,
  [SMALL_STATE(291)] = 3942,
  [SMALL_STATE(292)] = 3976,
  [SMALL_STATE(293)] = 4010,
  [SMALL_STATE(294)] = 4042,
  [SMALL_STATE(295)] = 4074,
  [SMALL_STATE(296)] = 4106,
  [SMALL_STATE(297)] = 4138,
  [SMALL_STATE(298)] = 4170,
  [SMALL_STATE(299)] = 4201,
  [SMALL_STATE(300)] = 4232,
  [SMALL_STATE(301)] = 4281,
  [SMALL_STATE(302)] = 4328,
  [SMALL_STATE(303)] = 4375,
  [SMALL_STATE(304)] = 4422,
  [SMALL_STATE(305)] = 4469,
  [SMALL_STATE(306)] = 4511,
  [SMALL_STATE(307)] = 4553,
  [SMALL_STATE(308)] = 4595,
  [SMALL_STATE(309)] = 4637,
  [SMALL_STATE(310)] = 4674,
  [SMALL_STATE(311)] = 4711,
  [SMALL_STATE(312)] = 4748,
  [SMALL_STATE(313)] = 4785,
  [SMALL_STATE(314)] = 4803,
  [SMALL_STATE(315)] = 4821,
  [SMALL_STATE(316)] = 4839,
  [SMALL_STATE(317)] = 4857,
  [SMALL_STATE(318)] = 4875,
  [SMALL_STATE(319)] = 4893,
  [SMALL_STATE(320)] = 4911,
  [SMALL_STATE(321)] = 4929,
  [SMALL_STATE(322)] = 4947,
  [SMALL_STATE(323)] = 4965,
  [SMALL_STATE(324)] = 4983,
  [SMALL_STATE(325)] = 5001,
  [SMALL_STATE(326)] = 5019,
  [SMALL_STATE(327)] = 5037,
  [SMALL_STATE(328)] = 5055,
  [SMALL_STATE(329)] = 5073,
  [SMALL_STATE(330)] = 5091,
  [SMALL_STATE(331)] = 5109,
  [SMALL_STATE(332)] = 5127,
  [SMALL_STATE(333)] = 5145,
  [SMALL_STATE(334)] = 5163,
  [SMALL_STATE(335)] = 5181,
  [SMALL_STATE(336)] = 5199,
  [SMALL_STATE(337)] = 5217,
  [SMALL_STATE(338)] = 5235,
  [SMALL_STATE(339)] = 5253,
  [SMALL_STATE(340)] = 5271,
  [SMALL_STATE(341)] = 5289,
  [SMALL_STATE(342)] = 5307,
  [SMALL_STATE(343)] = 5325,
  [SMALL_STATE(344)] = 5343,
  [SMALL_STATE(345)] = 5361,
  [SMALL_STATE(346)] = 5379,
  [SMALL_STATE(347)] = 5397,
  [SMALL_STATE(348)] = 5415,
  [SMALL_STATE(349)] = 5433,
  [SMALL_STATE(350)] = 5451,
  [SMALL_STATE(351)] = 5469,
  [SMALL_STATE(352)] = 5487,
  [SMALL_STATE(353)] = 5505,
  [SMALL_STATE(354)] = 5523,
  [SMALL_STATE(355)] = 5541,
  [SMALL_STATE(356)] = 5559,
  [SMALL_STATE(357)] = 5577,
  [SMALL_STATE(358)] = 5595,
  [SMALL_STATE(359)] = 5613,
  [SMALL_STATE(360)] = 5631,
  [SMALL_STATE(361)] = 5649,
  [SMALL_STATE(362)] = 5667,
  [SMALL_STATE(363)] = 5683,
  [SMALL_STATE(364)] = 5699,
  [SMALL_STATE(365)] = 5706,
  [SMALL_STATE(366)] = 5713,
  [SMALL_STATE(367)] = 5720,
  [SMALL_STATE(368)] = 5727,
  [SMALL_STATE(369)] = 5734,
  [SMALL_STATE(370)] = 5741,
  [SMALL_STATE(371)] = 5748,
  [SMALL_STATE(372)] = 5755,
  [SMALL_STATE(373)] = 5762,
  [SMALL_STATE(374)] = 5769,
  [SMALL_STATE(375)] = 5776,
  [SMALL_STATE(376)] = 5783,
  [SMALL_STATE(377)] = 5790,
  [SMALL_STATE(378)] = 5797,
  [SMALL_STATE(379)] = 5804,
  [SMALL_STATE(380)] = 5811,
  [SMALL_STATE(381)] = 5818,
  [SMALL_STATE(382)] = 5825,
  [SMALL_STATE(383)] = 5832,
  [SMALL_STATE(384)] = 5839,
  [SMALL_STATE(385)] = 5846,
  [SMALL_STATE(386)] = 5853,
  [SMALL_STATE(387)] = 5860,
  [SMALL_STATE(388)] = 5867,
  [SMALL_STATE(389)] = 5874,
  [SMALL_STATE(390)] = 5881,
  [SMALL_STATE(391)] = 5888,
  [SMALL_STATE(392)] = 5895,
  [SMALL_STATE(393)] = 5902,
  [SMALL_STATE(394)] = 5909,
  [SMALL_STATE(395)] = 5916,
  [SMALL_STATE(396)] = 5923,
  [SMALL_STATE(397)] = 5930,
  [SMALL_STATE(398)] = 5937,
  [SMALL_STATE(399)] = 5944,
  [SMALL_STATE(400)] = 5951,
  [SMALL_STATE(401)] = 5958,
  [SMALL_STATE(402)] = 5965,
  [SMALL_STATE(403)] = 5972,
  [SMALL_STATE(404)] = 5979,
  [SMALL_STATE(405)] = 5986,
  [SMALL_STATE(406)] = 5993,
  [SMALL_STATE(407)] = 6000,
  [SMALL_STATE(408)] = 6007,
  [SMALL_STATE(409)] = 6014,
  [SMALL_STATE(410)] = 6021,
  [SMALL_STATE(411)] = 6028,
  [SMALL_STATE(412)] = 6035,
  [SMALL_STATE(413)] = 6042,
  [SMALL_STATE(414)] = 6049,
  [SMALL_STATE(415)] = 6056,
  [SMALL_STATE(416)] = 6063,
  [SMALL_STATE(417)] = 6070,
  [SMALL_STATE(418)] = 6077,
  [SMALL_STATE(419)] = 6084,
  [SMALL_STATE(420)] = 6091,
  [SMALL_STATE(421)] = 6098,
  [SMALL_STATE(422)] = 6105,
  [SMALL_STATE(423)] = 6112,
  [SMALL_STATE(424)] = 6119,
  [SMALL_STATE(425)] = 6126,
  [SMALL_STATE(426)] = 6133,
  [SMALL_STATE(427)] = 6140,
  [SMALL_STATE(428)] = 6147,
  [SMALL_STATE(429)] = 6154,
  [SMALL_STATE(430)] = 6161,
  [SMALL_STATE(431)] = 6168,
  [SMALL_STATE(432)] = 6175,
  [SMALL_STATE(433)] = 6182,
  [SMALL_STATE(434)] = 6189,
  [SMALL_STATE(435)] = 6196,
  [SMALL_STATE(436)] = 6203,
  [SMALL_STATE(437)] = 6210,
  [SMALL_STATE(438)] = 6217,
  [SMALL_STATE(439)] = 6224,
  [SMALL_STATE(440)] = 6231,
  [SMALL_STATE(441)] = 6238,
  [SMALL_STATE(442)] = 6245,
  [SMALL_STATE(443)] = 6252,
  [SMALL_STATE(444)] = 6259,
  [SMALL_STATE(445)] = 6266,
  [SMALL_STATE(446)] = 6273,
  [SMALL_STATE(447)] = 6280,
  [SMALL_STATE(448)] = 6287,
  [SMALL_STATE(449)] = 6294,
  [SMALL_STATE(450)] = 6301,
  [SMALL_STATE(451)] = 6308,
  [SMALL_STATE(452)] = 6315,
  [SMALL_STATE(453)] = 6322,
  [SMALL_STATE(454)] = 6329,
  [SMALL_STATE(455)] = 6336,
  [SMALL_STATE(456)] = 6343,
  [SMALL_STATE(457)] = 6350,
  [SMALL_STATE(458)] = 6357,
  [SMALL_STATE(459)] = 6364,
  [SMALL_STATE(460)] = 6371,
  [SMALL_STATE(461)] = 6378,
  [SMALL_STATE(462)] = 6385,
  [SMALL_STATE(463)] = 6392,
  [SMALL_STATE(464)] = 6399,
  [SMALL_STATE(465)] = 6406,
  [SMALL_STATE(466)] = 6413,
  [SMALL_STATE(467)] = 6420,
  [SMALL_STATE(468)] = 6427,
  [SMALL_STATE(469)] = 6434,
  [SMALL_STATE(470)] = 6441,
  [SMALL_STATE(471)] = 6448,
  [SMALL_STATE(472)] = 6455,
  [SMALL_STATE(473)] = 6462,
  [SMALL_STATE(474)] = 6469,
  [SMALL_STATE(475)] = 6476,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = true}, REDUCE(sym_source_file, 0),
  [7] = {.count = 1, .reusable = false}, SHIFT(71),
  [9] = {.count = 1, .reusable = true}, SHIFT(3),
  [11] = {.count = 1, .reusable = true}, SHIFT(75),
  [13] = {.count = 1, .reusable = true}, SHIFT(47),
  [15] = {.count = 1, .reusable = true}, SHIFT(79),
  [17] = {.count = 1, .reusable = true}, SHIFT(10),
  [19] = {.count = 1, .reusable = true}, SHIFT(11),
  [21] = {.count = 1, .reusable = true}, SHIFT(134),
  [23] = {.count = 1, .reusable = true}, SHIFT(133),
  [25] = {.count = 1, .reusable = true}, SHIFT(128),
  [27] = {.count = 1, .reusable = true}, SHIFT(149),
  [29] = {.count = 1, .reusable = true}, SHIFT(151),
  [31] = {.count = 1, .reusable = true}, SHIFT(71),
  [33] = {.count = 1, .reusable = false}, SHIFT(253),
  [35] = {.count = 1, .reusable = false}, SHIFT(258),
  [37] = {.count = 1, .reusable = true}, SHIFT(254),
  [39] = {.count = 1, .reusable = true}, SHIFT(252),
  [41] = {.count = 1, .reusable = false}, SHIFT(236),
  [43] = {.count = 1, .reusable = true}, SHIFT(4),
  [45] = {.count = 1, .reusable = true}, SHIFT(360),
  [47] = {.count = 1, .reusable = true}, SHIFT(88),
  [49] = {.count = 1, .reusable = true}, SHIFT(91),
  [51] = {.count = 1, .reusable = true}, SHIFT(92),
  [53] = {.count = 1, .reusable = true}, SHIFT(15),
  [55] = {.count = 1, .reusable = true}, SHIFT(19),
  [57] = {.count = 1, .reusable = false}, SHIFT(165),
  [59] = {.count = 1, .reusable = false}, SHIFT(167),
  [61] = {.count = 1, .reusable = false}, SHIFT(160),
  [63] = {.count = 1, .reusable = false}, SHIFT(118),
  [65] = {.count = 1, .reusable = false}, SHIFT(158),
  [67] = {.count = 1, .reusable = false}, SHIFT(157),
  [69] = {.count = 1, .reusable = false}, SHIFT(114),
  [71] = {.count = 1, .reusable = false}, SHIFT(156),
  [73] = {.count = 1, .reusable = false}, SHIFT(168),
  [75] = {.count = 1, .reusable = false}, SHIFT(34),
  [77] = {.count = 1, .reusable = false}, SHIFT(154),
  [79] = {.count = 1, .reusable = false}, SHIFT(301),
  [81] = {.count = 1, .reusable = true}, SHIFT(145),
  [83] = {.count = 1, .reusable = true}, SHIFT(146),
  [85] = {.count = 1, .reusable = true}, SHIFT(147),
  [87] = {.count = 1, .reusable = true}, SHIFT(148),
  [89] = {.count = 1, .reusable = true}, SHIFT(119),
  [91] = {.count = 1, .reusable = false}, SHIFT(311),
  [93] = {.count = 1, .reusable = true}, SHIFT(236),
  [95] = {.count = 1, .reusable = false}, SHIFT(225),
  [97] = {.count = 1, .reusable = false}, SHIFT(226),
  [99] = {.count = 1, .reusable = true}, SHIFT(223),
  [101] = {.count = 1, .reusable = true}, SHIFT(224),
  [103] = {.count = 1, .reusable = true}, SHIFT(260),
  [105] = {.count = 1, .reusable = false}, SHIFT(142),
  [107] = {.count = 1, .reusable = false}, SHIFT(144),
  [109] = {.count = 1, .reusable = false}, SHIFT(169),
  [111] = {.count = 1, .reusable = false}, SHIFT(163),
  [113] = {.count = 1, .reusable = false}, SHIFT(150),
  [115] = {.count = 1, .reusable = false}, SHIFT(123),
  [117] = {.count = 1, .reusable = false}, SHIFT(116),
  [119] = {.count = 1, .reusable = false}, SHIFT(135),
  [121] = {.count = 1, .reusable = false}, SHIFT(136),
  [123] = {.count = 1, .reusable = false}, SHIFT(31),
  [125] = {.count = 1, .reusable = false}, SHIFT(176),
  [127] = {.count = 1, .reusable = false}, SHIFT(302),
  [129] = {.count = 1, .reusable = false}, SHIFT(310),
  [131] = {.count = 1, .reusable = true}, SHIFT(209),
  [133] = {.count = 1, .reusable = false}, SHIFT(125),
  [135] = {.count = 1, .reusable = false}, SHIFT(124),
  [137] = {.count = 1, .reusable = false}, SHIFT(137),
  [139] = {.count = 1, .reusable = false}, SHIFT(138),
  [141] = {.count = 1, .reusable = false}, SHIFT(143),
  [143] = {.count = 1, .reusable = false}, SHIFT(140),
  [145] = {.count = 1, .reusable = false}, SHIFT(117),
  [147] = {.count = 1, .reusable = false}, SHIFT(159),
  [149] = {.count = 1, .reusable = false}, SHIFT(121),
  [151] = {.count = 1, .reusable = false}, SHIFT(21),
  [153] = {.count = 1, .reusable = false}, SHIFT(139),
  [155] = {.count = 1, .reusable = false}, SHIFT(303),
  [157] = {.count = 1, .reusable = false}, SHIFT(312),
  [159] = {.count = 1, .reusable = true}, SHIFT(455),
  [161] = {.count = 1, .reusable = false}, SHIFT(132),
  [163] = {.count = 1, .reusable = false}, SHIFT(155),
  [165] = {.count = 1, .reusable = false}, SHIFT(107),
  [167] = {.count = 1, .reusable = false}, SHIFT(171),
  [169] = {.count = 1, .reusable = false}, SHIFT(120),
  [171] = {.count = 1, .reusable = false}, SHIFT(44),
  [173] = {.count = 1, .reusable = false}, SHIFT(170),
  [175] = {.count = 1, .reusable = false}, SHIFT(304),
  [177] = {.count = 1, .reusable = false}, SHIFT(309),
  [179] = {.count = 1, .reusable = false}, SHIFT(164),
  [181] = {.count = 1, .reusable = false}, SHIFT(161),
  [183] = {.count = 1, .reusable = false}, SHIFT(153),
  [185] = {.count = 1, .reusable = false}, SHIFT(172),
  [187] = {.count = 1, .reusable = false}, SHIFT(231),
  [189] = {.count = 1, .reusable = true}, SHIFT(275),
  [191] = {.count = 1, .reusable = true}, SHIFT(231),
  [193] = {.count = 1, .reusable = false}, SHIFT(278),
  [195] = {.count = 1, .reusable = true}, SHIFT(324),
  [197] = {.count = 1, .reusable = true}, SHIFT(278),
  [199] = {.count = 1, .reusable = true}, SHIFT(317),
  [201] = {.count = 1, .reusable = false}, SHIFT(122),
  [203] = {.count = 1, .reusable = true}, SHIFT(266),
  [205] = {.count = 1, .reusable = true}, SHIFT(122),
  [207] = {.count = 1, .reusable = true}, SHIFT(268),
  [209] = {.count = 1, .reusable = true}, SHIFT(245),
  [211] = {.count = 1, .reusable = true}, SHIFT(325),
  [213] = {.count = 2, .reusable = false}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(231),
  [216] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(4),
  [219] = {.count = 1, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24),
  [221] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(88),
  [224] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(91),
  [227] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(92),
  [230] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(15),
  [233] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(19),
  [236] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(145),
  [239] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(146),
  [242] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(147),
  [245] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(148),
  [248] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(119),
  [251] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(231),
  [254] = {.count = 2, .reusable = false}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(225),
  [257] = {.count = 2, .reusable = false}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(226),
  [260] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(223),
  [263] = {.count = 2, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 2, .production_id = 24), SHIFT_REPEAT(224),
  [266] = {.count = 1, .reusable = true}, SHIFT(184),
  [268] = {.count = 1, .reusable = true}, SHIFT(251),
  [270] = {.count = 1, .reusable = true}, SHIFT(421),
  [272] = {.count = 1, .reusable = true}, SHIFT(422),
  [274] = {.count = 1, .reusable = true}, SHIFT(185),
  [276] = {.count = 1, .reusable = true}, SHIFT(242),
  [278] = {.count = 1, .reusable = true}, SHIFT(192),
  [280] = {.count = 1, .reusable = true}, SHIFT(197),
  [282] = {.count = 1, .reusable = true}, SHIFT(198),
  [284] = {.count = 1, .reusable = true}, SHIFT(332),
  [286] = {.count = 1, .reusable = true}, SHIFT(342),
  [288] = {.count = 1, .reusable = true}, SHIFT(437),
  [290] = {.count = 1, .reusable = true}, SHIFT(409),
  [292] = {.count = 1, .reusable = true}, SHIFT(207),
  [294] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(122),
  [297] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(4),
  [300] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(88),
  [303] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(91),
  [306] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(92),
  [309] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(15),
  [312] = {.count = 1, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10),
  [314] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(19),
  [317] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(145),
  [320] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(146),
  [323] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(147),
  [326] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(148),
  [329] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(119),
  [332] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(122),
  [335] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(225),
  [338] = {.count = 2, .reusable = false}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(226),
  [341] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(223),
  [344] = {.count = 2, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 2, .production_id = 10), SHIFT_REPEAT(224),
  [347] = {.count = 1, .reusable = true}, SHIFT(214),
  [349] = {.count = 1, .reusable = true}, SHIFT(277),
  [351] = {.count = 1, .reusable = true}, SHIFT(215),
  [353] = {.count = 1, .reusable = true}, SHIFT(428),
  [355] = {.count = 1, .reusable = true}, SHIFT(348),
  [357] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(236),
  [360] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(4),
  [363] = {.count = 1, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7),
  [365] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(88),
  [368] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(91),
  [371] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(92),
  [374] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(15),
  [377] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(19),
  [380] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(145),
  [383] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(146),
  [386] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(147),
  [389] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(148),
  [392] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(119),
  [395] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(236),
  [398] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(225),
  [401] = {.count = 2, .reusable = false}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(226),
  [404] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(223),
  [407] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2, .production_id = 7), SHIFT_REPEAT(224),
  [410] = {.count = 1, .reusable = true}, SHIFT(354),
  [412] = {.count = 1, .reusable = true}, SHIFT(355),
  [414] = {.count = 1, .reusable = true}, SHIFT(343),
  [416] = {.count = 1, .reusable = true}, SHIFT(438),
  [418] = {.count = 1, .reusable = true}, SHIFT(240),
  [420] = {.count = 1, .reusable = true}, SHIFT(221),
  [422] = {.count = 1, .reusable = true}, SHIFT(451),
  [424] = {.count = 1, .reusable = true}, SHIFT(450),
  [426] = {.count = 1, .reusable = true}, SHIFT(443),
  [428] = {.count = 1, .reusable = true}, SHIFT(288),
  [430] = {.count = 1, .reusable = true}, SHIFT(287),
  [432] = {.count = 1, .reusable = true}, SHIFT(264),
  [434] = {.count = 1, .reusable = true}, SHIFT(282),
  [436] = {.count = 1, .reusable = false}, SHIFT(403),
  [438] = {.count = 1, .reusable = true}, SHIFT(5),
  [440] = {.count = 1, .reusable = true}, SHIFT(61),
  [442] = {.count = 1, .reusable = true}, SHIFT(60),
  [444] = {.count = 1, .reusable = true}, SHIFT(53),
  [446] = {.count = 1, .reusable = true}, SHIFT(42),
  [448] = {.count = 1, .reusable = true}, SHIFT(43),
  [450] = {.count = 1, .reusable = true}, SHIFT(177),
  [452] = {.count = 1, .reusable = true}, SHIFT(289),
  [454] = {.count = 1, .reusable = true}, SHIFT(403),
  [456] = {.count = 1, .reusable = false}, SHIFT(457),
  [458] = {.count = 1, .reusable = false}, SHIFT(456),
  [460] = {.count = 1, .reusable = true}, SHIFT(290),
  [462] = {.count = 1, .reusable = true}, SHIFT(458),
  [464] = {.count = 1, .reusable = false}, SHIFT(386),
  [466] = {.count = 1, .reusable = true}, SHIFT(386),
  [468] = {.count = 1, .reusable = true}, SHIFT(440),
  [470] = {.count = 1, .reusable = true}, SHIFT(285),
  [472] = {.count = 1, .reusable = true}, SHIFT(452),
  [474] = {.count = 1, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2),
  [476] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(54),
  [479] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(3),
  [482] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(75),
  [485] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(47),
  [488] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(79),
  [491] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(10),
  [494] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(11),
  [497] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(134),
  [500] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(133),
  [503] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(128),
  [506] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(149),
  [509] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(151),
  [512] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(54),
  [515] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(253),
  [518] = {.count = 2, .reusable = false}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(258),
  [521] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(254),
  [524] = {.count = 2, .reusable = true}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(252),
  [527] = {.count = 1, .reusable = false}, SHIFT(469),
  [529] = {.count = 1, .reusable = true}, SHIFT(469),
  [531] = {.count = 1, .reusable = false}, SHIFT(468),
  [533] = {.count = 1, .reusable = true}, SHIFT(468),
  [535] = {.count = 1, .reusable = false}, SHIFT(380),
  [537] = {.count = 1, .reusable = true}, SHIFT(380),
  [539] = {.count = 1, .reusable = false}, SHIFT(365),
  [541] = {.count = 1, .reusable = true}, SHIFT(365),
  [543] = {.count = 1, .reusable = false}, SHIFT(387),
  [545] = {.count = 1, .reusable = true}, SHIFT(387),
  [547] = {.count = 1, .reusable = true}, SHIFT(453),
  [549] = {.count = 1, .reusable = true}, SHIFT(454),
  [551] = {.count = 1, .reusable = false}, SHIFT(464),
  [553] = {.count = 1, .reusable = true}, SHIFT(464),
  [555] = {.count = 1, .reusable = false}, SHIFT(372),
  [557] = {.count = 1, .reusable = true}, SHIFT(372),
  [559] = {.count = 1, .reusable = false}, SHIFT(373),
  [561] = {.count = 1, .reusable = true}, SHIFT(373),
  [563] = {.count = 1, .reusable = true}, SHIFT(358),
  [565] = {.count = 1, .reusable = true}, SHIFT(359),
  [567] = {.count = 1, .reusable = true}, REDUCE(sym_body, 1, .production_id = 5),
  [569] = {.count = 1, .reusable = true}, SHIFT(237),
  [571] = {.count = 1, .reusable = true}, SHIFT(424),
  [573] = {.count = 1, .reusable = true}, SHIFT(439),
  [575] = {.count = 1, .reusable = true}, REDUCE(sym_source_file, 1),
  [577] = {.count = 1, .reusable = false}, SHIFT(54),
  [579] = {.count = 1, .reusable = true}, SHIFT(54),
  [581] = {.count = 1, .reusable = true}, SHIFT(442),
  [583] = {.count = 1, .reusable = false}, SHIFT(390),
  [585] = {.count = 1, .reusable = true}, SHIFT(390),
  [587] = {.count = 1, .reusable = true}, SHIFT(239),
  [589] = {.count = 1, .reusable = true}, SHIFT(263),
  [591] = {.count = 1, .reusable = false}, SHIFT(391),
  [593] = {.count = 1, .reusable = true}, SHIFT(391),
  [595] = {.count = 1, .reusable = true}, SHIFT(429),
  [597] = {.count = 1, .reusable = false}, SHIFT(410),
  [599] = {.count = 1, .reusable = true}, SHIFT(410),
  [601] = {.count = 1, .reusable = true}, SHIFT(265),
  [603] = {.count = 1, .reusable = true}, SHIFT(347),
  [605] = {.count = 1, .reusable = true}, SHIFT(212),
  [607] = {.count = 1, .reusable = false}, SHIFT(402),
  [609] = {.count = 1, .reusable = true}, SHIFT(402),
  [611] = {.count = 1, .reusable = false}, SHIFT(411),
  [613] = {.count = 1, .reusable = true}, SHIFT(411),
  [615] = {.count = 1, .reusable = true}, SHIFT(346),
  [617] = {.count = 1, .reusable = true}, SHIFT(345),
  [619] = {.count = 1, .reusable = true}, SHIFT(327),
  [621] = {.count = 1, .reusable = true}, SHIFT(344),
  [623] = {.count = 1, .reusable = true}, SHIFT(208),
  [625] = {.count = 1, .reusable = true}, SHIFT(206),
  [627] = {.count = 1, .reusable = false}, SHIFT(465),
  [629] = {.count = 1, .reusable = true}, SHIFT(465),
  [631] = {.count = 1, .reusable = true}, SHIFT(182),
  [633] = {.count = 1, .reusable = true}, SHIFT(183),
  [635] = {.count = 1, .reusable = true}, SHIFT(283),
  [637] = {.count = 1, .reusable = true}, SHIFT(441),
  [639] = {.count = 1, .reusable = true}, SHIFT(357),
  [641] = {.count = 1, .reusable = true}, SHIFT(284),
  [643] = {.count = 1, .reusable = true}, SHIFT(333),
  [645] = {.count = 1, .reusable = true}, SHIFT(193),
  [647] = {.count = 1, .reusable = true}, SHIFT(256),
  [649] = {.count = 1, .reusable = true}, SHIFT(194),
  [651] = {.count = 1, .reusable = true}, SHIFT(257),
  [653] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(278),
  [656] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(4),
  [659] = {.count = 1, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14),
  [661] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(88),
  [664] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(91),
  [667] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(92),
  [670] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(15),
  [673] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(19),
  [676] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(145),
  [679] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(146),
  [682] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(147),
  [685] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(148),
  [688] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(119),
  [691] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(278),
  [694] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(225),
  [697] = {.count = 2, .reusable = false}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(226),
  [700] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(223),
  [703] = {.count = 2, .reusable = true}, REDUCE(aux_sym_while_repeat1, 2, .production_id = 14), SHIFT_REPEAT(224),
  [706] = {.count = 1, .reusable = true}, SHIFT(195),
  [708] = {.count = 1, .reusable = true}, SHIFT(274),
  [710] = {.count = 1, .reusable = true}, SHIFT(196),
  [712] = {.count = 1, .reusable = false}, SHIFT(385),
  [714] = {.count = 1, .reusable = true}, SHIFT(6),
  [716] = {.count = 1, .reusable = true}, SHIFT(211),
  [718] = {.count = 1, .reusable = true}, SHIFT(173),
  [720] = {.count = 1, .reusable = true}, SHIFT(174),
  [722] = {.count = 1, .reusable = true}, SHIFT(175),
  [724] = {.count = 1, .reusable = true}, SHIFT(141),
  [726] = {.count = 1, .reusable = true}, SHIFT(385),
  [728] = {.count = 1, .reusable = true}, SHIFT(406),
  [730] = {.count = 1, .reusable = false}, SHIFT(368),
  [732] = {.count = 1, .reusable = true}, SHIFT(444),
  [734] = {.count = 1, .reusable = true}, SHIFT(368),
  [736] = {.count = 1, .reusable = false}, SHIFT(463),
  [738] = {.count = 1, .reusable = true}, SHIFT(269),
  [740] = {.count = 1, .reusable = true}, SHIFT(463),
  [742] = {.count = 1, .reusable = false}, SHIFT(412),
  [744] = {.count = 1, .reusable = true}, SHIFT(328),
  [746] = {.count = 1, .reusable = true}, SHIFT(412),
  [748] = {.count = 1, .reusable = false}, SHIFT(467),
  [750] = {.count = 1, .reusable = true}, SHIFT(281),
  [752] = {.count = 1, .reusable = true}, SHIFT(467),
  [754] = {.count = 1, .reusable = false}, SHIFT(374),
  [756] = {.count = 1, .reusable = true}, SHIFT(425),
  [758] = {.count = 1, .reusable = true}, SHIFT(374),
  [760] = {.count = 1, .reusable = false}, SHIFT(404),
  [762] = {.count = 1, .reusable = true}, SHIFT(335),
  [764] = {.count = 1, .reusable = true}, SHIFT(404),
  [766] = {.count = 1, .reusable = false}, SHIFT(389),
  [768] = {.count = 1, .reusable = true}, SHIFT(204),
  [770] = {.count = 1, .reusable = true}, SHIFT(389),
  [772] = {.count = 1, .reusable = false}, SHIFT(397),
  [774] = {.count = 1, .reusable = true}, SHIFT(349),
  [776] = {.count = 1, .reusable = true}, SHIFT(397),
  [778] = {.count = 1, .reusable = false}, SHIFT(366),
  [780] = {.count = 1, .reusable = true}, SHIFT(431),
  [782] = {.count = 1, .reusable = true}, SHIFT(366),
  [784] = {.count = 1, .reusable = false}, SHIFT(471),
  [786] = {.count = 1, .reusable = true}, SHIFT(276),
  [788] = {.count = 1, .reusable = true}, SHIFT(471),
  [790] = {.count = 1, .reusable = false}, SHIFT(398),
  [792] = {.count = 1, .reusable = true}, SHIFT(191),
  [794] = {.count = 1, .reusable = true}, SHIFT(398),
  [796] = {.count = 1, .reusable = false}, SHIFT(394),
  [798] = {.count = 1, .reusable = true}, SHIFT(394),
  [800] = {.count = 1, .reusable = false}, SHIFT(190),
  [802] = {.count = 1, .reusable = true}, SHIFT(190),
  [804] = {.count = 1, .reusable = false}, SHIFT(166),
  [806] = {.count = 1, .reusable = true}, SHIFT(166),
  [808] = {.count = 1, .reusable = false}, SHIFT(152),
  [810] = {.count = 1, .reusable = true}, SHIFT(152),
  [812] = {.count = 1, .reusable = false}, SHIFT(286),
  [814] = {.count = 1, .reusable = true}, SHIFT(286),
  [816] = {.count = 1, .reusable = false}, SHIFT(472),
  [818] = {.count = 1, .reusable = true}, SHIFT(472),
  [820] = {.count = 1, .reusable = false}, SHIFT(73),
  [822] = {.count = 1, .reusable = true}, SHIFT(73),
  [824] = {.count = 1, .reusable = false}, SHIFT(76),
  [826] = {.count = 1, .reusable = true}, SHIFT(76),
  [828] = {.count = 1, .reusable = false}, SHIFT(350),
  [830] = {.count = 1, .reusable = true}, SHIFT(2),
  [832] = {.count = 1, .reusable = true}, SHIFT(66),
  [834] = {.count = 1, .reusable = true}, SHIFT(65),
  [836] = {.count = 1, .reusable = true}, SHIFT(95),
  [838] = {.count = 1, .reusable = true}, SHIFT(37),
  [840] = {.count = 1, .reusable = true}, SHIFT(36),
  [842] = {.count = 1, .reusable = true}, SHIFT(131),
  [844] = {.count = 1, .reusable = true}, SHIFT(130),
  [846] = {.count = 1, .reusable = true}, SHIFT(129),
  [848] = {.count = 1, .reusable = true}, SHIFT(127),
  [850] = {.count = 1, .reusable = true}, SHIFT(126),
  [852] = {.count = 1, .reusable = true}, SHIFT(350),
  [854] = {.count = 1, .reusable = false}, SHIFT(338),
  [856] = {.count = 1, .reusable = false}, SHIFT(361),
  [858] = {.count = 1, .reusable = true}, SHIFT(315),
  [860] = {.count = 1, .reusable = true}, SHIFT(318),
  [862] = {.count = 1, .reusable = false}, SHIFT(313),
  [864] = {.count = 1, .reusable = true}, SHIFT(313),
  [866] = {.count = 1, .reusable = false}, SHIFT(272),
  [868] = {.count = 1, .reusable = true}, SHIFT(272),
  [870] = {.count = 1, .reusable = false}, SHIFT(351),
  [872] = {.count = 1, .reusable = true}, SHIFT(351),
  [874] = {.count = 1, .reusable = false}, SHIFT(352),
  [876] = {.count = 1, .reusable = true}, SHIFT(352),
  [878] = {.count = 1, .reusable = false}, SHIFT(353),
  [880] = {.count = 1, .reusable = true}, SHIFT(353),
  [882] = {.count = 1, .reusable = false}, SHIFT(57),
  [884] = {.count = 1, .reusable = true}, SHIFT(57),
  [886] = {.count = 1, .reusable = false}, SHIFT(271),
  [888] = {.count = 1, .reusable = true}, SHIFT(271),
  [890] = {.count = 1, .reusable = false}, SHIFT(270),
  [892] = {.count = 1, .reusable = true}, SHIFT(270),
  [894] = {.count = 1, .reusable = false}, SHIFT(110),
  [896] = {.count = 1, .reusable = true}, SHIFT(110),
  [898] = {.count = 1, .reusable = false}, SHIFT(162),
  [900] = {.count = 1, .reusable = true}, SHIFT(162),
  [902] = {.count = 1, .reusable = false}, SHIFT(381),
  [904] = {.count = 1, .reusable = true}, SHIFT(381),
  [906] = {.count = 1, .reusable = false}, SHIFT(405),
  [908] = {.count = 1, .reusable = true}, SHIFT(405),
  [910] = {.count = 1, .reusable = false}, SHIFT(89),
  [912] = {.count = 1, .reusable = true}, SHIFT(89),
  [914] = {.count = 1, .reusable = false}, SHIFT(400),
  [916] = {.count = 1, .reusable = true}, SHIFT(400),
  [918] = {.count = 1, .reusable = false}, SHIFT(446),
  [920] = {.count = 1, .reusable = true}, SHIFT(446),
  [922] = {.count = 1, .reusable = false}, SHIFT(55),
  [924] = {.count = 1, .reusable = true}, SHIFT(55),
  [926] = {.count = 1, .reusable = false}, SHIFT(401),
  [928] = {.count = 1, .reusable = true}, SHIFT(401),
  [930] = {.count = 1, .reusable = false}, SHIFT(56),
  [932] = {.count = 1, .reusable = true}, SHIFT(56),
  [934] = {.count = 1, .reusable = false}, SHIFT(186),
  [936] = {.count = 1, .reusable = true}, SHIFT(186),
  [938] = {.count = 1, .reusable = false}, SHIFT(187),
  [940] = {.count = 1, .reusable = true}, SHIFT(187),
  [942] = {.count = 1, .reusable = false}, SHIFT(188),
  [944] = {.count = 1, .reusable = true}, SHIFT(188),
  [946] = {.count = 1, .reusable = false}, SHIFT(189),
  [948] = {.count = 1, .reusable = true}, SHIFT(189),
  [950] = {.count = 1, .reusable = false}, SHIFT(273),
  [952] = {.count = 1, .reusable = true}, SHIFT(273),
  [954] = {.count = 1, .reusable = false}, SHIFT(473),
  [956] = {.count = 1, .reusable = true}, SHIFT(473),
  [958] = {.count = 1, .reusable = false}, SHIFT(238),
  [960] = {.count = 1, .reusable = true}, SHIFT(238),
  [962] = {.count = 1, .reusable = false}, SHIFT(106),
  [964] = {.count = 1, .reusable = true}, SHIFT(106),
  [966] = {.count = 1, .reusable = false}, SHIFT(379),
  [968] = {.count = 1, .reusable = true}, SHIFT(379),
  [970] = {.count = 1, .reusable = false}, SHIFT(97),
  [972] = {.count = 1, .reusable = true}, SHIFT(97),
  [974] = {.count = 1, .reusable = false}, SHIFT(58),
  [976] = {.count = 1, .reusable = true}, SHIFT(58),
  [978] = {.count = 1, .reusable = false}, SHIFT(112),
  [980] = {.count = 1, .reusable = true}, SHIFT(112),
  [982] = {.count = 1, .reusable = false}, SHIFT(396),
  [984] = {.count = 1, .reusable = true}, SHIFT(396),
  [986] = {.count = 1, .reusable = false}, SHIFT(395),
  [988] = {.count = 1, .reusable = true}, SHIFT(395),
  [990] = {.count = 1, .reusable = false}, SHIFT(113),
  [992] = {.count = 1, .reusable = true}, SHIFT(113),
  [994] = {.count = 1, .reusable = false}, SHIFT(393),
  [996] = {.count = 1, .reusable = true}, SHIFT(393),
  [998] = {.count = 1, .reusable = false}, SHIFT(377),
  [1000] = {.count = 1, .reusable = true}, SHIFT(377),
  [1002] = {.count = 1, .reusable = false}, SHIFT(108),
  [1004] = {.count = 1, .reusable = true}, SHIFT(108),
  [1006] = {.count = 1, .reusable = false}, SHIFT(474),
  [1008] = {.count = 1, .reusable = true}, SHIFT(474),
  [1010] = {.count = 1, .reusable = false}, SHIFT(370),
  [1012] = {.count = 1, .reusable = true}, SHIFT(370),
  [1014] = {.count = 1, .reusable = false}, SHIFT(82),
  [1016] = {.count = 1, .reusable = true}, SHIFT(82),
  [1018] = {.count = 1, .reusable = false}, SHIFT(111),
  [1020] = {.count = 1, .reusable = true}, SHIFT(111),
  [1022] = {.count = 1, .reusable = false}, SHIFT(49),
  [1024] = {.count = 1, .reusable = true}, SHIFT(49),
  [1026] = {.count = 1, .reusable = false}, SHIFT(178),
  [1028] = {.count = 1, .reusable = true}, SHIFT(178),
  [1030] = {.count = 1, .reusable = false}, SHIFT(475),
  [1032] = {.count = 1, .reusable = true}, SHIFT(475),
  [1034] = {.count = 1, .reusable = false}, SHIFT(77),
  [1036] = {.count = 1, .reusable = true}, SHIFT(77),
  [1038] = {.count = 1, .reusable = false}, SHIFT(115),
  [1040] = {.count = 1, .reusable = true}, SHIFT(115),
  [1042] = {.count = 1, .reusable = false}, SHIFT(367),
  [1044] = {.count = 1, .reusable = true}, SHIFT(367),
  [1046] = {.count = 1, .reusable = false}, SHIFT(449),
  [1048] = {.count = 1, .reusable = true}, SHIFT(449),
  [1050] = {.count = 1, .reusable = false}, SHIFT(448),
  [1052] = {.count = 1, .reusable = true}, SHIFT(448),
  [1054] = {.count = 1, .reusable = false}, SHIFT(447),
  [1056] = {.count = 1, .reusable = true}, SHIFT(447),
  [1058] = {.count = 1, .reusable = false}, SHIFT(68),
  [1060] = {.count = 1, .reusable = true}, SHIFT(68),
  [1062] = {.count = 1, .reusable = false}, SHIFT(445),
  [1064] = {.count = 1, .reusable = true}, SHIFT(445),
  [1066] = {.count = 1, .reusable = false}, SHIFT(109),
  [1068] = {.count = 1, .reusable = true}, SHIFT(109),
  [1070] = {.count = 1, .reusable = false}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19),
  [1072] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(363),
  [1075] = {.count = 1, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19),
  [1077] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(145),
  [1080] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(146),
  [1083] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(147),
  [1086] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(148),
  [1089] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(299),
  [1092] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(223),
  [1095] = {.count = 1, .reusable = false}, REDUCE(sym_def, 5, .production_id = 18),
  [1097] = {.count = 1, .reusable = true}, REDUCE(sym_def, 5, .production_id = 18),
  [1099] = {.count = 1, .reusable = false}, REDUCE(sym_var, 5, .production_id = 18),
  [1101] = {.count = 1, .reusable = true}, REDUCE(sym_var, 5, .production_id = 18),
  [1103] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [1105] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [1107] = {.count = 1, .reusable = false}, REDUCE(sym_sqr_array, 2),
  [1109] = {.count = 1, .reusable = true}, REDUCE(sym_sqr_array, 2),
  [1111] = {.count = 1, .reusable = false}, REDUCE(sym_struct, 2),
  [1113] = {.count = 1, .reusable = true}, REDUCE(sym_struct, 2),
  [1115] = {.count = 1, .reusable = false}, REDUCE(sym_table, 2),
  [1117] = {.count = 1, .reusable = true}, REDUCE(sym_table, 2),
  [1119] = {.count = 1, .reusable = false}, REDUCE(sym_short_quote, 2),
  [1121] = {.count = 1, .reusable = true}, REDUCE(sym_short_quote, 2),
  [1123] = {.count = 1, .reusable = false}, REDUCE(sym_short_splice, 2),
  [1125] = {.count = 1, .reusable = true}, REDUCE(sym_short_splice, 2),
  [1127] = {.count = 1, .reusable = false}, REDUCE(sym_short_quasiquote, 2),
  [1129] = {.count = 1, .reusable = true}, REDUCE(sym_short_quasiquote, 2),
  [1131] = {.count = 1, .reusable = false}, REDUCE(sym_short_unquote, 2),
  [1133] = {.count = 1, .reusable = true}, REDUCE(sym_short_unquote, 2),
  [1135] = {.count = 1, .reusable = false}, REDUCE(sym_short_fn, 2, .production_id = 3),
  [1137] = {.count = 1, .reusable = true}, REDUCE(sym_short_fn, 2, .production_id = 3),
  [1139] = {.count = 1, .reusable = false}, REDUCE(sym_break, 3),
  [1141] = {.count = 1, .reusable = true}, REDUCE(sym_break, 3),
  [1143] = {.count = 1, .reusable = false}, REDUCE(sym_do, 3),
  [1145] = {.count = 1, .reusable = true}, REDUCE(sym_do, 3),
  [1147] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 3, .production_id = 6),
  [1149] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 3, .production_id = 6),
  [1151] = {.count = 1, .reusable = false}, REDUCE(sym_sqr_tuple, 3, .production_id = 6),
  [1153] = {.count = 1, .reusable = true}, REDUCE(sym_sqr_tuple, 3, .production_id = 6),
  [1155] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3, .production_id = 6),
  [1157] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3, .production_id = 6),
  [1159] = {.count = 1, .reusable = false}, REDUCE(sym_sqr_array, 3, .production_id = 6),
  [1161] = {.count = 1, .reusable = true}, REDUCE(sym_sqr_array, 3, .production_id = 6),
  [1163] = {.count = 1, .reusable = false}, REDUCE(sym_struct, 3, .production_id = 9),
  [1165] = {.count = 1, .reusable = true}, REDUCE(sym_struct, 3, .production_id = 9),
  [1167] = {.count = 1, .reusable = false}, REDUCE(sym_table, 3, .production_id = 9),
  [1169] = {.count = 1, .reusable = true}, REDUCE(sym_table, 3, .production_id = 9),
  [1171] = {.count = 1, .reusable = false}, REDUCE(sym_quote, 4),
  [1173] = {.count = 1, .reusable = true}, REDUCE(sym_quote, 4),
  [1175] = {.count = 1, .reusable = false}, REDUCE(sym_splice, 4),
  [1177] = {.count = 1, .reusable = true}, REDUCE(sym_splice, 4),
  [1179] = {.count = 1, .reusable = false}, REDUCE(sym_quasiquote, 4),
  [1181] = {.count = 1, .reusable = true}, REDUCE(sym_quasiquote, 4),
  [1183] = {.count = 1, .reusable = false}, REDUCE(sym_unquote, 4),
  [1185] = {.count = 1, .reusable = true}, REDUCE(sym_unquote, 4),
  [1187] = {.count = 1, .reusable = false}, REDUCE(sym_break, 4),
  [1189] = {.count = 1, .reusable = true}, REDUCE(sym_break, 4),
  [1191] = {.count = 1, .reusable = false}, REDUCE(sym_set, 4, .production_id = 12),
  [1193] = {.count = 1, .reusable = true}, REDUCE(sym_set, 4, .production_id = 12),
  [1195] = {.count = 1, .reusable = false}, REDUCE(sym_do, 4, .production_id = 13),
  [1197] = {.count = 1, .reusable = true}, REDUCE(sym_do, 4, .production_id = 13),
  [1199] = {.count = 1, .reusable = false}, REDUCE(sym_while, 4, .production_id = 15),
  [1201] = {.count = 1, .reusable = true}, REDUCE(sym_while, 4, .production_id = 15),
  [1203] = {.count = 1, .reusable = false}, REDUCE(sym_fn, 4, .production_id = 17),
  [1205] = {.count = 1, .reusable = true}, REDUCE(sym_fn, 4, .production_id = 17),
  [1207] = {.count = 1, .reusable = false}, REDUCE(sym_sqr_tuple, 2),
  [1209] = {.count = 1, .reusable = true}, REDUCE(sym_sqr_tuple, 2),
  [1211] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 2),
  [1213] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 2),
  [1215] = {.count = 1, .reusable = false}, REDUCE(sym_set, 5, .production_id = 20),
  [1217] = {.count = 1, .reusable = true}, REDUCE(sym_set, 5, .production_id = 20),
  [1219] = {.count = 1, .reusable = false}, REDUCE(sym_if, 5, .production_id = 21),
  [1221] = {.count = 1, .reusable = true}, REDUCE(sym_if, 5, .production_id = 21),
  [1223] = {.count = 1, .reusable = false}, REDUCE(sym_while, 5, .production_id = 22),
  [1225] = {.count = 1, .reusable = true}, REDUCE(sym_while, 5, .production_id = 22),
  [1227] = {.count = 1, .reusable = false}, REDUCE(sym_fn, 5, .production_id = 25),
  [1229] = {.count = 1, .reusable = true}, REDUCE(sym_fn, 5, .production_id = 25),
  [1231] = {.count = 1, .reusable = false}, REDUCE(sym_fn, 5, .production_id = 26),
  [1233] = {.count = 1, .reusable = true}, REDUCE(sym_fn, 5, .production_id = 26),
  [1235] = {.count = 1, .reusable = false}, REDUCE(sym_extra_defs, 5, .production_id = 26),
  [1237] = {.count = 1, .reusable = true}, REDUCE(sym_extra_defs, 5, .production_id = 26),
  [1239] = {.count = 1, .reusable = false}, REDUCE(sym_def, 6, .production_id = 27),
  [1241] = {.count = 1, .reusable = true}, REDUCE(sym_def, 6, .production_id = 27),
  [1243] = {.count = 1, .reusable = false}, REDUCE(sym_var, 6, .production_id = 27),
  [1245] = {.count = 1, .reusable = true}, REDUCE(sym_var, 6, .production_id = 27),
  [1247] = {.count = 1, .reusable = false}, REDUCE(sym_if, 6, .production_id = 28),
  [1249] = {.count = 1, .reusable = true}, REDUCE(sym_if, 6, .production_id = 28),
  [1251] = {.count = 1, .reusable = false}, REDUCE(sym_fn, 6, .production_id = 29),
  [1253] = {.count = 1, .reusable = true}, REDUCE(sym_fn, 6, .production_id = 29),
  [1255] = {.count = 1, .reusable = false}, REDUCE(sym_extra_defs, 6, .production_id = 29),
  [1257] = {.count = 1, .reusable = true}, REDUCE(sym_extra_defs, 6, .production_id = 29),
  [1259] = {.count = 1, .reusable = false}, REDUCE(sym_extra_defs, 6, .production_id = 30),
  [1261] = {.count = 1, .reusable = true}, REDUCE(sym_extra_defs, 6, .production_id = 30),
  [1263] = {.count = 1, .reusable = false}, REDUCE(sym_extra_defs, 7, .production_id = 31),
  [1265] = {.count = 1, .reusable = true}, REDUCE(sym_extra_defs, 7, .production_id = 31),
  [1267] = {.count = 1, .reusable = false}, REDUCE(sym_long_str_literal, 1),
  [1269] = {.count = 1, .reusable = true}, REDUCE(sym_long_str_literal, 1),
  [1271] = {.count = 1, .reusable = false}, REDUCE(sym_long_buffer_literal, 1),
  [1273] = {.count = 1, .reusable = true}, REDUCE(sym_long_buffer_literal, 1),
  [1275] = {.count = 1, .reusable = false}, REDUCE(sym_number_literal, 1),
  [1277] = {.count = 1, .reusable = true}, REDUCE(sym_number_literal, 1),
  [1279] = {.count = 1, .reusable = false}, REDUCE(sym_bool_literal, 1),
  [1281] = {.count = 1, .reusable = true}, REDUCE(sym_bool_literal, 1),
  [1283] = {.count = 1, .reusable = false}, SHIFT(12),
  [1285] = {.count = 1, .reusable = true}, SHIFT(7),
  [1287] = {.count = 1, .reusable = true}, SHIFT(74),
  [1289] = {.count = 1, .reusable = true}, SHIFT(339),
  [1291] = {.count = 1, .reusable = true}, SHIFT(243),
  [1293] = {.count = 1, .reusable = false}, SHIFT(8),
  [1295] = {.count = 1, .reusable = false}, SHIFT(27),
  [1297] = {.count = 1, .reusable = false}, SHIFT(17),
  [1299] = {.count = 1, .reusable = false}, REDUCE(aux_sym_parameters_repeat1, 1, .production_id = 16),
  [1301] = {.count = 1, .reusable = true}, REDUCE(aux_sym_parameters_repeat1, 1, .production_id = 16),
  [1303] = {.count = 1, .reusable = false}, SHIFT(9),
  [1305] = {.count = 1, .reusable = false}, SHIFT(41),
  [1307] = {.count = 1, .reusable = false}, SHIFT(32),
  [1309] = {.count = 1, .reusable = false}, SHIFT(16),
  [1311] = {.count = 1, .reusable = false}, REDUCE(aux_sym_tuple_repeat1, 1, .production_id = 1),
  [1313] = {.count = 1, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 1, .production_id = 1),
  [1315] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 2),
  [1317] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 2),
  [1319] = {.count = 1, .reusable = false}, REDUCE(sym_metadata, 1),
  [1321] = {.count = 1, .reusable = true}, REDUCE(sym_metadata, 1),
  [1323] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1),
  [1325] = {.count = 1, .reusable = false}, REDUCE(sym__parameters, 1),
  [1327] = {.count = 1, .reusable = true}, REDUCE(sym__identifier, 1),
  [1329] = {.count = 1, .reusable = false}, REDUCE(sym__identifier, 1),
  [1331] = {.count = 1, .reusable = false}, REDUCE(sym_parameters, 3, .production_id = 23),
  [1333] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 3, .production_id = 23),
  [1335] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_parameters, 3, .production_id = 23),
  [1337] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_parameters, 3, .production_id = 23),
  [1339] = {.count = 1, .reusable = false}, REDUCE(aux_sym_struct_repeat1, 1, .production_id = 2),
  [1341] = {.count = 1, .reusable = true}, REDUCE(aux_sym_struct_repeat1, 1, .production_id = 2),
  [1343] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_parameters, 2),
  [1345] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_parameters, 2),
  [1347] = {.count = 1, .reusable = false}, REDUCE(aux_sym_while_repeat1, 1, .production_id = 4),
  [1349] = {.count = 1, .reusable = true}, REDUCE(aux_sym_while_repeat1, 1, .production_id = 4),
  [1351] = {.count = 1, .reusable = false}, REDUCE(sym__name, 1),
  [1353] = {.count = 1, .reusable = true}, REDUCE(sym__name, 1),
  [1355] = {.count = 1, .reusable = false}, REDUCE(sym__struct_tables_commom, 2, .production_id = 8),
  [1357] = {.count = 1, .reusable = true}, REDUCE(sym__struct_tables_commom, 2, .production_id = 8),
  [1359] = {.count = 1, .reusable = true}, REDUCE(sym__literals, 1),
  [1361] = {.count = 1, .reusable = true}, REDUCE(sym__special_forms, 1),
  [1363] = {.count = 1, .reusable = true}, REDUCE(sym__shorthand, 1),
  [1365] = {.count = 1, .reusable = false}, REDUCE(aux_sym_def_repeat1, 1, .production_id = 11),
  [1367] = {.count = 1, .reusable = true}, REDUCE(aux_sym_def_repeat1, 1, .production_id = 11),
  [1369] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(362),
  [1372] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(131),
  [1375] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(130),
  [1378] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(129),
  [1381] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(127),
  [1384] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(339),
  [1387] = {.count = 2, .reusable = true}, REDUCE(aux_sym_def_repeat1, 2, .production_id = 19), SHIFT_REPEAT(315),
  [1390] = {.count = 1, .reusable = false}, SHIFT(279),
  [1392] = {.count = 1, .reusable = true}, SHIFT(279),
  [1394] = {.count = 1, .reusable = false}, SHIFT(20),
  [1396] = {.count = 1, .reusable = true}, SHIFT(20),
  [1398] = {.count = 1, .reusable = false}, SHIFT(13),
  [1400] = {.count = 1, .reusable = true}, SHIFT(13),
  [1402] = {.count = 1, .reusable = false}, SHIFT(30),
  [1404] = {.count = 1, .reusable = true}, SHIFT(30),
  [1406] = {.count = 1, .reusable = false}, SHIFT(18),
  [1408] = {.count = 1, .reusable = true}, SHIFT(18),
  [1410] = {.count = 1, .reusable = false}, SHIFT(230),
  [1412] = {.count = 1, .reusable = true}, SHIFT(362),
  [1414] = {.count = 1, .reusable = true}, SHIFT(230),
  [1416] = {.count = 1, .reusable = false}, SHIFT(235),
  [1418] = {.count = 1, .reusable = true}, SHIFT(235),
  [1420] = {.count = 1, .reusable = false}, SHIFT(228),
  [1422] = {.count = 1, .reusable = true}, SHIFT(228),
  [1424] = {.count = 1, .reusable = false}, SHIFT(234),
  [1426] = {.count = 1, .reusable = true}, SHIFT(234),
  [1428] = {.count = 1, .reusable = true}, SHIFT(160),
  [1430] = {.count = 1, .reusable = true}, SHIFT(118),
  [1432] = {.count = 1, .reusable = true}, SHIFT(158),
  [1434] = {.count = 1, .reusable = true}, SHIFT(157),
  [1436] = {.count = 1, .reusable = true}, SHIFT(137),
  [1438] = {.count = 1, .reusable = true}, SHIFT(138),
  [1440] = {.count = 1, .reusable = true}, SHIFT(143),
  [1442] = {.count = 1, .reusable = true}, SHIFT(140),
  [1444] = {.count = 1, .reusable = true}, SHIFT(426),
  [1446] = {.count = 1, .reusable = true}, SHIFT(364),
  [1448] = {.count = 1, .reusable = true}, SHIFT(433),
  [1450] = {.count = 1, .reusable = true}, SHIFT(432),
  [1452] = {.count = 1, .reusable = true}, SHIFT(423),
  [1454] = {.count = 1, .reusable = true}, SHIFT(436),
  [1456] = {.count = 1, .reusable = true}, SHIFT(430),
  [1458] = {.count = 1, .reusable = true}, SHIFT(420),
  [1460] = {.count = 1, .reusable = true}, SHIFT(419),
  [1462] = {.count = 1, .reusable = true}, SHIFT(418),
  [1464] = {.count = 1, .reusable = true}, SHIFT(417),
  [1466] = {.count = 1, .reusable = true}, SHIFT(415),
  [1468] = {.count = 1, .reusable = true}, SHIFT(435),
  [1470] = {.count = 1, .reusable = true}, SHIFT(408),
  [1472] = {.count = 1, .reusable = true}, SHIFT(434),
  [1474] = {.count = 1, .reusable = true}, SHIFT(427),
  [1476] = {.count = 1, .reusable = true}, SHIFT(199),
  [1478] = {.count = 1, .reusable = true}, SHIFT(222),
  [1480] = {.count = 1, .reusable = true}, SHIFT(220),
  [1482] = {.count = 1, .reusable = true}, SHIFT(219),
  [1484] = {.count = 1, .reusable = true}, SHIFT(218),
  [1486] = {.count = 1, .reusable = true}, SHIFT(217),
  [1488] = {.count = 1, .reusable = true}, SHIFT(216),
  [1490] = {.count = 1, .reusable = true}, SHIFT(213),
  [1492] = {.count = 1, .reusable = true}, SHIFT(210),
  [1494] = {.count = 1, .reusable = true}, SHIFT(181),
  [1496] = {.count = 1, .reusable = true}, SHIFT(180),
  [1498] = {.count = 1, .reusable = true}, SHIFT(205),
  [1500] = {.count = 1, .reusable = true}, SHIFT(341),
  [1502] = {.count = 1, .reusable = true}, SHIFT(340),
  [1504] = {.count = 1, .reusable = true}, SHIFT(314),
  [1506] = {.count = 1, .reusable = true}, SHIFT(337),
  [1508] = {.count = 1, .reusable = true}, SHIFT(336),
  [1510] = {.count = 1, .reusable = true}, SHIFT(203),
  [1512] = {.count = 1, .reusable = true}, SHIFT(334),
  [1514] = {.count = 1, .reusable = true}, SHIFT(202),
  [1516] = {.count = 1, .reusable = true}, SHIFT(201),
  [1518] = {.count = 1, .reusable = true}, SHIFT(331),
  [1520] = {.count = 1, .reusable = true}, SHIFT(330),
  [1522] = {.count = 1, .reusable = true}, SHIFT(329),
  [1524] = {.count = 1, .reusable = true}, SHIFT(200),
  [1526] = {.count = 1, .reusable = true}, SHIFT(326),
  [1528] = {.count = 1, .reusable = true}, SHIFT(323),
  [1530] = {.count = 1, .reusable = true}, SHIFT(322),
  [1532] = {.count = 1, .reusable = true}, SHIFT(321),
  [1534] = {.count = 1, .reusable = true}, SHIFT(320),
  [1536] = {.count = 1, .reusable = true}, SHIFT(319),
  [1538] = {.count = 1, .reusable = true}, SHIFT(316),
  [1540] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [1542] = {.count = 1, .reusable = true}, SHIFT(244),
  [1544] = {.count = 1, .reusable = true}, SHIFT(246),
  [1546] = {.count = 1, .reusable = true}, SHIFT(247),
  [1548] = {.count = 1, .reusable = true}, SHIFT(248),
  [1550] = {.count = 1, .reusable = true}, SHIFT(249),
  [1552] = {.count = 1, .reusable = true}, SHIFT(250),
  [1554] = {.count = 1, .reusable = true}, SHIFT(255),
  [1556] = {.count = 1, .reusable = true}, SHIFT(262),
  [1558] = {.count = 1, .reusable = true}, SHIFT(261),
  [1560] = {.count = 1, .reusable = true}, SHIFT(259),
  [1562] = {.count = 1, .reusable = true}, SHIFT(280),
  [1564] = {.count = 1, .reusable = true}, SHIFT(293),
  [1566] = {.count = 1, .reusable = true}, SHIFT(297),
  [1568] = {.count = 1, .reusable = true}, SHIFT(296),
  [1570] = {.count = 1, .reusable = true}, SHIFT(295),
  [1572] = {.count = 1, .reusable = true}, SHIFT(294),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_janet_external_scanner_create(void);
void tree_sitter_janet_external_scanner_destroy(void *);
bool tree_sitter_janet_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_janet_external_scanner_serialize(void *, char *);
void tree_sitter_janet_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_janet(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_symbol,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_janet_external_scanner_create,
      tree_sitter_janet_external_scanner_destroy,
      tree_sitter_janet_external_scanner_scan,
      tree_sitter_janet_external_scanner_serialize,
      tree_sitter_janet_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
